///////////////////////////////////////////////////////////////////////////////
// PjPoly_IP Interface class
//
// Author: Humberto Jos Bortolossi (http://www.professores.uff.br/hjbortol/)
//
// Creative Commons License: http://creativecommons.org/licenses/by-nc-sa/2.5/
//
// Date: 12/09/2010
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Native JAVA imports
///////////////////////////////////////////////////////////////////////////////
import java.awt.Checkbox;
import java.awt.Choice;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

///////////////////////////////////////////////////////////////////////////////
// JavaView imports
///////////////////////////////////////////////////////////////////////////////
import jv.geom.PgElementSet;
import jv.object.PsPanel;
import jv.objectGui.PsTabPanel;
import jv.object.PsUpdateIf;
import jv.project.PjProject_IP;
import jvx.geom.PwClip;
import jvx.geom.PwModel;
import jvx.geom.PwUnfold;


///////////////////////////////////////////////////////////////////////////////
// Info panel for graph tomography applet.
///////////////////////////////////////////////////////////////////////////////
public class PjPoly_IP extends PjProject_IP implements ActionListener, ItemListener
{
   protected PjPoly m_pjPoly;

   protected Choice poly_category;
   protected Choice poly_name;

   protected Panel m_aPanel; // Transparency panel
   protected Checkbox viewElementsCB;
   protected Checkbox viewEdgesCB;
   protected Checkbox viewVerticesCB;
   protected Checkbox viewPseudodualCB;
   protected Checkbox viewDualCB;

   protected Checkbox enableCutPlaneCB;
   protected Checkbox viewCutPlaneCB;
   protected Checkbox viewNormalVectorCB;   
   protected Checkbox posPartCB;
   protected Checkbox negPartCB;
   protected Panel m_tPanel;
   protected Panel m_latPanel;
   protected Panel m_lonPanel;

   protected Checkbox enableUnfoldCB;
   protected Panel m_uPanel;

   protected Checkbox enableModelCB;
   protected Checkbox trnModelCB; // Truncate
   protected Checkbox trfModelCB; // Truncate and fill
   protected Checkbox pncModelCB; // Punch
   protected Checkbox stlModelCB; // Stellate
   protected Panel m_mPanel;

   protected PsTabPanel tabPanel;
   protected PsTabPanel cutPanel;
   protected PsTabPanel ufdPanel;
   protected PsTabPanel modPanel;

   protected int idiom = 0;
/*   
   protected String[] title_trans = {"Uma Pletora de Poliedros",
                                     "A Plethora of Polyhedra"};

   protected String[] vis_transparency_trans = {"Transparncia:",
		                                        "Transparency:"};
   protected String[] vis_vertices_trans = {"Exibir vrtices",
                                            "Show vertices"};
   protected String[] vis_edges_trans = {"Exibir arestas", "Show edges"};
   protected String[] vis_elements_trans = {"Exibir faces", "Show faces"};
   protected String[] vis_pseudodual_trans = {"Exibir dual topolgico", "Show topological dual"};
   protected String[] vis_dual_trans = {"Exibir dual", "Show dual"};   

   protected String[] vis_panel_trans = {"Exibir", "Visualize"};

   protected String[] cut_enable_trans = {"Habilitar operao de corte",
                                          "Enable cut operation"};
   protected String[] cut_view_trans = {"Exibir plano de corte",
                                        "Show cut plane"};
   protected String[] cut_normal_trans = {"Exibir vetor ortogonal ao plano de corte",
                                          "Show orthogonal vector to the cut plane"};   
   protected String[] cut_part1_trans = {"Exibir parte 1", "Show part 1"};
   protected String[] cut_part2_trans = {"Exibir parte 2", "Show part 2"};
   protected String[] cut_translation_trans = {"Translao:", "Translation:"};
   protected String[] cut_angle_lat_trans = {"ngulo 1:", "Angle 1:"};   
   protected String[] cut_angle_lon_trans = {"ngulo 2:", "Angle 2:"};   
   protected String[] cut_panel_trans = {"Cortar", "Cut"};

   protected String[] ufd_enable_trans = {"Habilitar montagem",
                                          "Enable unfold"};
   protected String[] flatten_level_trans = {"Parmetro:", "Parameter:"};
   protected String[] ufd_panel_trans = {"Montar", "Unfold"};

   protected String[] mod_enable_trans = {"Habilitar modelagem",
                                          "Enable modelling"};
   protected String[] mod_trn_trans = {"Truncar", "Truncate"};
   protected String[] mod_trf_trans = {"Truncar e preencher",
                                       "Truncate and fill"};
   protected String[] mod_pnc_trans = {"Esburacar", "Punch"};
   protected String[] mod_stl_trans = {"Estrelar", "Stellate"};
   protected String[] parameter_trans = {"Parmetro:", "Parameter:"};
   protected String[] mod_panel_trans = {"Modelar", "Model"};

   protected String[] platonic_trans =
                {"Slidos Platnicos", "Platonic Solids"};
   protected String[] archimedean_trans =
                {"Slidos Arquimedianos", "Archimedean Solids"};
   protected String[] johnson_trans =
                {"Slidos de Johnson", "Johnson Solids"};
   protected String[] catalan_trans =
                {"Slidos de Catalan", "Catalan Solids"};
   protected String[] prisms_trans =
                {"Prismas", "Prisms"};
   protected String[] antiprisms_trans =
                {"Antiprismas", "Antiprisms"};
   protected String[] pyramids_trans =
                {"Pirmides", "Pyramids"};      
// protected String[] nonregular_trans =
//              {"Poliedros Convexos No Regulares", "Nonregular Convex Polyhedra"};
   protected String[] toroids_trans =
                {"Torides", "Toroids"};   
// protected String[] stewart_trans =
//              {"Torides de Stewart", "Stewart Toroids"};
   protected String[] leonardo_trans =
                {"Cosmogramas de Leonardo", "Leonardo Cosmograms"};
   protected String[] animal_trans =
                {"Animais", "Animals"};
   protected String[] hexahedra_trans =
                {"Hexaedros", "Hexahedra"};         
   protected String[] isohedra_trans =
                {"Isoedros", "Isohedra"};      
   protected String[] euler_characteristic_trans =
                {"Para o poliedro original:     V - A + F = ", "For the original polyhedron:     V - E + F = "};   
*/

protected String[] title_trans = {"Uma Pletora de Poliedros",
           "A Plethora of Polyhedra", 
			 "Mnoica poliedrov"};

protected String[] vis_transparency_trans = {"Transparncia:",
                      "Transparency:", 
						"Prosojnost"};
protected String[] vis_vertices_trans = {"Exibir vrtices",
                  "Show vertices",
					"Prikai toke"};
protected String[] vis_edges_trans = {"Exibir arestas", "Show edges", "Prikai robove"};
protected String[] vis_elements_trans = {"Exibir faces", "Show faces", "Prikai ploskve"};
protected String[] vis_pseudodual_trans = {"Exibir dual topolgico", "Show topological dual", "Prikai topoloki dual"};
protected String[] vis_dual_trans = {"Exibir dual", "Show dual", "Prikai dual"};   

protected String[] vis_panel_trans = {"Exibir", "Visualize", "Prikaz"};

protected String[] cut_enable_trans = {"Habilitar operao de corte",
                "Enable cut operation",
				  "Omogoi prerez"};
protected String[] cut_view_trans = {"Exibir plano de corte",
              "Show cut plane",
				"Prikai prerezno ravnino"};
protected String[] cut_normal_trans = {"Exibir vetor ortogonal ao plano de corte",
                "Show orthogonal vector to the cut plane",
				  "Prikai vektor pravokoten na prerezno ravnino"};   
protected String[] cut_part1_trans = {"Exibir parte 1", "Show part 1", "Prikai del 1"};
protected String[] cut_part2_trans = {"Exibir parte 2", "Show part 2", "Prikai del 2"};
protected String[] cut_translation_trans = {"Translao:", "Translation:", "Premik"};
protected String[] cut_angle_lat_trans = {"ngulo 1:", "Angle 1:", "Kot 1"};   
protected String[] cut_angle_lon_trans = {"ngulo 2:", "Angle 2:", "Kot 2"};   
protected String[] cut_panel_trans = {"Cortar", "Cut", "Prerez"};

protected String[] ufd_enable_trans = {"Habilitar montagem",
                "Enable unfold",
				  "Omogoi zlaganje"};
protected String[] flatten_level_trans = {"Parmetro:", "Parameter:", "Parameter"};
protected String[] ufd_panel_trans = {"Montar", "Unfold", "Zlaganje"};

protected String[] mod_enable_trans = {"Habilitar modelagem",
                "Enable modelling",
				  "Omogoi modeliranje "};
protected String[] mod_trn_trans = {"Truncar", "Truncate", "Obrei"};
protected String[] mod_trf_trans = {"Truncar e preencher",
             "Truncate and fill",
			   "Obrei in izpolni"};
protected String[] mod_pnc_trans = {"Esburacar", "Punch", "Izvotli"};
protected String[] mod_stl_trans = {"Estrelar", "Stellate", "Radialna simetrija"};
protected String[] parameter_trans = {"Parmetro:", "Parameter:", "Parameter"};
protected String[] mod_panel_trans = {"Modelar", "Model", "Modeliraj"};

protected String[] platonic_trans =
{"Slidos Platnicos", "Platonic Solids", "Platonska telesa"};
protected String[] archimedean_trans =
{"Slidos Arquimedianos", "Archimedean Solids", "Arhimedova telesa"};
protected String[] johnson_trans =
{"Slidos de Johnson", "Johnson Solids", "Johnsonova telesa"};
protected String[] catalan_trans =
{"Slidos de Catalan", "Catalan Solids", "Catalanova telesa"};
protected String[] prisms_trans =
{"Prismas", "Prisms", "Prizme"};
protected String[] antiprisms_trans =
{"Antiprismas", "Antiprisms", "Antiprizme"};
protected String[] pyramids_trans =
{"Pirmides", "Pyramids", "Piramide"};      
protected String[] nonregular_trans =
{"Poliedros Convexos No Regulares", "Nonregular Convex Polyhedra", "Konveksni neregularni poliedri"};
protected String[] toroids_trans =
{"Torides", "Toroids", "Torusi" };   
protected String[] stewart_trans =
{"Torides de Stewart", "Stewart Toroids", "Stewartovi torusi"};
protected String[] leonardo_trans =
{"Cosmogramas de Leonardo", "Leonardo Cosmograms", "Leonardovi kozmogrami"};
protected String[] animal_trans =
{"Animais", "Animals", "ivali"};
protected String[] hexahedra_trans =
{"Hexaedros", "Hexahedra", "Heksaedri"};         
protected String[] isohedra_trans =
{"Isoedros", "Isohedra", "Izoedri"};      
protected String[] euler_characteristic_trans =
{"Para o poliedro original:     V - A + F = ", "For the original polyhedron:     V - E + F = ", "Za zaetni polieder:     V - A + F = "};   
   

   protected Category platonic;
   protected Category archimedean;
   protected Category johnson;
   protected Category catalan;
   protected Category prisms;
   protected Category antiprisms;
   protected Category pyramids;   
// protected Category nonregular;
   protected Category toroids;   
// protected Category stewart;
   protected Category leonardo;
   protected Category animal;
   protected Category hexahedra;
   protected Category isohedra;

   protected Model model;     
   
   ///////////////////////////////////////////////////////////////////////////
   // Default constructor
   ///////////////////////////////////////////////////////////////////////////
   public PjPoly_IP()
   {
      super();

      if (getClass() == PjPoly_IP.class)
      {
         init();
      };
   }; // End of PjPoly_IP()


   //////////////////////////////////////////////////////////////////////////
   // Setup the main control panel
   //////////////////////////////////////////////////////////////////////////
   public void init()
   {
      super.init();

      // Title
      addTitle(title_trans[idiom]);

      add(new Label(" "));

      poly_category = new Choice();
      add(poly_category);
      poly_category.addItemListener(this);

      poly_name = new Choice();
      add(poly_name);
      poly_name.addItemListener(this);

      add(new Label(" "));

      tabPanel = new PsTabPanel();
      add(tabPanel);
   }; // End of init()


   //////////////////////////////////////////////////////////////////////////
   // Setup parent and add the level slider
   //////////////////////////////////////////////////////////////////////////
   public void setParent(PsUpdateIf parent)
   {
      super.setParent(parent);
      m_pjPoly = (PjPoly) parent;
      idiom = m_pjPoly.idiom;
      
      // Euler characteristic translation
      m_pjPoly.eulerCharacteristic = euler_characteristic_trans[idiom];

      // Title
      setTitle(title_trans[idiom]);

      // Category and name of the solid
      poly_category.add(platonic_trans[idiom]);
      poly_category.add(archimedean_trans[idiom]);
      poly_category.add(johnson_trans[idiom]);
      poly_category.add(catalan_trans[idiom]);
      poly_category.add(prisms_trans[idiom]);
      poly_category.add(antiprisms_trans[idiom]);
      poly_category.add(pyramids_trans[idiom]);      
//    poly_category.add(nonregular_trans[idiom]);
      poly_category.add(toroids_trans[idiom]);      
//    poly_category.add(stewart_trans[idiom]);
      poly_category.add(leonardo_trans[idiom]);
      poly_category.add(animal_trans[idiom]);
      poly_category.add(hexahedra_trans[idiom]);
      poly_category.add(isohedra_trans[idiom]);
      
      poly_category.select(m_pjPoly.category);
      buildDataBase();
      buildChoice(m_pjPoly.category);
      poly_name.select(m_pjPoly.solid);
      loadModel(m_pjPoly.category, m_pjPoly.solid);

      poly_category.setEnabled(m_pjPoly.enable_choice);
      poly_name.setEnabled(m_pjPoly.enable_choice);


      // Visualization panel
      PsPanel visPanel = new PsPanel();

      viewVerticesCB = new Checkbox(vis_vertices_trans[idiom]);
      viewVerticesCB.addItemListener(this);
      viewVerticesCB.setState(true);
      visPanel.add(viewVerticesCB);

      viewEdgesCB = new Checkbox(vis_edges_trans[idiom]);
      viewEdgesCB.addItemListener(this);
      viewEdgesCB.setState(true);
      visPanel.add(viewEdgesCB);

      viewElementsCB = new Checkbox(vis_elements_trans[idiom]);
      viewElementsCB.addItemListener(this);
      viewElementsCB.setState(true);
      visPanel.add(viewElementsCB);

      visPanel.addLine(1);

      viewPseudodualCB = new Checkbox(vis_pseudodual_trans[idiom]);
      viewPseudodualCB.addItemListener(this);
      viewPseudodualCB.setState(false);
      visPanel.add(viewPseudodualCB);
      
      viewDualCB = new Checkbox(vis_dual_trans[idiom]);
      viewDualCB.addItemListener(this);
      viewDualCB.setState(false);
      visPanel.add(viewDualCB);      
      if (model.isEnabledDual() == false)
      {
    	  this.viewDualCB.setEnabled(false);
      }
      else
      {
    	  this.viewDualCB.setEnabled(true);
      }
      

      visPanel.addLine(1);

      m_aPanel = new Panel();
      m_aPanel.setLayout(new GridLayout(1, 1));
      visPanel.add(m_aPanel);
      m_aPanel.removeAll();
      m_pjPoly.transparency.setName(vis_transparency_trans[idiom]);
      m_aPanel.add(m_pjPoly.transparency.newInspector(PsPanel.INFO_EXT));

      visPanel.addLine(1);

      tabPanel.addPanel(vis_panel_trans[idiom], visPanel);

      // Cut plane panel
      PsPanel cutPanel = new PsPanel();

      enableCutPlaneCB = new Checkbox(cut_enable_trans[idiom]);
      enableCutPlaneCB.addItemListener(this);
      enableCutPlaneCB.setState(false);
      cutPanel.add(enableCutPlaneCB);

      viewCutPlaneCB = new Checkbox(cut_view_trans[idiom]);
      viewCutPlaneCB.addItemListener(this);
      viewCutPlaneCB.setState(true);
      viewCutPlaneCB.setEnabled(false);
      cutPanel.add(viewCutPlaneCB);
      
      viewNormalVectorCB = new Checkbox(cut_normal_trans[idiom]);
      viewNormalVectorCB.addItemListener(this);
      viewNormalVectorCB.setState(true);
      viewNormalVectorCB.setEnabled(false);
      cutPanel.add(viewNormalVectorCB);      

      negPartCB = new Checkbox(cut_part1_trans[idiom]);
      negPartCB.addItemListener(this);
      negPartCB.setState(true);
      negPartCB.setEnabled(false);

      posPartCB = new Checkbox(cut_part2_trans[idiom]);
      posPartCB.addItemListener(this);
      posPartCB.setState(false);
      posPartCB.setEnabled(false);

      PsPanel partPanel = new PsPanel();
      partPanel.setLayout(new GridLayout(1, 2));
      partPanel.add(negPartCB);
      partPanel.add(posPartCB);

      cutPanel.add(partPanel);
      
      cutPanel.add(new Label(" "));

      m_tPanel = new Panel();
      m_tPanel.setLayout(new GridLayout(1, 1));
      cutPanel.add(m_tPanel);
      m_tPanel.setVisible(false);
      
      m_latPanel = new Panel();
      m_latPanel.setLayout(new GridLayout(1, 1));
      cutPanel.add(m_latPanel);
      m_latPanel.setVisible(false);

      m_lonPanel = new Panel();
      m_lonPanel.setLayout(new GridLayout(1, 1));
      cutPanel.add(m_lonPanel);    
      m_lonPanel.setVisible(false);

      cutPanel.addLine(1);

      tabPanel.addPanel(cut_panel_trans[idiom], cutPanel);

      m_tPanel.removeAll();
      m_pjPoly.translation_factor.setName(cut_translation_trans[idiom]);
      m_tPanel.add(m_pjPoly.translation_factor.newInspector(PsPanel.INFO_EXT));

      m_latPanel.removeAll();
      m_pjPoly.angle_lat.setName(cut_angle_lat_trans[idiom]);
      m_latPanel.add(m_pjPoly.angle_lat.newInspector(PsPanel.INFO_EXT));

      m_lonPanel.removeAll();
      m_pjPoly.angle_lon.setName(cut_angle_lon_trans[idiom]);
      m_lonPanel.add(m_pjPoly.angle_lon.newInspector(PsPanel.INFO_EXT));      
      

      // Unfold panel
      PsPanel ufdPanel = new PsPanel();

      enableUnfoldCB = new Checkbox(ufd_enable_trans[idiom]);
      enableUnfoldCB.addItemListener(this);
      enableUnfoldCB.setState(false);

      ufdPanel.add(enableUnfoldCB);

      m_uPanel = new Panel();
      m_uPanel.setLayout(new GridLayout(1, 1));
      ufdPanel.add(m_uPanel);

      m_pjPoly.flatten_level.setName(flatten_level_trans[idiom]);      
      
      tabPanel.addPanel(ufd_panel_trans[idiom], ufdPanel);

      m_uPanel.removeAll();
      m_pjPoly.flatten_level.setName(flatten_level_trans[idiom]);
      m_uPanel.add(m_pjPoly.flatten_level.newInspector(PsPanel.INFO_EXT));
      m_uPanel.setVisible(false); // JAVAVIEW 4.60 FIX

      ufdPanel.addLine(1);

      // Model panel
      PsPanel modPanel = new PsPanel();

      enableModelCB = new Checkbox(mod_enable_trans[idiom]);
      enableModelCB.addItemListener(this);
      enableModelCB.setState(false);
      modPanel.add(enableModelCB);

      trnModelCB = new Checkbox(mod_trn_trans[idiom]);
      trnModelCB.addItemListener(this);
      trnModelCB.setState(false);
      trnModelCB.setEnabled(false);
      modPanel.add(trnModelCB);

      trfModelCB = new Checkbox(mod_trf_trans[idiom]);
      trfModelCB.addItemListener(this);
      trfModelCB.setState(false);
      trfModelCB.setEnabled(false);
      modPanel.add(trfModelCB);

      pncModelCB = new Checkbox(mod_pnc_trans[idiom]);
      pncModelCB.addItemListener(this);
      pncModelCB.setState(true);
      pncModelCB.setEnabled(false);
      modPanel.add(pncModelCB);

      stlModelCB = new Checkbox(mod_stl_trans[idiom]);
      stlModelCB.addItemListener(this);
      stlModelCB.setState(false);
      stlModelCB.setEnabled(false);
      modPanel.add(stlModelCB);

      m_mPanel = new Panel();
      m_mPanel.setLayout(new GridLayout(1, 1));
      modPanel.add(m_mPanel);
      m_mPanel.setVisible(false); // JAVAVIEW 4.60 FIX

      m_pjPoly.m_parameter.setName(parameter_trans[idiom]);

      m_mPanel.removeAll();
      m_mPanel.add(m_pjPoly.m_parameter.newInspector(PsPanel.INFO_EXT));

      modPanel.addLine(1);

      tabPanel.addPanel(mod_panel_trans[idiom], modPanel);

      // Validate
      tabPanel.validate();

      super.setParent(parent);
   }; // End of setParent()

   //////////////////////////////////////////////////////////////////////////
   // Load model
   //////////////////////////////////////////////////////////////////////////
   public void loadModel(String category, String solid)
   {
	  if (category.equals(platonic_trans[idiom]))
	  {
		  for (int i = 0; i < platonic.getNumberOfModels(); i++)
		  {
			  if (platonic.getModel(i).getName(idiom).equals(solid))
			  {
				  model = platonic.getModel(i);
				  break;
			  }
		  }
	  }

	  if (category.equals(archimedean_trans[idiom]))
	  {
		  for (int i = 0; i < archimedean.getNumberOfModels(); i++)
		  {
			  if (archimedean.getModel(i).getName(idiom).equals(solid))
			  {
				  model = archimedean.getModel(i);
				  break;
			  }
		  }
	  }

	  if (category.equals(animal_trans[idiom]))
	  {
		  for (int i = 0; i < animal.getNumberOfModels(); i++)
		  {
			  if (animal.getModel(i).getName(idiom).equals(solid))
			  {
				  model = animal.getModel(i);
				  break;
			  }
		  }
	  }
	  
	  if (category.equals(hexahedra_trans[idiom]))
	  {
		  for (int i = 0; i < hexahedra.getNumberOfModels(); i++)
		  {
			  if (hexahedra.getModel(i).getName(idiom).equals(solid))
			  {
				  model = hexahedra.getModel(i);
				  break;
			  }
		  }
	  }	  
	  
	  if (category.equals(isohedra_trans[idiom]))
	  {
		  for (int i = 0; i < isohedra.getNumberOfModels(); i++)
		  {
			  if (isohedra.getModel(i).getName(idiom).equals(solid))
			  {
				  model = isohedra.getModel(i);
				  break;
			  }
		  }
	  }	  

	  if (category.equals(johnson_trans[idiom]))
	  {
		  for (int i = 0; i < johnson.getNumberOfModels(); i++)
		  {
			  if (johnson.getModel(i).getName(idiom).equals(solid))
			  {
				  model = johnson.getModel(i);
				  break;
			  }
		  }
	  }

      if (category.equals(catalan_trans[idiom]))
          {
                  for (int i = 0; i < catalan.getNumberOfModels(); i++)
                  {
                          if (catalan.getModel(i).getName(idiom).equals(solid))
                          {
                                  model = catalan.getModel(i);
                                  break;
                          }
                  }
          }

          if (category.equals(prisms_trans[idiom]))
          {
                  for (int i = 0; i < prisms.getNumberOfModels(); i++)
                  {
                          if (prisms.getModel(i).getName(idiom).equals(solid))
                          {
                                  model = prisms.getModel(i);
                                  break;
                          }
                  }
          }

          if (category.equals(antiprisms_trans[idiom]))
         {
                 for (int i = 0; i < antiprisms.getNumberOfModels(); i++)
                 {
                         if (antiprisms.getModel(i).getName(idiom).equals(solid))
                         {
                                 model = antiprisms.getModel(i);
                                 break;
                         }
                 }
         }

          if (category.equals(pyramids_trans[idiom]))
          {
                  for (int i = 0; i < pyramids.getNumberOfModels(); i++)
                  {
                          if (pyramids.getModel(i).getName(idiom).equals(solid))
                          {
                                  model = pyramids.getModel(i);
                                  break;
                          }
                  }
          }          
          
/*          
          if (category.equals(nonregular_trans[idiom]))
          {
                  for (int i = 0; i < nonregular.getNumberOfModels(); i++)
                  {
                          if (nonregular.getModel(i).getName(idiom).equals(solid))
                          {
                                  model = nonregular.getModel(i);
                                  break;
                          }
                  }
          }
 */          
          
         if (category.equals(toroids_trans[idiom]))
         {
                  for (int i = 0; i < toroids.getNumberOfModels(); i++)
                  {
                          if (toroids.getModel(i).getName(idiom).equals(solid))
                          {
                                  model = toroids.getModel(i);
                                  break;
                          }
                  }
         }          

/*         
         if (category.equals(stewart_trans[idiom]))
         {
                 for (int i = 0; i < stewart.getNumberOfModels(); i++)
                 {
                         if (stewart.getModel(i).getName(idiom).equals(solid))
                         {
                                 model = stewart.getModel(i);
                                 break;
                         }
                 }
         }
 */         

	  if (category.equals(leonardo_trans[idiom]))
	  {
		  for (int i = 0; i < leonardo.getNumberOfModels(); i++)
		  {
			  if (leonardo.getModel(i).getName(idiom).equals(solid))
			  {
				  model = leonardo.getModel(i);
				  break;
			  }
		  }
	  }

	  
      m_pjPoly.showVertices = model.isShowingVertices();
      m_pjPoly.showEdges = model.isShowingEdges();
      m_pjPoly.showElements = model.isShowingElements();
      
      m_pjPoly.loadGeometryFromFile(model);
      if (!(m_pjPoly.disp == null))
      {
    	  m_pjPoly.disp.setName(m_pjPoly.displayTitle);
      }
   }

   //////////////////////////////////////////////////////////////////////////
   // Update the panel whenever the parent has changed somewhere else
   //////////////////////////////////////////////////////////////////////////
   public boolean update(Object  event)
   {
      if (m_pjPoly == event)
      {
         // Fill here!

         return(true);
      };

      return(super.update(event));
   }; // End of update()


   //////////////////////////////////////////////////////////////////////////
   // Handle action events invoked from text fields
   //////////////////////////////////////////////////////////////////////////
   public void actionPerformed(ActionEvent event)
   {
      if (m_pjPoly == null)
      {
          return;
      };

      // Object source = event.getSource();

      // Fill here!

   }; // End of actionPerformed()


   //////////////////////////////////////////////////////////////////////////
   // Handle action events invoked from itens
   //////////////////////////////////////////////////////////////////////////
   public void itemStateChanged(ItemEvent event)
   {
       if (m_pjPoly == null)
       {
          return;
       };

       Object source = event.getSource();

       //////////////////////////////////////////////////////////////////////
       // Names
       //////////////////////////////////////////////////////////////////////
       if (source == poly_category)
       {
    	  closeOperations();
          String category = poly_category.getSelectedItem();
          buildChoice(category);
          poly_name.select(0);
          loadModel(category, poly_name.getSelectedItem());
          if (model.isEnabledDual() == false)
          {
        	  if (this.viewDualCB.getState() == true)
        	  {
        		  this.viewDualCB.setState(false);
        	  }        	          	          	  
        	  this.viewDualCB.setEnabled(false);
          }
          else
          {
        	  this.viewDualCB.setEnabled(true);
          }
          

          // Apply current settings
          if (this.viewVerticesCB.getState() == false)
          {
              m_pjPoly.poly.showVertices(false);
              m_pjPoly.poly.update(m_pjPoly.poly);
          }
          if (this.viewEdgesCB.getState() == false)
          {
              m_pjPoly.poly.showEdges(false);
              m_pjPoly.poly.update(m_pjPoly.poly);
          }
          if (this.viewElementsCB.getState() == false)
          {
              m_pjPoly.poly.showElements(false);
              m_pjPoly.poly.update(m_pjPoly.poly);
          }

          m_pjPoly.disp.fit();
       }

       if (source == poly_name)
       {
    	  closeOperations();
          loadModel(poly_category.getSelectedItem(),
        		    poly_name.getSelectedItem());
          if (model.isEnabledDual() == false)
          {
        	  if (this.viewDualCB.getState() == true)
        	  {
        		  this.viewDualCB.setState(false);
        	  }        	          	  
        	  this.viewDualCB.setEnabled(false);
          }
          else
          {
        	  this.viewDualCB.setEnabled(true);
          }
          

          // Apply current settings
          if (this.viewVerticesCB.getState() == false)
          {
              m_pjPoly.poly.showVertices(false);
              m_pjPoly.poly.update(m_pjPoly.poly);
          }
          if (this.viewEdgesCB.getState() == false)
          {
              m_pjPoly.poly.showEdges(false);
              m_pjPoly.poly.update(m_pjPoly.poly);
          }
          if (this.viewElementsCB.getState() == false)
          {
              m_pjPoly.poly.showElements(false);
              m_pjPoly.poly.update(m_pjPoly.poly);
          }

          m_pjPoly.disp.fit();
       }

       //////////////////////////////////////////////////////////////////////
       // Visualization panel
       //////////////////////////////////////////////////////////////////////
       if (source == viewElementsCB)
       {
          if (viewElementsCB.getState() == true)
          {
             m_pjPoly.poly.showElements(true);
             m_pjPoly.poly.update(m_pjPoly.poly);

             // Synchronize visualization properties of the original and
             // PwWorkshop objects.
             if (enableCutPlaneCB.getState() == true)
             {
                PgElementSet original =
                      (PgElementSet) m_pjPoly.m_pwClip.getSavedGeometry();
                original.showElements(true);
             };

             if (enableUnfoldCB.getState() == true)
             {
                PgElementSet original =
                    (PgElementSet) m_pjPoly.m_pwUnfold.getSavedGeometry();
                original.showElements(true);
             };

             if (enableModelCB.getState() == true)
             {
                PgElementSet original =
                     (PgElementSet) m_pjPoly.m_pwModel.getSavedGeometry();
                original.showElements(true);
             };
          }
          else
          {
             m_pjPoly.poly.showElements(false);
             m_pjPoly.poly.update(m_pjPoly.poly);

             // Synchronize visualization properties of the original and
             // PwWorkshop objects.
             if (enableCutPlaneCB.getState() == true)
             {
                PgElementSet original =
                      (PgElementSet) m_pjPoly.m_pwClip.getSavedGeometry();
                original.showElements(false);
             };

             if (enableUnfoldCB.getState() == true)
             {
                PgElementSet original =
                    (PgElementSet) m_pjPoly.m_pwUnfold.getSavedGeometry();
                original.showElements(false);
             };

             if (enableModelCB.getState() == true)
             {
                PgElementSet original =
                     (PgElementSet) m_pjPoly.m_pwModel.getSavedGeometry();
                original.showElements(false);
             };
          };
          return;
       }; // End of if (source == viewElementsCB)

       if (source == viewEdgesCB)
       {
          if (viewEdgesCB.getState() == true)
          {
             m_pjPoly.poly.showEdges(true);
             m_pjPoly.poly.update(m_pjPoly.poly);

             // Synchronize visualization properties of the original and
             // PwWorkshop objects.
             if (enableCutPlaneCB.getState() == true)
             {
                PgElementSet original =
                      (PgElementSet) m_pjPoly.m_pwClip.getSavedGeometry();
                original.showEdges(true);
             };

             if (enableUnfoldCB.getState() == true)
             {
                PgElementSet original =
                    (PgElementSet) m_pjPoly.m_pwUnfold.getSavedGeometry();
                original.showEdges(true);
             };

             if (enableModelCB.getState() == true)
             {
                PgElementSet original =
                     (PgElementSet) m_pjPoly.m_pwModel.getSavedGeometry();
                original.showEdges(true);
             };
          }
          else
          {
             m_pjPoly.poly.showEdges(false);
             m_pjPoly.poly.update(m_pjPoly.poly);

             // Synchronize visualization properties of the original and
             // PwWorkshop objects.
             if (enableCutPlaneCB.getState() == true)
             {
                PgElementSet original =
                      (PgElementSet) m_pjPoly.m_pwClip.getSavedGeometry();
                original.showEdges(false);
             };

             if (enableUnfoldCB.getState() == true)
             {
                PgElementSet original =
                    (PgElementSet) m_pjPoly.m_pwUnfold.getSavedGeometry();
                original.showEdges(false);
             };

             if (enableModelCB.getState() == true)
             {
                PgElementSet original =
                     (PgElementSet) m_pjPoly.m_pwModel.getSavedGeometry();
                original.showEdges(false);
             };
          };
          return;
       }; // End of if (source == viewEdgesCB)

       if (source == viewVerticesCB)
       {
          if (viewVerticesCB.getState() == true)
          {
             m_pjPoly.poly.showVertices(true);
             m_pjPoly.poly.update(m_pjPoly.poly);

             // Synchronize visualization properties of the original and
             // PwWorkshop objects.
             if (enableCutPlaneCB.getState() == true)
             {
                PgElementSet original =
                      (PgElementSet) m_pjPoly.m_pwClip.getSavedGeometry();
                original.showVertices(true);
             };

             if (enableUnfoldCB.getState() == true)
             {
                PgElementSet original =
                    (PgElementSet) m_pjPoly.m_pwUnfold.getSavedGeometry();
                original.showVertices(true);
             };

             if (enableModelCB.getState() == true)
             {
                PgElementSet original =
                     (PgElementSet) m_pjPoly.m_pwModel.getSavedGeometry();
                original.showVertices(true);
             };
          }
          else
          {
             m_pjPoly.poly.showVertices(false);
             m_pjPoly.poly.update(m_pjPoly.poly);

             // Synchronize visualization properties of the original and
             // PwWorkshop objects.
             if (enableCutPlaneCB.getState() == true)
             {
                PgElementSet original =
                      (PgElementSet) m_pjPoly.m_pwClip.getSavedGeometry();
                original.showVertices(false);
             };

             if (enableUnfoldCB.getState() == true)
             {
                PgElementSet original =
                    (PgElementSet) m_pjPoly.m_pwUnfold.getSavedGeometry();
                original.showVertices(false);
             };

             if (enableModelCB.getState() == true)
             {
                PgElementSet original =
                     (PgElementSet) m_pjPoly.m_pwModel.getSavedGeometry();
                original.showVertices(false);
             };
          };
          return;
       }; // End of if (source == viewVerticesCB)

       if (source == viewPseudodualCB)
       {
          if (viewPseudodualCB.getState() == true)
          {
        	  m_pjPoly.addGeometry(m_pjPoly.pseudodual);
        	  if (m_pjPoly.transparency.getValue() == 0.0)
        	  {
        		  m_pjPoly.poly.showTransparency(true);
        		  m_pjPoly.poly.setTransparency(0.5);
        		  m_pjPoly.poly.update(m_pjPoly.poly);
        		  m_pjPoly.transparency.setValue(0.5);
        	  };
          }
          else
          {
        	  m_pjPoly.removeGeometry(m_pjPoly.pseudodual);
          }
          return;
       }; // End of if (source == viewPseudodualCB)
       
       if (source == viewDualCB)
       {
          if (viewDualCB.getState() == true)
          {
        	  m_pjPoly.addGeometry(m_pjPoly.dual);
          }
          else
          {
        	  m_pjPoly.removeGeometry(m_pjPoly.dual);
          }
          return;
       }; // End of if (source == viewPseudodualCB)
       


       //////////////////////////////////////////////////////////////////////
       // Cut plane panel
       //////////////////////////////////////////////////////////////////////
       if (source == enableCutPlaneCB)
       {
          if (enableCutPlaneCB.getState() == true)
          {
          	 // This is used for vertex coordinates displaying
          	 m_pjPoly.isModeling = false;      	  
        	  
        	 // Disable Euler Characteristic display
        	 m_pjPoly.operationInUse = true;
        	 m_pjPoly.disp.showTitle(false);
        	 m_pjPoly.disp.update(m_pjPoly.disp);
        	         	  
             // Disable the others operations, if any
             if (enableUnfoldCB.getState() == true)
             {
                 enableUnfoldCB.setState(false);
/* JAVAVIEW 4.60 FIX                 
                 m_pjPoly.flatten_level.setEnabled(false);
 */
                 m_uPanel.setVisible(false);
                 m_pjPoly.m_pwUnfold.cancel();
             };
             if (enableModelCB.getState() == true)
             {
                enableModelCB.setState(false);
                trnModelCB.setEnabled(false);
                trfModelCB.setEnabled(false);
                pncModelCB.setEnabled(false);
                stlModelCB.setEnabled(false);
/* JAVAVIEW 4.60 FIX                
                m_pjPoly.m_parameter.setEnabled(false);
 */
                m_mPanel.setVisible(false);
                m_pjPoly.m_pwModel.cancel();
             };

             // Cut plane setup
             viewCutPlaneCB.setEnabled(true);
             viewNormalVectorCB.setEnabled(true);             
             posPartCB.setEnabled(true);
             negPartCB.setEnabled(true);
             // m_pjPoly.poly.showVertexLabels(false);
             if (viewCutPlaneCB.getState() == true)
             {
                m_pjPoly.addGeometry(m_pjPoly.cutplane);
             };
             if (viewNormalVectorCB.getState() == true)
             {
                m_pjPoly.addGeometry(m_pjPoly.picked_point);
             };             
             m_pjPoly.m_defClipFunc = "u+v+w";
             m_pjPoly.m_pwClip = new PwClip();
             m_pjPoly.m_pwClip.setFunction(m_pjPoly.m_defClipFunc);
             m_pjPoly.m_pwClip.setLevel(0.0);
             m_pjPoly.m_pwClip.setGeometry(m_pjPoly.poly);
             if (posPartCB.getState() == true)
             {
                m_pjPoly.m_pwClip.setEnabledPositive(true);
             }
             else
             {
                m_pjPoly.m_pwClip.setEnabledPositive(false);
             };

/* JAVAVIEW 4.60
             m_pjPoly.translation_factor.setEnabled(true);
             m_pjPoly.angle_lat.setEnabled(true);
             m_pjPoly.angle_lon.setEnabled(true);
 */             
             m_tPanel.setVisible(true);
             m_latPanel.setVisible(true);
             m_lonPanel.setVisible(true);
             
             {
                m_pjPoly.addGeometry(m_pjPoly.sphere);
                m_pjPoly.selectGeometry(m_pjPoly.sphere);
             }
             m_pjPoly.updateCutPlane();
          }
          else
          {
         	 // Allow Euler Characteristic display
        	 m_pjPoly.operationInUse = false;
        	  
             viewCutPlaneCB.setEnabled(false);
             viewNormalVectorCB.setEnabled(false);
             posPartCB.setEnabled(false);
             negPartCB.setEnabled(false);
             m_pjPoly.removeGeometry(m_pjPoly.cutplane);

             m_pjPoly.m_pwClip.cancel();
             m_pjPoly.removeGeometry(m_pjPoly.picked_point);
             {
                m_pjPoly.removeGeometry(m_pjPoly.sphere);
             };
             
/* JAVAVIEW 4.60 FIX             
             m_pjPoly.translation_factor.setEnabled(false);
             m_pjPoly.angle_lat.setEnabled(false);
             m_pjPoly.angle_lon.setEnabled(false);
 */          
             m_tPanel.setVisible(false);
             m_latPanel.setVisible(false);
             m_lonPanel.setVisible(false);

             
             // Reset original poly vertices numbers
	   		 for (int i = 0; i < m_pjPoly.poly.getNumVertices(); i++)
			 {
	   			m_pjPoly.poly.getVertex(i).setName(Integer.toString(i));
			 };
			 			 
			 // Reset transparency
			 m_pjPoly.poly.setTransparency(m_pjPoly.transparency.getValue());

	         if (m_pjPoly.transparency.getValue() > 0.05)
	         {
	        	 m_pjPoly.poly.showTransparency(true);
	         }
	         else
	         {
	        	 m_pjPoly.poly.showTransparency(false);	
	         }
	          
	         m_pjPoly.poly.update(m_pjPoly.poly);			 
          };
          return;
       }; // End of if (source == enableCutPlaneCB)

       if (source == viewCutPlaneCB)
       {
          if (viewCutPlaneCB.getState() == true)
          {
             m_pjPoly.addGeometry(m_pjPoly.cutplane);
          }
          else
          {
             m_pjPoly.removeGeometry(m_pjPoly.cutplane);
          };
          return;
       }; // End of if (source == viewCutPlaneCB)
       
       if (source == viewNormalVectorCB)
       {
          if (viewNormalVectorCB.getState() == true)
          {
             m_pjPoly.addGeometry(m_pjPoly.picked_point);
          }
          else
          {
             m_pjPoly.removeGeometry(m_pjPoly.picked_point);
          };
          return;
       }; // End of if (source == viewCutPlaneCB)       

       if (source == posPartCB)
       {
          if (posPartCB.getState() == true)
          {
             negPartCB.setState(false);
             m_pjPoly.m_pwClip.setEnabledPositive(true);
             m_pjPoly.updateCutPlane();
          }
          else
          {
             posPartCB.setState(true);
          };

          return;
       }; // End of if (source == posPartCB)

       if (source == negPartCB)
       {
          if (negPartCB.getState() == true)
          {
             posPartCB.setState(false);
             m_pjPoly.m_pwClip.setEnabledPositive(false);
             m_pjPoly.updateCutPlane();
          }
          else
          {
             negPartCB.setState(true);
          };

          return;
       }; // End of if (source == negPartCB)

       //////////////////////////////////////////////////////////////////////
       // Unfold panel
       //////////////////////////////////////////////////////////////////////
       if (source == enableUnfoldCB)
       {
          if (enableUnfoldCB.getState() == true)
          {
         	 // This is used for vertex coordinates displaying
         	 m_pjPoly.isModeling = false;      	  
        	  
         	 // Disable Euler Characteristic display
         	 m_pjPoly.operationInUse = true;
        	 m_pjPoly.disp.showTitle(false);
        	 m_pjPoly.disp.update(m_pjPoly.disp);         	 
        	  
             // Disable the others operations, if any
             if (enableCutPlaneCB.getState() == true)
             {
                enableCutPlaneCB.setState(false);
                viewCutPlaneCB.setEnabled(false);
                viewNormalVectorCB.setEnabled(false);
                posPartCB.setEnabled(false);
                negPartCB.setEnabled(false);
                m_pjPoly.removeGeometry(m_pjPoly.cutplane);

                m_pjPoly.m_pwClip.cancel();
                m_pjPoly.removeGeometry(m_pjPoly.picked_point);

                {
                   m_pjPoly.removeGeometry(m_pjPoly.sphere);
                };
                
/* JAVAVIEW 4.60 FIX                                
                m_pjPoly.translation_factor.setEnabled(false);
                m_pjPoly.angle_lat.setEnabled(false);
                m_pjPoly.angle_lon.setEnabled(false);
 */              
                m_tPanel.setVisible(false);
                m_latPanel.setVisible(false);
                m_lonPanel.setVisible(false);
             };
             if (enableModelCB.getState() == true)
             {
                enableModelCB.setState(false);
                trnModelCB.setEnabled(false);
                trfModelCB.setEnabled(false);
                pncModelCB.setEnabled(false);
                stlModelCB.setEnabled(false);
/* JAVAVIEW 4.60 FIX                
                m_pjPoly.m_parameter.setEnabled(false);
 */
                m_mPanel.setVisible(false);
                m_pjPoly.m_pwModel.cancel();
             };

             // Unfold setup
/* JAVAVIEW 4.60 FIX             
             m_pjPoly.flatten_level.setEnabled(true);
 */
             m_uPanel.setVisible(true);
             m_pjPoly.m_pwUnfold = new PwUnfold();
             m_pjPoly.m_pwUnfold.setGeometry(m_pjPoly.poly);
             // m_pjPoly.poly.showVertexLabels(false);
             m_pjPoly.m_pwUnfold.setEnabledFixingElement(true);
             m_pjPoly.m_pwUnfold.setDisplay(m_pjPoly.disp);
                                      // The PwUnfold needs a reference to the
                                      // display in order to work properly.
             if (model.getImproveUnfolding() == true)
             {
            	 for (int i = 0; i < model.getUnfoldingTrials(); i++)
            	 {
            	    m_pjPoly.m_pwUnfold.improveUnfolding();
            	 };
             }
             m_pjPoly.m_pwUnfold.flatten(m_pjPoly.flatten_level.getValue()/100.0);
             m_pjPoly.poly.update(m_pjPoly.poly);
          }
          else
          {
          	 // Allow Euler Characteristic display
          	 m_pjPoly.operationInUse = false;
        	  
/* JAVAVIEW 4.60 FIX          	 
             m_pjPoly.flatten_level.setEnabled(false);
 */
          	 m_uPanel.setVisible(false);          	 
             m_pjPoly.m_pwUnfold.cancel();
             
             // Reset original poly vertices numbers
	   		 for (int i = 0; i < m_pjPoly.poly.getNumVertices(); i++)
			 {
	   			m_pjPoly.poly.getVertex(i).setName(Integer.toString(i));
			 };
			 			 
			 // Reset transparency
			 m_pjPoly.poly.setTransparency(m_pjPoly.transparency.getValue());

	         if (m_pjPoly.transparency.getValue() > 0.05)
	         {
	        	 m_pjPoly.poly.showTransparency(true);
	         }
	         else
	         {
	        	 m_pjPoly.poly.showTransparency(false);	
	         }
	          
	         m_pjPoly.poly.update(m_pjPoly.poly);             
          };
          return;
       }; // End of if (source == enableUnfoldCB)

       //////////////////////////////////////////////////////////////////////
       // Model panel
       //////////////////////////////////////////////////////////////////////
       if (source == enableModelCB)
       {
          if (enableModelCB.getState() == true)
          {
        	 // This is used for vertex coordinates displaying
        	 m_pjPoly.isModeling = true;
        	  
          	 // Disable Euler Characteristic display
          	 m_pjPoly.operationInUse = true;
        	 m_pjPoly.disp.showTitle(false);
        	 m_pjPoly.disp.update(m_pjPoly.disp);          	 
        	          	  
             // Disable the others operations, if any
             if (enableUnfoldCB.getState() == true)
             {
                 enableUnfoldCB.setState(false);
/* JAVAVIEW 4.60 FIX                 
                 m_pjPoly.flatten_level.setEnabled(false);
 */
                 m_uPanel.setVisible(false);
                 m_pjPoly.m_pwUnfold.cancel();
             };
             if (enableCutPlaneCB.getState() == true)
             {
                enableCutPlaneCB.setState(false);
                viewCutPlaneCB.setEnabled(false);
                viewNormalVectorCB.setEnabled(false);
                posPartCB.setEnabled(false);
                negPartCB.setEnabled(false);
                m_pjPoly.removeGeometry(m_pjPoly.cutplane);

                m_pjPoly.m_pwClip.cancel();
                m_pjPoly.removeGeometry(m_pjPoly.picked_point);

                {
                   m_pjPoly.removeGeometry(m_pjPoly.sphere);
                };
                
/* JAVAVIEW 4.60 FIX                
                m_pjPoly.translation_factor.setEnabled(false);
                m_pjPoly.angle_lat.setEnabled(false);
                m_pjPoly.angle_lon.setEnabled(false);
 */              
                m_tPanel.setVisible(false);
                m_latPanel.setVisible(false);
                m_lonPanel.setVisible(false);

             };

             // Model setup
             trnModelCB.setEnabled(true);
             trfModelCB.setEnabled(true);
             pncModelCB.setEnabled(true);
             stlModelCB.setEnabled(true);
/* JAVAVIEW 4.60 FIX             
             m_pjPoly.m_parameter.setEnabled(true);
 */
             m_mPanel.setVisible(true);

             // m_pjPoly.poly.showVertexLabels(false);
             m_pjPoly.m_pwModel = new PwModel();
             m_pjPoly.m_pwModel.setGeometry(m_pjPoly.poly);
             m_pjPoly.m_pwModel.setEnabledModeling(true);

             if (trnModelCB.getState() == true)
             {
                m_pjPoly.trn_fill = false;
                m_pjPoly.setModelingType(PwModel.TRUNCATE);
                m_pjPoly.poly.copy(m_pjPoly.m_pwModel.getSavedGeometry());
                PwModel.truncate(m_pjPoly.poly,m_pjPoly.m_parameter.getValue(), m_pjPoly.trn_fill);
             };
             if (trfModelCB.getState() == true)
             {
                m_pjPoly.trn_fill = true;
                m_pjPoly.setModelingType(PwModel.TRUNCATEFILL);
                m_pjPoly.poly.copy(m_pjPoly.m_pwModel.getSavedGeometry());
                PwModel.truncate(m_pjPoly.poly, m_pjPoly.m_parameter.getValue(), m_pjPoly.trn_fill);
             };
             if (pncModelCB.getState() == true)
             {
                m_pjPoly.setModelingType(PwModel.PUNCH);
                m_pjPoly.poly.copy(m_pjPoly.m_pwModel.getSavedGeometry());
                PwModel.punch(m_pjPoly.poly, m_pjPoly.m_parameter.getValue());
             };
             if (stlModelCB.getState() == true)
             {
                m_pjPoly.setModelingType(PwModel.STELLATE);
                m_pjPoly.poly.copy(m_pjPoly.m_pwModel.getSavedGeometry());
                PwModel.stellate(m_pjPoly.poly, m_pjPoly.m_parameter.getValue());
             };

             m_pjPoly.poly.update(m_pjPoly.poly);
          }
          else
          {
          	 // Allow Euler Characteristic display
          	 m_pjPoly.operationInUse = false;       	  
        	  
             trnModelCB.setEnabled(false);
             trfModelCB.setEnabled(false);
             pncModelCB.setEnabled(false);
             stlModelCB.setEnabled(false);
/* JAVAVIEW 4.60 FIX             
             m_pjPoly.m_parameter.setEnabled(false);
 */
             m_mPanel.setVisible(false);
             m_pjPoly.m_pwModel.cancel();
             
             // Reset original poly vertices numbers
	   		 for (int i = 0; i < m_pjPoly.poly.getNumVertices(); i++)
			 {
	   			m_pjPoly.poly.getVertex(i).setName(Integer.toString(i));
			 };
			 			 
			 // Reset transparency
			 m_pjPoly.poly.setTransparency(m_pjPoly.transparency.getValue());

	         if (m_pjPoly.transparency.getValue() > 0.05)
	         {
	        	 m_pjPoly.poly.showTransparency(true);
	         }
	         else
	         {
	        	 m_pjPoly.poly.showTransparency(false);	
	         }
	          
	         m_pjPoly.poly.update(m_pjPoly.poly);             
          };
       }; // End of if (source == enableModelCB)

       if (source == trnModelCB)
       {
          m_pjPoly.setModelingType(PwModel.TRUNCATE);
          updateModelSelectors();

          m_pjPoly.trn_fill = false;
          m_pjPoly.poly.copy(m_pjPoly.m_pwModel.getSavedGeometry());
          PwModel.truncate(m_pjPoly.poly, m_pjPoly.m_parameter.getValue(), m_pjPoly.trn_fill);
          m_pjPoly.poly.update(m_pjPoly.poly);
       }
       else
       {
          updateModelSelectors();
       }; // End of if (source == trnModelCB)

       if (source == trfModelCB)
       {
          m_pjPoly.setModelingType(PwModel.TRUNCATEFILL);
          updateModelSelectors();

          m_pjPoly.trn_fill = true;
          m_pjPoly.poly.copy(m_pjPoly.m_pwModel.getSavedGeometry());
          PwModel.truncate(m_pjPoly.poly, m_pjPoly.m_parameter.getValue(), m_pjPoly.trn_fill);
          m_pjPoly.poly.update(m_pjPoly.poly);
       }
       else
       {
          updateModelSelectors();
       }; // End of if (source == trfModelCB)

       if (source == pncModelCB)
       {
          m_pjPoly.setModelingType(PwModel.PUNCH);
          updateModelSelectors();

          m_pjPoly.poly.copy(m_pjPoly.m_pwModel.getSavedGeometry());
          PwModel.punch(m_pjPoly.poly, m_pjPoly.m_parameter.getValue());
          m_pjPoly.poly.update(m_pjPoly.poly);
       }
       else
       {
          updateModelSelectors();
       }; // End of if (source == pncModelCB)

       if (source == stlModelCB)
       {
          m_pjPoly.setModelingType(PwModel.STELLATE);
          updateModelSelectors();

          m_pjPoly.poly.copy(m_pjPoly.m_pwModel.getSavedGeometry());
          PwModel.stellate(m_pjPoly.poly, m_pjPoly.m_parameter.getValue());
          m_pjPoly.poly.update(m_pjPoly.poly);
       }
       else
       {
          updateModelSelectors();
       }; // End of if (source == stlModelCB)
    }; // End of itemStateChanged()

    //////////////////////////////////////////////////////////////////////
    // Close all pending PwModel operations
    //////////////////////////////////////////////////////////////////////
    protected void closeOperations()
    {
        // Disable the others operations, if any
        if (enableCutPlaneCB.getState() == true)
        {
           enableCutPlaneCB.setState(false);
           viewCutPlaneCB.setEnabled(false);
           viewNormalVectorCB.setEnabled(false);
           posPartCB.setEnabled(false);
           negPartCB.setEnabled(false);
           m_pjPoly.removeGeometry(m_pjPoly.cutplane);

           m_pjPoly.m_pwClip.cancel();
           m_pjPoly.removeGeometry(m_pjPoly.picked_point);

           {
              m_pjPoly.removeGeometry(m_pjPoly.sphere);
           };
           
/* JAVAVIEW 4.60 FIX           
           m_pjPoly.translation_factor.setEnabled(false);
           m_pjPoly.angle_lat.setEnabled(false);
           m_pjPoly.angle_lon.setEnabled(false);
 */        
           m_tPanel.setVisible(false);
           m_latPanel.setVisible(false);
           m_lonPanel.setVisible(false);

        };
        if (enableUnfoldCB.getState() == true)
        {
            enableUnfoldCB.setState(false);
/* JAVAVIEW 4.60 FIX            
            m_pjPoly.flatten_level.setEnabled(false);
 */
            m_uPanel.setVisible(false);
            m_pjPoly.m_pwUnfold.cancel();
        };
        if (enableModelCB.getState() == true)
        {
           enableModelCB.setState(false);
           trnModelCB.setEnabled(false);
           trfModelCB.setEnabled(false);
           pncModelCB.setEnabled(false);
           stlModelCB.setEnabled(false);
/* JAVAVIEW 4.60 FIX           
           m_pjPoly.m_parameter.setEnabled(false);
 */
           m_mPanel.setVisible(false);
           m_pjPoly.m_pwModel.cancel();
        };
        tabPanel.setVisible(vis_panel_trans[idiom]);
    }; // End of closeOperations()

    //////////////////////////////////////////////////////////////////////////
    // Handle the proper state of the checkbox items in the model panel
    //////////////////////////////////////////////////////////////////////////
    protected void updateModelSelectors()
    {
       if (m_pjPoly.m_modelingType == PwModel.TRUNCATE)
       {
          trnModelCB.setState(true);
       }
       else
       {
          trnModelCB.setState(false);
       };

       if (m_pjPoly.m_modelingType == PwModel.TRUNCATEFILL)
       {
          trfModelCB.setState(true);
       }
       else
       {
          trfModelCB.setState(false);
       };

       if (m_pjPoly.m_modelingType == PwModel.PUNCH)
       {
          pncModelCB.setState(true);
       }
       else
       {
          pncModelCB.setState(false);
       };

       if (m_pjPoly.m_modelingType == PwModel.STELLATE)
       {
          stlModelCB.setState(true);
       }
       else
       {
          stlModelCB.setState(false);
       };
    }; // End of updateModelSelectors()


    //////////////////////////////////////////////////////////////////////////
    // Build choice of models within a given category
    //////////////////////////////////////////////////////////////////////////
    protected void buildChoice(String c)
    {
    	poly_name.removeAll();
    	if (c.equals(platonic_trans[idiom]))
    	{
    		for (int i = 0; i < platonic.getNumberOfModels(); i++)
    		{
    		   poly_name.add(platonic.getModel(i).getName(idiom));
    		}
    	}

    	if (c.equals(archimedean_trans[idiom]))
    	{
    		for (int i = 0; i < archimedean.getNumberOfModels(); i++)
    		{
    		   poly_name.add(archimedean.getModel(i).getName(idiom));
    		}
    	}

    	if (c.equals(johnson_trans[idiom]))
    	{
    		for (int i = 0; i < johnson.getNumberOfModels(); i++)
    		{
    		   poly_name.add(johnson.getModel(i).getName(idiom));
    		}
    	}

            if (c.equals(catalan_trans[idiom]))
        {
                for (int i = 0; i < catalan.getNumberOfModels(); i++)
                {
                   poly_name.add(catalan.getModel(i).getName(idiom));
                }
        }

        if (c.equals(prisms_trans[idiom]))
        {
                for (int i = 0; i < prisms.getNumberOfModels(); i++)
                {
                   poly_name.add(prisms.getModel(i).getName(idiom));
                }
        }

        if (c.equals(antiprisms_trans[idiom]))
        {
                for (int i = 0; i < antiprisms.getNumberOfModels(); i++)
                {
                   poly_name.add(antiprisms.getModel(i).getName(idiom));
                }
        }

        if (c.equals(pyramids_trans[idiom]))
        {
                for (int i = 0; i < pyramids.getNumberOfModels(); i++)
                {
                   poly_name.add(pyramids.getModel(i).getName(idiom));
                }
        }        
        
/*        
        if (c.equals(nonregular_trans[idiom]))
        {
                for (int i = 0; i < nonregular.getNumberOfModels(); i++)
                {
                   poly_name.add(nonregular.getModel(i).getName(idiom));
                }
        }
 */                

        if (c.equals(toroids_trans[idiom]))
        {
                for (int i = 0; i < toroids.getNumberOfModels(); i++)
                {
                   poly_name.add(toroids.getModel(i).getName(idiom));
                }
        }        

/*        
        if (c.equals(stewart_trans[idiom]))
        {
                for (int i = 0; i < stewart.getNumberOfModels(); i++)
                {
                   poly_name.add(stewart.getModel(i).getName(idiom));
                }
        }
 */        

    	if (c.equals(leonardo_trans[idiom]))
    	{
    		for (int i = 0; i < leonardo.getNumberOfModels(); i++)
    		{
    		   poly_name.add(leonardo.getModel(i).getName(idiom));
    		}
    	}

    	if (c.equals(animal_trans[idiom]))
    	{
    		for (int i = 0; i < animal.getNumberOfModels(); i++)
    		{
    		   poly_name.add(animal.getModel(i).getName(idiom));
    		}
    	}
    	
    	if (c.equals(hexahedra_trans[idiom]))
    	{
    		for (int i = 0; i < hexahedra.getNumberOfModels(); i++)
    		{
    		   poly_name.add(hexahedra.getModel(i).getName(idiom));
    		}
    	}
    	
    	if (c.equals(isohedra_trans[idiom]))
    	{
    		for (int i = 0; i < isohedra.getNumberOfModels(); i++)
    		{
    		   poly_name.add(isohedra.getModel(i).getName(idiom));
    		}
    	}    	
    }


    //////////////////////////////////////////////////////////////////////////
    // Build database of solids
    //////////////////////////////////////////////////////////////////////////
    protected void buildDataBase()
    {
        int i;

if (0 == 1)
{
        // PLATONIC
        i = 0;
        platonic = new Category(platonic_trans, 5);

        platonic.addModel(i, new Model(platonic_trans,
                new String[]
                {"Tetraedro",
                 "Tetrahedron"},
                "off",
                "platonic-tetrahedron",
	          4, 6, 4,
                true, true, true,
                true,
                true));
        i++;

        platonic.addModel(i, new Model(platonic_trans,
                new String[]
                {"Cubo",
                 "Cube"},
                "off",
                "platonic-cube",
	          8, 12, 6,
                true, true, true,
                true,
                true));
        i++;

        platonic.addModel(i, new Model(platonic_trans,
                new String[]
                {"Octaedro",
                 "Octahedron"},
                "off",
                "platonic-octahedron",
	          6, 12, 8,
                true, true, true,
                true,
                true));
        i++;

        platonic.addModel(i, new Model(platonic_trans,
                new String[]
                {"Dodecaedro",
                 "Dodecahedron"},
                "off",
                "platonic-dodecahedron",
	          20, 30, 12,
                true, true, true,
                true,
                true));
        i++;

        platonic.addModel(i, new Model(platonic_trans,
                new String[]
                {"Icosaedro",
                 "Icosahedron"},
                "off",
                "platonic-icosahedron",
	          12, 30, 20,
                true, true, true,
                true,
                true));
        i++;

        // ARCHIMEDEAN
        i = 0;
        archimedean = new Category(archimedean_trans, 13);

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Tetraedro Truncado",
                 "Truncated Tetrahedron"},
                "off",
                "archimedean-truncated-tetrahedron",
	          12, 18, 8,
                true, true, true,
                true,
                true));
        i++;

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Cuboctaedro",
                 "Cuboctahedron"},
                "off",
                "archimedean-cuboctahedron",
	          12, 24, 14,
                true, true, true,
                true,
                true));
        i++;

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Octaedro Truncado",
                 "Truncated Octahedron"},
                "off",
                "archimedean-truncated-octahedron",
	          24, 36, 14,
                true, true, true,
                true,
                true));
        i++;

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Cubo Truncado",
                 "Truncated Cube"},
                "off",
                "archimedean-truncated-cube",
	          24, 36, 14,
                true, true, true,
                true,
                true));
        i++;

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Pequeno Rombicuboctaedro",
                 "Small Rhombicuboctahedron"},
                "off",
                "archimedean-rhombicuboctahedron",
	          24, 48, 26,
                true, true, true,
                true,
                true));
        i++;

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Grande Rombicuboctaedro",
                 "Great Rhombicuboctahedron"},
                "off",
                "archimedean-truncated-cuboctahedron",
	          48, 72, 26,
                true, true, true,
                true,
                true));
        i++;

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Cubo Achatado",
                 "Snub Cube"},
                "off",
                "archimedean-snub-cube",
	          24, 60, 38,
                true, true, true,
                true,
                true));
        i++;

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Icosidodecaedro",
                 "Icosidodecahedron"},
                "off",
                "archimedean-icosidodecahedron",
	          30, 60, 32,
                true, true, true,
                true,
                true));
        i++;

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Icosaedro Truncado",
                 "Truncated Icosahedron"},
                "off",
                "archimedean-truncated-icosahedron",
	          60, 90, 32,
                true, true, true,
                true,
                true));
        i++;

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Dodecaedro Truncado",
                 "Truncated Dodecahedron"},
                "off",
                "archimedean-truncated-dodecahedron",
	          60, 90, 32,
                true, true, true,
                true,
                true));
        i++;

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Pequeno Rombicosidodecaedro",
                 "Small Rhombicosidodecahedron"},
                "off",
                "archimedean-rhombicosidodecahedron",
	          60, 120, 62,
                true, true, true,
                true,
                true));
        i++;

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Grande Rombicosidodecaedro",
                 "Great Rhombicosidodecahedron"},
                "off",
                "archimedean-truncated-icosidodecahedron",
	          120, 180, 62,
                true, true, true,
                true,
                true));
        i++;

        archimedean.addModel(i, new Model(archimedean_trans,
                new String[]
                {"Dodecaedro Achatado",
                 "Snub Dodecahedron"},
                "off",
                "archimedean-snub-dodecahedron",
	          60, 150, 92,
                true, true, true,
                true,
                true));
        i++;

        // JOHNSON
        i = 0;
        johnson = new Category(johnson_trans, 92);

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Pirmide Quadrada (J1)",
                 "Square Pyramid (J1)"},
                "off",
                "johnson-j01-square-pyramid",
	          5, 8, 5,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Pirmide Pentagonal (J2)",
                 "Pentagonal Pyramid (J2)"},
                "off",
                "johnson-j02-pentagonal-pyramid",
	          6, 10, 6,
                true, true, true,
                true,
                true));
        i++;

       johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Cpula Triangular (J3)",
                 "Triangular Cupola (J3)"},
                "off",
                "johnson-j03-triangular-cupola",
	          9, 15, 8,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Cpula Quadrada (J4)",
                 "Square Cupola (J4)"},
                "off",
                "johnson-j04-square-cupola",
	          12, 20, 10,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Cpula Pentagonal (J5)",
                 "Pentagonal Cupola (J5)"},
                "off",
                "johnson-j05-pentagonal-cupola",
	          15, 25, 12,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Rotunda Pentagonal (J6)",
                 "Pentagonal Rotunda (J6)"},
                "off",
                "johnson-j06-pentagonal-rotunda",
	          20, 35, 17,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Pirmide Triangular Alongada (J7)",
                 "Elongated Triangular Pyramid (J7)"},
                "off",
                "johnson-j07-elongated-triangular-pyramid",
	          7, 12, 7,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Pirmide Quadrada Alongada (J8)",
                 "Elongated Square Pyramid (J8)"},
                "off",
                "johnson-j08-elongated-square-pyramid",
	          9, 16, 9,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Pirmide Pentagonal Alongada (J9)",
                 "Elongated Pentagonal Pyramid (J9)"},
                "off",
                "johnson-j09-elongated-pentagonal-pyramid",
	          11, 20, 11,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Pirmide Quadrada Giroalongada (J10)",
                 "Gyroelongated Square Pyramid (J10)"},
                "off",
                "johnson-j10-gyroelongated-square-pyramid",
	          9, 20, 13,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Pirmide Pentagonal Giroalongada (J11)",
                 "Gyroelongated Pentagonal Pyramid (J11)"},
                "off",
                "johnson-j11-gyroelongated-pentagonal-pyramid",
	          11, 25, 16,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dipirmide Triangular (J12)",
                 "Triangular Dipyramid (J12)"},
                "off",
                "johnson-j12-triangular-dipyramid",
	          5, 9, 6,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dipirmide Pentagonal (J13)",
                 "Pentagonal Dipyramid (J13)"},
                "off",
                "johnson-j13-pentagonal-dipyramid",
	          7, 15, 10,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dipirmide Triangular Alongada (J14)",
                 "Elongated Triangular Dipyramid (J14)"},
                "off",
                "johnson-j14-elongated-triangular-dipyramid",
	          8, 15, 9,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dipirmide Quadrada Alongada (J15)",
                 "Elongated Square Dipyramid (J15)"},
                "off",
                "johnson-j15-elongated-square-dipyramid",
	          10, 20, 12,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dipirmide Pentagonal Alongada (J16)",
                 "Elongated Pentagonal Dipyramid (J16)"},
                "off",
                "johnson-j16-elongated-pentagonal-dipyramid",
	          12, 25, 15,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dipirmide Quadrada Giroalongada (J17)",
                 "Gyroelongated Square Dipyramid (J17)"},
                "off",
                "johnson-j17-gyroelongated-square-dipyramid",
	          10, 24, 16,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Cpula Triangular Alongada (J18)",
                 "Elongated Triangular Cupola (J18)"},
                "off",
                "johnson-j18-elongated-triangular-cupola",
	          15, 27, 14,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Cpula Quadrada Alongada (J19)",
                 "Elongated Square Cupola (J19)"},
                "off",
                "johnson-j19-elongated-square-cupola",
	          20, 36, 18,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Cpula Pentagonal Alongada (J20)",
                 "Elongated Pentagonal Cupola (J20)"},
                "off",
                "johnson-j20-elongated-pentagonal-cupola",
	          25, 45, 22,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Rotunda Pentagonal Alongada (J21)",
                 "Elongated Pentagonal Rotunda (J21)"},
                "off",
                "johnson-j21-elongated-pentagonal-rotunda",
	          30, 55, 27,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Cpula Triangular Giroalongada (J22)",
                 "Gyroelongated Triangular Cupola (J22)"},
                "off",
                "johnson-j22-gyroelongated-triangular-cupola",
	          15, 33, 20,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Cpula Quadrada Giroalongada (J23)",
                 "Gyroelongated Square Cupola (J23)"},
                "off",
                "johnson-j23-gyroelongated-square-cupola",
	          20, 44, 26,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Cpula Pentagonal Giroalongada (J24)",
                 "Gyroelongated Pentagonal Cupola (J24)"},
                "off",
                "johnson-j24-gyroelongated-pentagonal-cupola",
	          25, 55, 32,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Rotunda Pentagonal Giroalongada (J25)",
                 "Gyroelongated Pentagonal Rotunda (J25)"},
                "off",
                "johnson-j25-gyroelongated-pentagonal-rotunda",
	          30, 65, 37,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Gyrobifastigium (J26)",
                 "Gyrobifastigium (J26)"},
                "off",
                "johnson-j26-gyrobifastigium",
	          8, 14, 8,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Ortobicpula Triangular (J27)",
                 "Triangular Orthobicupola (J27)"},
                "off",
                "johnson-j27-triangular-orthobicupola",
	          12, 24, 14,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Ortobicpula Quadrada (J28)",
                 "Square Orthobicupola (J28)"},
                "off",
                "johnson-j28-square-orthobicupola",
	          16, 32, 18,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Girobicpula Quadrada (J29)",
                 "Square Gyrobicupola (J29)"},
                "off",
                "johnson-j29-square-gyrobicupola",
	          16, 32, 18,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Ortobicpula Pentagonal (J30)",
                 "Pentagonal Orthobicupola (J30)"},
                "off",
                "johnson-j30-pentagonal-orthobicupola",
	          20, 40, 22,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Girobicpula Pentagonal (J31)",
                 "Pentagonal Gyrobicupola (J31)"},
                "off",
                "johnson-j31-pentagonal-gyrobicupola",
	          20, 40, 22,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Ortocupularrotunda Pentagonal (J32)",
                 "Pentagonal Orthocupolarotunda (J32)"},
                "off",
                "johnson-j32-pentagonal-orthocupolarotunda",
	          25, 50, 27,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Girocupularrotunda Pentagonal (J33)",
                 "Pentagonal Gyrocupolarotunda (J33)"},
                "off",
                "johnson-j33-pentagonal-gyrocupolarotunda",
	          25, 50, 27,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Ortobirrotunda Pentagonal (J34)",
                 "Pentagonal Orthobirotunda (J34)"},
                "off",
                "johnson-j34-pentagonal-orthobirotunda",
	          30, 60, 32,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Ortobicpula Triangular Alongada (J35)",
                 "Elongated Triangular Orthobicupola (J35)"},
                "off",
                "johnson-j35-elongated-triangular-orthobicupola",
	          18, 36, 20,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Girobicpula Triangular Alongada (J36)",
                 "Elongated Triangular Gyrobicupola (J36)"},
                "off",
                "johnson-j36-elongated-triangular-gyrobicupola",
	          18, 36, 20,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Girobicpula Quadrada Alongada (J37)",
                 "Elongated Square Gyrobicupola (J37)"},
                "off",
                "johnson-j37-elongated-square-gyrobicupola",
	          24, 48, 26,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Ortobicpula Pentagonal Alongada (J38)",
                 "Elongated Pentagonal Orthobicupola (J38)"},
                "off",
                "johnson-j38-elongated-pentagonal-orthobicupola",
	          30, 60, 32,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Girobicpula Pentagonal Alongada (J39)",
                 "Elongated Pentagonal Gyrobicupola (J39)"},
                "off",
                "johnson-j39-elongated-pentagonal-gyrobicupola",
	          30, 60, 32,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Ortocupularrotunda Pentagonal Alongada (J40)",
                 "Elongated Pentagonal Orthocupolarotunda (J40)"},
                "off",
                "johnson-j40-elongated-pentagonal-orthocupolarotunda",
	          35, 70, 37,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Girocupularrotunda Pentagonal Alongada (J41)",
                 "Elongated Pentagonal Gyrocupolarotunda (J41)"},
                "off",
                "johnson-j41-elongated-pentagonal-gyrocupolarotunda",
	          35, 70, 37,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Ortobirrotunda Pentagonal Alongada (J42)",
                 "Elongated Pentagonal Orthobirotunda (J42)"},
                "off",
                "johnson-j42-elongated-pentagonal-orthobirotunda",
	          40, 80, 42,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Girobirrotunda Pentagonal Alongada (J43)",
                 "Elongated Pentagonal Gyrobirotunda (J43)"},
                "off",
                "johnson-j43-elongated-pentagonal-gyrobirotunda",
	          40, 80, 42,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Bicpula Triangular Giroalongada (J44)",
                 "Gyroelongated Triangular Bicupola (J44)"},
                "off",
                "johnson-j44-gyroelongated-triangular-bicupola",
	          18, 42, 26,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Bicpula Quadrada Giroalongada (J45)",
                 "Gyroelongated Square Bicupola (J45)"},
                "off",
                "johnson-j45-gyroelongated-square-bicupola",
	          24, 56, 34,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Bicpula Pentagonal Giroalongada (J46)",
                 "Gyroelongated Pentagonal Bicupola (J46)"},
                "off",
                "johnson-j46-gyroelongated-pentagonal-bicupola",
	          30, 70, 42,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Cupularrotunda Pentagonal Giroalongada (J47)",
                 "Gyroelongated Pentagonal Cupolarotunda (J47)"},
                "off",
                "johnson-j47-gyroelongated-pentagonal-cupolarotunda",
	          35, 80, 47,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Birrotunda Pentagonal Giroalongada (J48)",
                 "Gyroelongated Pentagonal Birotunda (J48)"},
                "off",
                "johnson-j48-gyroelongated-pentagonal-birotunda",
	          40, 90, 52,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Prisma Triangular Aumentado (J49)",
                 "Augmented Triangular Prism (J49)"},
                "off",
                "johnson-j49-augmented-triangular-prism",
	          7, 13, 8,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Prisma Triangular Biaumentado (J50)",
                 "Biaugmented Triangular Prism (J50)"},
                "off",
                "johnson-j50-biaugmented-triangular-prism",
	          8, 17, 11,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Prisma Triangular Triaumentado (J51)",
                 "Triaugmented Triangular Prism (J51)"},
                "off",
                "johnson-j51-triaugmented-triangular-prism",
	          9, 21, 14,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Prisma Pentagonal Aumentado (J52)",
                 "Augmented Pentagonal Prism (J52)"},
                "off",
                "johnson-j52-augmented-pentagonal-prism",
	          11, 19, 10,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Prisma Pentagonal Biaumentado (J53)",
                 "Biaugmented Pentagonal Prism (J53)"},
                "off",
                "johnson-j53-biaugmented-pentagonal-prism",
	          12, 23, 13,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Prisma Hexagonal Aumentado (J54)",
                 "Augmented Hexagonal Prism (J54)"},
                "off",
                "johnson-j54-augmented-hexagonal-prism",
	          13, 22, 11,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Prisma Hexagonal Parabiaumentado (J55)",
                 "Parabiaugmented Hexagonal Prism (J55)"},
                "off",
                "johnson-j55-parabiaugmented-hexagonal-prism",
	          14, 26, 14,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Prisma Hexagonal Metabiaumentado (J56)",
                 "Metabiaugmented Hexagonal Prism (J56)"},
                "off",
                "johnson-j56-metabiaugmented-hexagonal-prism",
	          14, 26, 14,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Prisma Hexagonal Triaumentado (J57)",
                 "Triaugmented Hexagonal Prism (J57)"},
                "off",
                "johnson-j57-triaugmented-hexagonal-prism",
	          15, 30, 17,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dodecaedro Aumentado (J58)",
                 "Augmented Dodecahedron (J58)"},
                "off",
                "johnson-j58-augmented-dodecahedron",
	          21, 35, 16,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dodecaedro Parabiaumentado (J59)",
                 "Parabiaugmented Dodecahedron (J59)"},
                "off",
                "johnson-j59-parabiaugmented-dodecahedron",
	          22, 40, 20,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dodecaedro Metabiaumentado (J60)",
                 "Metabiaugmented Dodecahedron (J60)"},
                "off",
                "johnson-j60-metabiaugmented-dodecahedron",
	          22, 40, 20,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dodecaedro Triaumentado (J61)",
                 "Triaugmented Dodecahedron (J61)"},
                "off",
                "johnson-j61-triaugmented-dodecahedron",
	          23, 45, 24,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Icosaedro Metabidiminudo (J62)",
                 "Metabidiminished Icosahedron (J62)"},
                "off",
                "johnson-j62-metabidiminished-icosahedron",
	          10, 20, 12,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Icosaedro Tridiminudo (J63)",
                 "Tridiminished Icosahedron (J63)"},
                "off",
                "johnson-j63-tridiminished-icosahedron",
	          9, 15, 8,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Icosaedro Tridiminudo Aumentado (J64)",
                 "Augmented Tridiminished Icosahedron (J64)"},
                "off",
                "johnson-j64-augmented-tridiminished-icosahedron",
	          10, 18, 10,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Tetraedro Truncado Aumentado (J65)",
                 "Augmented Truncated Tetrahedron (J65)"},
                "off",
                "johnson-j65-augmented-truncated-tetrahedron",
	          15, 27, 14,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Cubo Truncado Aumentado (J66)",
                 "Augmented Truncated Cube (J66)"},
                "off",
                "johnson-j66-augmented-truncated-cube",
	          28, 48, 22,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Cubo Truncado Biaumentado (J67)",
                 "Biaugmented Truncated Cube (J67)"},
                "off",
                "johnson-j67-biaugmented-truncated-cube",
	          32, 60, 30,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dodecaedro Truncado Aumentado (J68)",
                 "Augmented Truncated Dodecahedron (J68)"},
                "off",
                "johnson-j68-augmented-truncated-dodecahedron",
	          65, 105, 42,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dodecaedro Truncado Parabiaumentado (J69)",
                 "Parabiaugmented Truncated Dodecahedron (J69)"},
                "off",
                "johnson-j69-parabiaugmented-truncated-dodecahedron",
	          70, 120, 52,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dodecaedro Truncado Metabiaumentado (J70)",
                 "Metabiaugmented Truncated Dodecahedron (J70)"},
                "off",
                "johnson-j70-metabiaugmented-truncated-dodecahedron",
	          70, 120, 52,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Dodecaedro Truncado Triaumentado (J71)",
                 "Triaugmented Truncated Dodecahedron (J71)"},
                "off",
                "johnson-j71-triaugmented-truncated-dodecahedron",
	          75, 135, 62,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Giro-Rombicosidodecaedro (J72)",
                 "Gyrate-Rhombicosidodecahedron (J72)"},
                "off",
                "johnson-j72-gyrate-rhombicosidodecahedron",
	          60, 120, 62,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Parabigiro-Rombicosidodecaedro (J73)",
                 "Parabigyrate-Rhombicosidodecahedron (J73)"},
                "off",
                "johnson-j73-parabigyrate-rhombicosidodecahedron",
	          60, 120, 62,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Metabigiro-Rombicosidodecaedro (J74)",
                 "Metabigyrate-Rhombicosedodecahedron (J74)"},
                "off",
                "johnson-j74-metabigyrate-rhombicosidodecahedron",
	          60, 120, 62,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Trigiro-Rombicosidodecaedro (J75)",
                 "Trigyrate-Rhombicosidodecahedron (J75)"},
                "off",
                "johnson-j75-trigyrate-rhombicosidodecahedron",
	          60, 120, 62,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Rombicosidodecaedro Diminudo (J76)",
                 "Diminished Rhombicosidodecahedron (J76)"},
                "off",
                "johnson-j76-diminished-rhombicosidodecahedron",
	          55, 105, 52,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Rombicosidodecaedro Paragirodiminudo (J77)",
                 "Paragyrate Diminished Rhombicosidodecahedron (J77)"},
                "off",
                "johnson-j77-paragyrate-diminished-rhombicosidodecahedron",
	          55, 105, 52,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Rombicosidodecaedro Metagirodiminudo (J78)",
                 "Metagyrate Diminished Rhombicosidodecahedron (J78)"},
                "off",
                "johnson-j78-metagyrate-diminished-rhombicosidodecahedron",
	          55, 105, 52,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Rombicosidodecaedro Bigirodiminudo (J79)",
                 "Bigyrate Diminished Rhombicosidodecahedron (J79)"},
                "off",
                "johnson-j79-bigyrate-diminished-rhombicosidodecahedron",
	          55, 105, 52,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Rombicosidodecaedro Parabidiminudo (J80)",
                 "Parabidiminished Rhombicosidodecahedron (J80)"},
                "off",
                "johnson-j80-parabidiminished-rhombicosidodecahedron",
	          50, 90, 42,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Rombicosidodecaedro Metabidiminudo (J81)",
                 "Metabidiminished Rhombicosidodecahedron (J81)"},
                "off",
                "johnson-j81-metabidiminished-rhombicosidodecahedron",
	          50, 90, 42,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Rombicosidodecaedro Girobidiminudo (J82)",
                 "Gyrate Bidiminished Rhombicosidodecahedron (J82)"},
                "off",
                "johnson-j82-gyrate-bidiminished-rhombicosidodecahedron",
	          50, 90, 42,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Rombicosidodecaedro Tridiminudo (J83)",
                 "Tridiminished Rhombicosidodecahedron (J83)"},
                "off",
                "johnson-j83-tridiminished-rhombicosidodecahedron",
	          45, 75, 32,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Disfenide Achatado (J84)",
                 "Snub-Disphenoid (J84)"},
                "off",
                "johnson-j84-snub-disphenoid",
	          8, 18, 12,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Antiprisma Quadrado Achatado (J85)",
                 "Snub Square Antiprism (J85)"},
                "off",
                "johnson-j85-snub-square-antiprism",
	          16, 40, 26,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Esfenocorona (J86)",
                 "Sphenocorona (J86)"},
                "off",
                "johnson-j86-sphenocorona",
	          10, 22, 14,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Esfenocorona Aumentada (J87)",
                 "Augmented Sphenocorona (J87)"},
                "off",
                "johnson-j87-augmented-sphenocorona",
	          11, 26, 17,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Esfenomegacorona (J88)",
                 "Sphenomegacorona (J88)"},
                "off",
                "johnson-j88-sphenomegacorona",
	          12, 28, 18,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Hebesfenomegacorona (J89)",
                 "Hebesphenomegacorona (J89)"},
                "off",
                "johnson-j89-hebesphenomegacorona",
	          14, 33, 21,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Disfenocingulum (J90)",
                 "Disphenocingulum (J90)"},
                "off",
                "johnson-j90-disphenocingulum",
	          16, 38, 24,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Bilunabirrotunda (J91)",
                 "Bilunabirotunda (J91)"},
                "off",
                "johnson-j91-bilunabirotunda",
	          14, 26, 14,
                true, true, true,
                true,
                true));
        i++;

        johnson.addModel(i, new Model(johnson_trans,
                new String[]
                {"Hebesfenorrotunda Triangular (J92)",
                 "Triangular Hebesphenorotunda (J92)"},
                "off",
                "johnson-j92-triangular-hebesphenorotunda",
	          18, 36, 20,
                true, true, true,
                true,
                true));
        i++;

        // CATALAN
        i = 0;
        catalan = new Category(catalan_trans, 13);

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Tetraedro Triakis",
                 "Triakistetrahedron"},
                "off",
                "catalan-triakistetrahedron",
	          8, 18, 12,
                true, true, true,
                true,
                true));
        i++;

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Dodecaedro Rmbico",
                 "Rhombic Dodecahedron"},
                "off",
                "catalan-rhombic-dodecahedron",
	          14, 24, 12,
                true, true, true,
                true,
                true));
        i++;

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Hexaedro Tetrakis",
                 "Tetrakishexahedron"},
                "off",
                "catalan-tetrakishexahedron",
	          14, 36, 24,
                true, true, true,
                true,
                true));
        i++;

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Octaedro Triakis",
                 "Triakisoctahedron"},
                "off",
                "catalan-triakisoctahedron",
	          14, 36, 24,
                true, true, true,
                true,
                true));
        i++;

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Icositetraedro Deltoidal",
                 "Strombic Icositetrahedron"},
                "off",
                "catalan-strombic-icositetrahedron",
	          26, 48, 24,
                true, true, true,
                true,
                true));
        i++;

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Dodecaedro Disdiakis",
                 "Disdyakis Dodecahedron"},
                "off",
                "catalan-disdyakis-dodecahedron",
	          26, 72, 48,
                true, true, true,
                true,
                true));
        i++;

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Icositetraedro Pentagonal",
                 "Pentagonal Icositetrahedron"},
                "off",
                "catalan-pentagonal-icositetrahedron",
	          38, 60, 24,
                true, true, true,
                true,
                true));
        i++;

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Triacontaedro Rmbico",
                 "Rhombic Triacontahedron"},
                "off",
                "catalan-rhombic-triacontahedron",
	          32, 60, 30,
                true, true, true,
                true,
                true));
        i++;

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Dodecaedro Pentakis",
                 "Pentakis Dodecahedron"},
                "off",
                "catalan-pentakis-dodecahedron",
	          32, 90, 60,
                true, true, true,
                true,
                true));
        i++;

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Icosaedro Triakis",
                 "Triakis Icosahedron"},
                "off",
                "catalan-triakis-icosahedron",
	          32, 90, 60,
                true, true, true,
                true,
                true));
        i++;

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Hexecontaedro Deltoidal",
                 "Strombic Hexecontahedron"},
                "off",
                "catalan-strombic-hexecontahedron",
	          62, 120, 60,
                true, true, true,
                true,
                true));
        i++;

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Triacontaedro Disdiakis",
                 "Disdyakis Triacontahedron"},
                "off",
                "catalan-disdyakis-triacontahedron",
	          62, 180, 120,
                true, true, true,
                true,
                true));
        i++;

        catalan.addModel(i, new Model(catalan_trans,
                new String[]
                {"Hexecontaedro Pentagonal",
                 "Pentagonal Hexecontahedron"},
                "off",
                "catalan-pentagonal-hexecontahedron",
	          92, 150, 60,
                true, true, true,
                true,
                true));
        i++;

        // PRISMS
        i = 0;
        prisms = new Category(prisms_trans, 30);        
        
       // Regular 
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Regular de Base Triangular",
                "Regular with Triangular Base"},
               "off",
               "prisms-regular-triangular",
	          6, 9, 5,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Reto de Base Triangular",
                "Right with Triangular Base"},
               "off",
               "prisms-right-triangular",
	          6, 9, 5,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Oblquo de Base Triangular",
                "Oblique with Triangular Base"},
               "off",
               "prisms-oblique-triangular",
	          6, 9, 5,
               true, true, true,
               true,
               true));
       i++;
              
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Regular de Base Quadrangular",
                "Regular with Quadrangular Base"},
               "off",
               "prisms-regular-quadrangular",
	          8, 12, 6,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Reto de Base Quadrangular",
                "Right with Quadrangular Base"},
               "off",
               "prisms-right-quadrangular",
	          8, 12, 6,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Oblquo de Base Quadrangular",
                "Oblique with Quadrangular Base"},
               "off",
               "prisms-oblique-quadrangular",
	          8, 12, 6,
               true, true, true,
               true,
               true));
       i++;       
             
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Regular de Base Pentagonal",
                "Regular with Pentagonal Base"},
               "off",
               "prisms-regular-pentagonal",
	          10, 15, 7,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Reto de Base Pentagonal",
                "Right with Pentagonal Base"},
               "off",
               "prisms-right-pentagonal",
	          10, 15, 7,
               true, true, true,
               true,
               true));
       i++;       

       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Oblquo de Base Pentagonal",
                "Oblique with Pentagonal Base"},
               "off",
               "prisms-oblique-pentagonal",
	          10, 15, 7,
               true, true, true,
               true,
               true));
       i++;

       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Regular de Base Hexagonal",
                "Regular with Hexagonal Base"},
               "off",
               "prisms-regular-hexagonal",
	          12, 18, 8,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Reto de Base Hexagonal",
                "Right with Hexagonal Base"},
               "off",
               "prisms-right-hexagonal",
	          12, 18, 8,
               true, true, true,
               true,
               true));
       i++;       
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Oblquo de Base Hexagonal",
                "Oblique with Hexagonal Base"},
               "off",
               "prisms-oblique-hexagonal",
	          12, 18, 8,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Regular de Base Heptagonal",
                "Regular with Heptagonal Base"},
               "off",
               "prisms-regular-heptagonal",
	          14, 21, 9,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Reto de Base Heptagonal",
                "Right with Heptagonal Base"},
               "off",
               "prisms-right-heptagonal",
	          14, 21, 9,
               true, true, true,
               true,
               true));
       i++;       
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Oblquo de Base Heptagonal",
                "Oblique with Heptagonal Base"},
               "off",
               "prisms-oblique-heptagonal",
	          14, 21, 9,
               true, true, true,
               true,
               true));
       i++;       

       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Regular de Base Octagonal",
                "Regular with Octagonal Base"},
               "off",
               "prisms-regular-octagonal",
	          16, 24, 10,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Reto de Base Octagonal",
                "Right with Octagonal Base"},
               "off",
               "prisms-right-octagonal",
	          16, 24, 10,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Oblquo de Base Octagonal",
                "Oblique with Octagonal Base"},
               "off",
               "prisms-oblique-octagonal",
	          16, 24, 10,
               true, true, true,
               true,
               true));
       i++;       
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Regular de Base Eneagonal",
                "Regular with Enneagonal Base"},
               "off",
               "prisms-regular-enneagonal",
	          18, 27, 11,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Reto de Base Eneagonal",
                "Right with Enneagonal Base"},
               "off",
               "prisms-right-enneagonal",
	          18, 27, 11,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Oblquo de Base Eneagonal",
                "Oblique with Enneagonal Base"},
               "off",
               "prisms-oblique-enneagonal",
	          18, 27, 11,
               true, true, true,
               true,
               true));
       i++;       

       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Regular de Base Decagonal",
                "Regular with Decagonal Base"},
               "off",
               "prisms-regular-decagonal",
	          20, 30, 12,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Reto de Base Decagonal",
                "Right with Decagonal Base"},
               "off",
               "prisms-right-decagonal",
	          20, 30, 12,
               true, true, true,
               true,
               true));
       i++;       
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Oblquo de Base Decagonal",
                "Oblique with Decagonal Base"},
               "off",
               "prisms-oblique-decagonal",
	          20, 30, 12,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Regular de Base Hendecagonal",
                "Regular with Hendecagonal Base"},
               "off",
               "prisms-regular-hendecagonal",
	          22, 33, 13,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Reto de Base Hendecagonal",
                "Right with Hendecagonal Base"},
               "off",
               "prisms-right-hendecagonal",
	          22, 33, 13,
               true, true, true,
               true,
               true));
       i++;       
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Oblquo de Base Hendecagonal",
                "Oblique with Hendecagonal Base"},
               "off",
               "prisms-oblique-hendecagonal",
	          22, 33, 13,
               true, true, true,
               true,
               true));
       i++;       
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Regular de Base Dodecagonal",
                "Regular with Dodecagonal Base"},
               "off",
               "prisms-regular-dodecagonal",
	          24, 36, 14,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Reto de Base Dodecagonal",
                "Right with Dodecagonal Base"},
               "off",
               "prisms-right-dodecagonal",
	          24, 36, 14,
               true, true, true,
               true,
               true));
       i++;
       
       prisms.addModel(i, new Model(prisms_trans,
               new String[]
               {"Oblquo de Base Dodecagonal",
                "Oblique with Dodecagonal Base"},
               "off",
               "prisms-oblique-dodecagonal",
	          24, 36, 14,
               true, true, true,
               true,
               true));
       i++;       
              

       // ANTIPRISMS
       i = 0;
      antiprisms = new Category(antiprisms_trans, 10);

      antiprisms.addModel(i, new Model(antiprisms_trans,
              new String[]
              {"Regular de Base Triangular",
               "Regular with Triangular Base"},
              "off",
              "antiprisms-regular-octahedron",
	          6, 12, 8,
              true, true, true,
              true,
              true));
      i++;      
      
      antiprisms.addModel(i, new Model(antiprisms_trans,
              new String[]
              {"Regular de Base Quadrangular",
               "Regular with Quadrangular Base"},
              "off",
              "antiprisms-regular-quadrangular",
	          8, 16, 10,
              true, true, true,
              true,
              true));
      i++;

      antiprisms.addModel(i, new Model(antiprisms_trans,
              new String[]
              {"Regular de Base Pentagonal",
               "Regular with Pentagonal Base"},
              "off",
              "antiprisms-regular-pentagonal",
	          10, 20, 12,
              true, true, true,
              true,
              true));
      i++;

      antiprisms.addModel(i, new Model(antiprisms_trans,
              new String[]
              {"Regular de Base Hexagonal",
               "Regular with Hexagonal Base"},
              "off",
              "antiprisms-regular-hexagonal",
	          12, 24, 14,
              true, true, true,
              true,
              true));
      i++;

      antiprisms.addModel(i, new Model(antiprisms_trans,
              new String[]
              {"Regular de Base Heptagonal",
               "Regular with Heptagonal Base"},
              "off",
              "antiprisms-regular-heptagonal",
	          14, 28, 16,
              true, true, true,
              true,
              true));
      i++;

      antiprisms.addModel(i, new Model(antiprisms_trans,
              new String[]
              {"Regular de Base Octagonal",
               "Regular with Octagonal Base"},
              "off",
              "antiprisms-regular-octagonal",
	          16, 32, 18,
              true, true, true,
              true,
              true));
      i++;

      antiprisms.addModel(i, new Model(antiprisms_trans,
              new String[]
              {"Regular de Base Eneagonal",
               "Regular with Enneagonal Base"},
              "off",
              "antiprisms-regular-enneagonal",
	          18, 36, 20,
              true, true, true,
              true,
              true));
      i++;      
      
      antiprisms.addModel(i, new Model(antiprisms_trans,
              new String[]
              {"Regular de Base Decagonal",
               "Regular with Decagonal Base"},
              "off",
              "antiprisms-regular-decagonal",
	          20, 40, 22,
              true, true, true,
              true,
              true));
      i++;

      antiprisms.addModel(i, new Model(antiprisms_trans,
              new String[]
              {"Regular de Base Hendecagonal",
               "Regular with Hendecagonal Base"},
              "off",
              "antiprisms-regular-hendecagonal",
	          22, 44, 24,
              true, true, true,
              true,
              true));
      i++;

      antiprisms.addModel(i, new Model(antiprisms_trans,
              new String[]
              {"Regular de Base Dodecagonal",
               "Regular with Dodecagonal Base"},
              "off",
              "antiprisms-regular-dodecagonal",
	          24, 48, 26,
              true, true, true,
              true,
              true));
      i++;      

      // PYRAMIDS
      i = 0;
      pyramids = new Category(pyramids_trans, 30);

      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Regular de Base Triangular",
	           "Regular with Triangular Base"},
	          "off",
	          "pyramids-regular-triangular",
	          4, 6, 4,
	          true, true, true,
	          true,
	          true));
      i++;

      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Reta de Base Triangular",
	           "Right with Triangular Base"},
	          "off",
	          "pyramids-right-triangular",
	          4, 6, 4,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Oblqua de Base Triangular",
	           "Oblique with Triangular Base"},
	          "off",
	          "pyramids-oblique-triangular",
	          4, 6, 4,
	          true, true, true,
	          true,
	          true));
      i++;
            
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Regular de Base Quadrangular",
	           "Regular with Quadrangular Base"},
	          "off",
	          "pyramids-regular-quadrangular",
	          5, 8, 5,
	          true, true, true,
	          true,
	          true));
      i++;
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Reta de Base Quadrangular",
	           "Right with Quadrangular Base"},
	          "off",
	          "pyramids-right-quadrangular",
	          5, 8, 5,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Oblqua de Base Quadrangular",
	           "Oblique with Quadrangular Base"},
	          "off",
	          "pyramids-oblique-quadrangular",
	          5, 8, 5,
	          true, true, true,
	          true,
	          true));
      i++;      

      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Regular de Base Pentagonal",
	           "Regular with Pentagonal Base"},
	          "off",
	          "pyramids-regular-pentagonal",
	          6, 10, 6,
	          true, true, true,
	          true,
	          true));
      i++;
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Reta de Base Pentagonal",
	           "Right with Pentagonal Base"},
	          "off",
	          "pyramids-right-pentagonal",
	          6, 10, 6,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Oblqua de Base Pentagonal",
	           "Oblique with Pentagonal Base"},
	          "off",
	          "pyramids-oblique-pentagonal",
	          6, 10, 6,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Regular de Base Hexagonal",
	           "Regular with Hexagonal Base"},
	          "off",
	          "pyramids-regular-hexagonal",
	          7, 12, 7,
	          true, true, true,
	          true,
	          true));
      i++;
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Reta de Base Hexagonal",
	           "Right with Hexagonal Base"},
	          "off",
	          "pyramids-right-hexagonal",
	          7, 12, 7,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Oblqua de Base Hexagonal",
	           "Oblique with Hexagonal Base"},
	          "off",
	          "pyramids-oblique-hexagonal",
	          7, 12, 7,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Regular de Base Heptagonal",
	           "Regular with Heptagonal Base"},
	          "off",
	          "pyramids-regular-heptagonal",
	          8, 14, 8,
	          true, true, true,
	          true,
	          true));
      i++;
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Reta de Base Heptagonal",
	           "Right with Heptagonal Base"},
	          "off",
	          "pyramids-right-heptagonal",
	          8, 14, 8,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Oblqua de Base Heptagonal",
	           "Oblique with Heptagonal Base"},
	          "off",
	          "pyramids-oblique-heptagonal",
	          8, 14, 8,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Regular de Base Octagonal",
	           "Regular with Octagonal Base"},
	          "off",
	          "pyramids-regular-octagonal",
	          9, 16, 9,
	          true, true, true,
	          true,
	          true));
      i++;
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Reta de Base Octagonal",
	           "Right with Octagonal Base"},
	          "off",
	          "pyramids-right-octagonal",
	          9, 16, 9,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Oblqua de Base Octagonal",
	           "Oblique with Octagonal Base"},
	          "off",
	          "pyramids-oblique-octagonal",
	          9, 16, 9,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Regular de Base Eneagonal",
	           "Regular with Enneagonal Base"},
	          "off",
	          "pyramids-regular-enneagonal",
	          10, 18, 10,
	          true, true, true,
	          true,
	          true));
      i++;
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Reta de Base Eneagonal",
	           "Right with Enneagonal Base"},
	          "off",
	          "pyramids-regular-enneagonal",
	          10, 18, 10,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Oblqua de Base Eneagonal",
	           "Oblique with Enneagonal Base"},
	          "off",
	          "pyramids-oblique-enneagonal",
	          10, 18, 10,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Regular de Base Decagonal",
	           "Regular with Decagonal Base"},
	          "off",
	          "pyramids-regular-decagonal",
	          11, 20, 11,
	          true, true, true,
	          true,
	          true));
      i++;
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Reta de Base Decagonal",
	           "Right with Decagonal Base"},
	          "off",
	          "pyramids-right-decagonal",
	          11, 20, 11,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Oblqua de Base Decagonal",
	           "Oblique with Decagonal Base"},
	          "off",
	          "pyramids-oblique-decagonal",
	          11, 20, 11,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Regular de Base Hendecagonal",
	           "Regular with Hendecagonal Base"},
	          "off",
	          "pyramids-regular-hendecagonal",
	          12, 22, 12,
	          true, true, true,
	          true,
	          true));
      i++;
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Reta de Base Hendecagonal",
	           "Right with Hendecagonal Base"},
	          "off",
	          "pyramids-right-hendecagonal",
	          12, 22, 12,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Oblqua de Base Hendecagonal",
	           "Oblique with Hendecagonal Base"},
	          "off",
	          "pyramids-oblique-hendecagonal",
	          12, 22, 12,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Regular de Base Dodecagonal",
	           "Regular with Dodecagonal Base"},
	          "off",
	          "pyramids-regular-dodecagonal",
	          13, 24, 13,
	          true, true, true,
	          true,
	          true));
      i++;
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Reta de Base Dodecagonal",
	           "Right with Dodecagonal Base"},
	          "off",
	          "pyramids-right-dodecagonal",
	          13, 24, 13,
	          true, true, true,
	          true,
	          true));
      i++;      
      
      pyramids.addModel(i, new Model(pyramids_trans,
	          new String[]
	          {"Oblqua de Base Dodecagonal",
	           "Oblique with Dodecagonal Base"},
	          "off",
	          "pyramids-oblique-dodecagonal",
	          13, 24, 13,
	          true, true, true,
	          true,
	          true));
      i++;      
                 

/*
      // NONREGULAR
      i = 0;
      nonregular = new Category(nonregular_trans, 10);
      
      nonregular.addModel(i, new Model(nonregular_trans,
	          new String[]
	          {"Prisma Reto de Base Triangular",
	           "NonRegular Triangular Right Prism"},
	          "off",
	          "non-regular-triangular-right-prism",
	          6, 9, 5,
	          true, true, true,
	          true,
	          true));
      i++;      

      nonregular.addModel(i, new Model(nonregular_trans,
	          new String[]
	          {"Prisma Oblquo de Base Triangular",
	           "NonRegular Triangular Oblique Prism"},
	          "off",
	          "non-regular-triangular-oblique-prism",
	          6, 9, 5,
	          true, true, true,
	          true,
	          true));
      i++;
      
      nonregular.addModel(i, new Model(nonregular_trans,
	          new String[]
	          {"Prisma Reto de Base Quadrada",
	           "NonRegular Right Square Prism"},
	          "off",
	          "non-regular-right-square-prism",
	          8, 12, 6,
	          true, true, true,
	          true,
	          true));
      i++;
      
      nonregular.addModel(i, new Model(nonregular_trans,
	          new String[]
	          {"Prisma Oblquo de Base Quadrada",
	           "NonRegular Oblique Square Prism"},
	          "off",
	          "non-regular-oblique-square-prism",
	          8, 12, 6,
	          true, true, true,
	          true,
	          true));
      i++;
      
      nonregular.addModel(i, new Model(nonregular_trans,
	          new String[]
	          {"Pirmide Oblqua de Base Quadrada",
	           "NonRegular Oblique Square Pyramid"},
	          "off",
	          "non-regular-oblique-square-pyramid",
	          5, 8, 5,
	          true, true, true,
	          true,
	          true));
      i++;
      
      nonregular.addModel(i, new Model(nonregular_trans,
	          new String[]
	          {"Romboedro Oblquo",
	           "NonRegular Oblique Rhombohedron"},
	          "off",
	          "non-regular-oblique-rhombohedron",
	          8, 12, 6,
	          true, true, true,
	          true,
	          true));
      i++;
      
      nonregular.addModel(i, new Model(nonregular_trans,
	          new String[]
	          {"Paraleleppedo Reto Retngulo",
	           "NonRegular Right Rectangle Parallelepiped"},
	          "off",
	          "non-regular-right-rectangle-parallelepiped",
	          8, 12, 6,
	          true, true, true,
	          true,
	          true));
      i++;

      nonregular.addModel(i, new Model(nonregular_trans,
	          new String[]
	          {"Paraleleppedo Oblquo",
	           "NonRegular Oblique Parallelepiped"},
	          "off",
	          "non-regular-oblique-parallelepiped",
	          8, 12, 6,
	          true, true, true,
	          true,
	          true));
      i++;
      
      nonregular.addModel(i, new Model(nonregular_trans,
	          new String[]
	          {"Paraleleppedo Reto",
	           "NonRegular Right Parallelepiped"},
	          "off",
	          "non-regular-right-parallelepiped",
	          8, 12, 6,
	          true, true, true,
	          true,
	          true));
      i++;
      
      nonregular.addModel(i, new Model(nonregular_trans,
	          new String[]
	          {"Pirmide No-Regular",
	           "NonRegular Pyramid"},
	          "off",
	          "non-regular-pyramid",
	          5, 8, 5,
	          true, true, true,
	          true,
	          true));
      i++;
 */      
        
      // TOROIDS
      i = 0;
      toroids = new Category(toroids_trans, 44);

      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Toride com 1 Buraco Triangular",
               "Toroid with 1 Triangular Hole"},
              "off",
              "toroid-triangular-genus-01",
	          9, 18, 9,
              true, true, true,
              false,
              true));
      i++;
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Toride com 1 Buraco Quadrado",
               "Toroid with 1 Square Hole"},
              "off",
              "toroid-quadrangular-genus-01",
	          12, 24, 12,
              true, true, true,
              false,
              true));
      i++;
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Toride com 1 Buraco Pentagonal",
               "Toroid with 1 Pentagonal Hole"},
              "off",
              "toroid-pentagonal-genus-01",
	          15, 30, 15,
              true, true, true,
              false,
              true));
      i++;
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Toride com 1 Buraco Hexagonal",
               "Toroid with 1 Hexagonal Hole"},
              "off",
              "toroid-hexagonal-genus-01",
	          18, 36, 18,
              true, true, true,
              false,
              true));
      i++;
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Toride com 1 Buraco Heptagonal",
               "Toroid with 1 Heptagonal Hole"},
              "off",
              "toroid-heptagonal-genus-01",
	          21, 42, 21,
              true, true, true,
              false,
              true));
      i++;      
            
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Toride com 2 Buraco Triangulares",
               "Toroid with 2 Triangular Holes"},
              "off",
              "toroid-triangular-genus-02",
	          14, 32, 16,
              true, true, true,
              false,
              true));
      i++;            
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Toride com 2 Buracos Quadrados",
               "Toroid with 2 Square Holes"},
              "off",
              "toroid-quadrangular-genus-02",
	          20, 44, 22,
              true, true, true,
              false,
              true));
      i++;      

      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Toride com 3 Buracos Quadrados",
               "Toroid with 3 Square Holes"},
              "off",
              "toroid-quadrangular-genus-03",
	          28, 64, 32,
              true, true, true,
              false,
              true));
      i++;            
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Toride com 4 Buracos Quadrados",
               "Toroid with 4 Square Holes"},
              "off",
              "toroid-quadrangular-genus-04",
	          36, 84, 42,
              true, true, true,
              false,
              true));
      i++;      
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Toride com 5 Buracos Quadrados",
               "Toroid with 5 Square Holes"},
              "off",
              "toroid-quadrangular-genus-05",
	          44, 104, 52,
              true, true, true,
              false,
              true));
      i++;      
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Toride com 6 Buracos Quadrados",
               "Toroid with 6 Square Holes"},
              "off",
              "toroid-quadrangular-genus-06",
	          52, 124, 62,
              true, true, true,
              false,
              true));
      i++;
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Toride com 7 Buracos Quadrados",
               "Toroid with 7 Square Holes"},
              "off",
              "toroid-quadrangular-genus-07",
	          60, 144, 72,
              true, true, true,
              false,
              true));
      i++;
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Poliedro com 1 Ala",
               "Polyhedron with 1 Handle"},
              "off",
              "toroid-handle-genus-01",
	          48, 78, 30,
              true, true, true,
              false,
              true));
      i++;                  
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Poliedro com 2 Alas",
               "Polyhedron with 2 Handles"},
              "off",
              "toroid-handle-genus-02",
	          54, 93, 37,
              true, true, true,
              false,
              true));
      i++;      
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Poliedro com 3 Alas",
               "Polyhedron with 3 Handles"},
              "off",
              "toroid-handle-genus-03",
	          60, 108, 44,
              true, true, true,
              false,
              true));
      i++;
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Poliedro com 4 Alas",
               "Polyhedron with 4 Handles"},
              "off",
              "toroid-handle-genus-04",
	          66, 123, 51,
              true, true, true,
              false,
              true));
      i++;
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Poliedro com 5 Alas",
               "Polyhedron with 5 Handles"},
              "off",
              "toroid-handle-genus-05",
	          72, 138, 58,
              true, true, true,
              false,
              true));
      i++;      
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Poliedro com 6 Alas",
               "Polyhedron with 6 Handles"},
              "off",
              "toroid-handle-genus-06",
	          78, 153, 65,
              true, true, true,
              false,
              true));
      i++;      
      
      toroids.addModel(i, new Model(toroids_trans,
              new String[]
              {"Poliedro com 7 Alas",
               "Polyhedron with 7 Handles"},
              "off",
              "toroid-handle-genus-07",
	          84, 168, 72,
              true, true, true,
              false,
              true));
      i++;      
      
      // STEWART
      //  i = 0;
      //  stewart = new Category(stewart_trans, 25);
        
      toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Cpula Triangular Perfurada Alongada",
                 "Drilled Elongated Triangular Cupola"},
                "off",
                "stewart-drilled-elongated-triangular-cupola",
	          18, 39, 21,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Bicpula Triangular Perfurada",
                 "Drilled Triangular Bicupola"},
                "off",
                "stewart-drilled-triangular-bicupola",
	          15, 39, 24,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Cubo Truncado Perfurado",
                 "Drilled Truncated Cube"},
                "off",
                "stewart-drilled-truncated-cube",
	          32, 64, 32,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Bicpula Quadrada Perfurada",
                 "Drilled Square Bicupola"},
                "off",
                "stewart-drilled-square-bicupola",
	          20, 48, 28,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Octaedro Truncado Perfurado",
                 "Single-drilled Truncated Octahedron"},
                "off",
                "stewart-single-drilled-truncated-octahedron",
	          30, 54, 24,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Rotunda Pentagonal Perfurada",
                 "Drilled Pentagonal Rotunda"},
                "off",
                "stewart-drilled-pentagonal-rotunda",
	          25, 60, 35,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Cubo Truncado Biaumentado Perfurado",
                 "Drilled Biaugmented Truncated Cube"},
                "off",
                "stewart-drilled-biaugmented-truncated-cube",
	          48, 104, 56,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Octaedro Truncado Tetra Perfurado",
                 "Four-Drilled Truncated Octahedron"},
                "off",
                "stewart-four-drilled-truncated-octahedron",
	            30, 72, 38,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Anel Octadrico com 8 Elos",
                 "Eight-Octahedron Ring"},
                "off",
                "stewart-eight-octahedron-ring",
	          24, 72, 48,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Cuboctaedro Truncado Quadrado-Perfurado",
                 "Square-Drilled Truncated Cuboctahedron"},
                "off",
                "stewart-square-drilled-truncated-cuboctahedron",
	          72, 168, 76,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Cuboctaedro Truncado Hexgono-Perfurado",
                 "Hexagon-Drilled Truncated Cuboctahedron"},
                "off",
                "stewart-hexagon-drilled-truncated-cuboctahedron",
	          72, 168, 84,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Cuboctaedro Truncado Octgono-Perfurado",
                 "Octagon-Drilled Truncated Cuboctahedron"},
                "off",
                "stewart-octagon-drilled-truncated-cuboctahedron",
	          72, 168, 88,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Cuboctaedro Truncado Tetra-Quadrado-Perfurado",
                 "Four-Square-Drilled Truncated Cuboctahedron"},
                "off",
                "stewart-four-square-drilled-truncated-cuboctahedron",
	          72, 136, 60,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Cuboctaedro Truncado Biquadrado-Perfurado",
                 "Two-Square-Double-Drilled Truncated Cuboctahedron"},
                "off",
                "stewart-two-square-double-drilled-truncated-cuboctahedron",
	          72, 132, 58,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Cuboctaedro Truncado com Dois Buracos Perfurados",
                 "Two-Hole Drilled Truncated Cuboctahedron"},
                "off",
                "stewart-two-hole-drilled-truncated-cuboctahedron",
	          72, 144, 62,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Cuboctaedro Truncado Duplamente Perfurado",
                 "Double Drilled Truncated Cuboctahedron"},
                "off",
                "stewart-double-drilled-truncated-cuboctahedron",
	          80, 192, 90,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Variao do Cuboctaedro Truncado Perfurado",
                 "Drilled Truncated Cuboctahedron Variation"},
                "off",
                "stewart-drilled-truncated-cuboctahedron-variation",
	          60, 128, 68,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Cuboctaedro Dissecado por Expanso em Prisma",
                 "Prism-Expanded Dissected Cuboctahedron"},
                "off",
                "stewart-prism-expanded-dissected-cuboctahedron",
	          62, 168, 86,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Rombicosidodecaedro Perfurado",
                 "Drilled Rhombicosidodecaedro"},
                "off",
                "stewart-drilled-rhombicosidodecahedron",
	          80, 168, 80,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Dodecaedro Truncado Perfurado",
                 "Drilled Truncated Dodecahedron"},
                "off",
                "stewart-drilled-truncated-dodecahedron",
	          140, 420, 260,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Dodecaedro Truncado Parcialmente Perfurado",
                 "Partially Drilled Truncated Dodecahedron"},
                "off",
                "stewart-partially-drilled-truncated-dodecahedron",
	          115, 290, 165,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Toro Cortado",
                 "Torus Slice"},
                "off",
                "stewart-torus-slice",
	            50, 120, 70,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Icosidodecaedro Truncado Rotunda-Perfurado",
                 "Rotunda-Drilled Truncated Icosidodecahedron"},
                "off",
                "stewart-rotunda-drilled-truncated-icosidodecahedron",
	          240, 540, 280,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Icosidodecaedro Truncado Cpula-Perfurado",
                 "Cupola-Drilled Truncated Icosidodecahedron"},
                "off",
                "stewart-cupola-drilled-truncated-icosidodecahedron",
	          240, 600, 340,
                true, true, true,
                false,
                true));
        i++;

        toroids.addModel(i, new Model(toroids_trans,
                new String[]
                {"Gnero 87",
                 "Genus 87"},
                "off",
                "stewart-genus-87-new-record",
	          1238, 3708, 2298,
                true, true, true,
                false,
                true));
        i++;

        // LEONARDO
        i = 0;
        leonardo = new Category(leonardo_trans, 5);

        leonardo.addModel(i, new Model(leonardo_trans,
                new String[]
                {"Cosmograma 1",
                 "Cosmogram 1"},
                "off",
                "leonardo-cosmogram-1",
	            280, 720, 360,
                false, true, true,
                false,
                true));
        leonardo.getModel(i).setImproveUnfolding(true, 6);
        i++;

        leonardo.addModel(i, new Model(leonardo_trans,
                new String[]
                {"Cosmograma 2",
                 "Cosmogram 2"},
                "off",
                "leonardo-cosmogram-2",
	            280, 720, 360,
                false, true, true,
                false,
                true));
        leonardo.getModel(i).setImproveUnfolding(true, 6);
        i++;

        leonardo.addModel(i, new Model(leonardo_trans,
                new String[]
                {"Cosmograma 3",
                 "Cosmogram 3"},
                "off",
                "leonardo-cosmogram-3",
	            280, 720, 360,
                false, true, true,
                false,
                true));
        leonardo.getModel(i).setImproveUnfolding(true, 6);
        i++;

        leonardo.addModel(i, new Model(leonardo_trans,
                new String[]
                {"Cosmograma 4",
                 "Cosmogram 4"},
                "off",
                "leonardo-cosmogram-4",
	            280, 720, 360,
                false, true, true,
                false,
                true));
        leonardo.getModel(i).setImproveUnfolding(true, 6);
        i++;
        
        leonardo.addModel(i, new Model(leonardo_trans,
                new String[]
                {"Cosmograma 5",
                 "Cosmogram 5"},
                "off",
                "leonardo-cosmogram-5",
	            280, 720, 360,
                false, true, true,
                false,
                true));
        leonardo.getModel(i).setImproveUnfolding(true, 6);
        i++;        

        // ANIMAL
        i = 0;
        animal = new Category(animal_trans, 4);

        animal.addModel(i, new Model(animal_trans,
               new String[]
               {"Cavalo",
                "Horse"},
               "off",
               "animal-horse",
	           173, 513, 342,
               true, true, true,
               false,
               true));
        animal.getModel(i).setImproveUnfolding(true, 6);
        i++;

        animal.addModel(i, new Model(animal_trans,
                 new String[]
                 {"Coelho",
                  "Bunny"},
                 "off",
                 "animal-bunny",
	             157, 465, 310,
                 true, true, true,
                 false,
                 true));
        animal.getModel(i).setImproveUnfolding(true, 6);
        i++;

        animal.addModel(i, new Model(animal_trans,
               new String[]
               {"Gatinho",
                "Kitten"},
               "off",
               "animal-kitten",
	           175, 525, 350,
               true, true, true,
               false,
               true));
        animal.getModel(i).setImproveUnfolding(true, 6);
        i++;
          
        animal.addModel(i, new Model(animal_trans,
               new String[]
               {"Dromedrio",
                "Dromedary"},
               "off",
                "animal-dromedary",
	            443, 1329, 886,
                true, true, true,
                false,
                true));
        animal.getModel(i).setImproveUnfolding(true, 5);
        i++;
        
        
        // HEXAHEDRA
        i = 0;
        hexahedra = new Category(hexahedra_trans, 13);
        
        hexahedra.addModel(i, new Model(hexahedra_trans,
    	          new String[]
    	          {"Hexaedro 3, 3, 3, 3, 3, 3",
    	           "Hexahedron 3, 3, 3, 3, 3, 3"},
    	          "off",
    	          "hexahedra-333333",
    	          5, 9, 6,
    	          true, true, true,
    	          true,
    	          true));
        i++;
          
        hexahedra.addModel(i, new Model(hexahedra_trans,
  	              new String[]
  	              {"Hexaedro 5, 3, 3, 3, 3, 3",
  	               "Hexahedron 5, 3, 3, 3, 3, 3"},
  	               "off",
  	              "hexahedra-533333",
  	              6, 10, 6,
  	              true, true, true,
  	              true,
  	              true));
        i++;
        
        hexahedra.addModel(i, new Model(hexahedra_trans,
  	              new String[]
  	              {"Hexaedro 4, 4, 3, 3, 3, 3",
  	               "Hexahedron 4, 4, 3, 3, 3, 3"},
  	              "off",
  	              "hexahedra-443333",
  	              6, 10, 6,
  	              true, true, true,
  	              true,
  	              true));
        i++;
        
        hexahedra.addModel(i, new Model(hexahedra_trans,
    	          new String[]
    	          {"Hexaedro 5, 4, 4, 3, 3, 3",
    	           "Hexahedron 5, 4, 4, 3, 3, 3"},
    	          "off",
    	          "hexahedra-544333",
    	          7, 11, 6,
    	          true, true, true,
    	          true,
    	          true));
        i++;        
          
        hexahedra.addModel(i, new Model(hexahedra_trans,
   	             new String[]
    	         {"Hexaedro 4, 4, 4, 4, 3, 3",
    	          "Hexahedron 4, 4, 4, 4, 3, 3"},
    	         "off",
    	         "hexahedra-444433",
    	         7, 11, 6,
    	         true, true, true,
    	         true,
    	         true));
        i++;
        
        hexahedra.addModel(i, new Model(hexahedra_trans,
  	             new String[]
   	             {"Hexaedro 5, 5, 4, 4, 3, 3",
   	              "Hexahedron 5, 5, 4, 4, 3, 3"},
   	              "off",
   	             "hexahedra-554433",
   	             8, 12, 6,
   	             true, true, true,
   	             true,
   	             true));
        i++;        
        
        hexahedra.addModel(i, new Model(hexahedra_trans,
 	             new String[]
  	             {"Hexaedro 4, 4, 4, 4, 4, 4 (Cubo)",
  	              "Hexahedron 4, 4, 4, 4, 4, 4 (Cube)"},
  	              "off",
  	             "hexahedra-444444",
  	             8, 12, 6,
  	             true, true, true,
  	             true,
  	             true));
        i++;        
         
        hexahedra.addModel(i, new Model(hexahedra_trans,
  	          new String[]
  	          {"Hexaedro 4, 4, 4, 4, 4, 4 (Prisma Reto de Base Quadrada)",
  	           "Hexahedron 4, 4, 4, 4, 4, 4 (NonRegular Right Square Prism)"},
  	          "off",
  	          "hexahedra-right-square-prism",
  	          8, 12, 6,
  	          true, true, true,
  	          true,
  	          true));
        i++;
        
        hexahedra.addModel(i, new Model(hexahedra_trans,
  	          new String[]
  	          {"Hexaedro 4, 4, 4, 4, 4, 4 (Prisma Oblquo de Base Quadrada)",
  	           "Hexahedron 4, 4, 4, 4, 4, 4 (NonRegular Oblique Square Prism)"},
  	          "off",
  	          "hexahedra-oblique-square-prism",
  	          8, 12, 6,
  	          true, true, true,
  	          true,
  	          true));
        i++;        
        
        hexahedra.addModel(i, new Model(hexahedra_trans,
  	          new String[]
  	          {"Hexaedro 4, 4, 4, 4, 4, 4 (Romboedro Oblquo)",
  	           "Hexahedron 4, 4, 4, 4, 4, 4 (NonRegular Oblique Rhombohedron)"},
  	          "off",
  	          "hexahedra-oblique-rhombohedron",
  	          8, 12, 6,
  	          true, true, true,
  	          true,
  	          true));
        i++;
        
        hexahedra.addModel(i, new Model(hexahedra_trans,
  	          new String[]
  	          {"Hexaedro 4, 4, 4, 4, 4, 4 (Paraleleppedo Reto Retngulo)",
  	           "Hexahedron 4, 4, 4, 4, 4, 4 (NonRegular Right Rectangle Parallelepiped)"},
  	          "off",
  	          "hexahedra-right-rectangle-parallelepiped",
  	          8, 12, 6,
  	          true, true, true,
  	          true,
  	          true));
        i++;

        hexahedra.addModel(i, new Model(hexahedra_trans,
  	          new String[]
  	          {"Hexaedro 4, 4, 4, 4, 4, 4 (Paraleleppedo Oblquo)",
  	           "Hexahedron 4, 4, 4, 4, 4, 4 (NonRegular Oblique Parallelepiped)"},
  	          "off",
  	          "hexahedra-oblique-parallelepiped",
  	          8, 12, 6,
  	          true, true, true,
  	          true,
  	          true));
        i++;
        
        hexahedra.addModel(i, new Model(hexahedra_trans,
  	          new String[]
  	          {"Hexaedro 4, 4, 4, 4, 4, 4 (Paraleleppedo Reto)",
  	           "Hexahedron 4, 4, 4, 4, 4, 4 (NonRegular Right Parallelepiped)"},
  	          "off",
  	          "hexahedra-right-parallelepiped",
  	          8, 12, 6,
  	          true, true, true,
  	          true,
  	          true));
        i++;        
        
        
        // ISOHEDRA
        i = 0;
        isohedra = new Category(isohedra_trans, 30);
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
               {"Cubo",
                 "Cube"},
                "off",
                "isohedra-cube",
   	            8, 12, 6,
                true, true, true,
                true,
                true));            
        i++;
         
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Dodecaedro Disdiakis",
                 "Disdyakis Dodecahedron"},
                "off",
                "isohedra-disdyakis-dodecahedron",
    	        26, 72, 48,
                true, true, true,
                true,
                true));            
        i++;
            
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Hexecontaedro Deltoidal",
                 "Deltoidal Hexecontahedron"},
                "off",
                "isohedra-deltoidal-hexecontahedron",
     	        62, 120, 60,
                true, true, true,
                true,
                true));            
        i++;
             
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
               {"Icositetraedro Deltoidal",
                "Deltoidal Icositetrahedron"},
               "off",
               "isohedra-deltoidal-icositetrahedron",
      	       26, 48, 24,
               true, true, true,
               true,
               true));            
        i++;
              
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Triacontaedro Disdiakis",
                 "Disdyakis Triacontahedron"},
                "off",
                "isohedra-disdyakis-triacontahedron",
       	        62, 180, 120,
                true, true, true,
                true,
                true));            
         i++;
               
         isohedra.addModel(i, new Model(isohedra_trans,
                 new String[]
                 {"Dodecaedro",
                  "Dodecahedron"},
                 "off",
                 "isohedra-dodecahedron",
                 20, 30, 12,
                 true, true, true,
                 true,
                 true));            
        i++;                
           
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Dodecaedro Dyakis",
                 "Dyakis Dodecahedron"},
                "off",
                "isohedra-dyakis-dodecahedron",
                26, 48, 24,
                true, true, true,
                true,
                true));            
        i++;
                 
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Tetraedro Hexakis",
                 "Hexakis Tetrahedron"},
                "off",
                "isohedra-hexakis-tetrahedron",
                14, 36, 24,
                true, true, true,
                true,
                true));            
        i++;
                  
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Icosaedro",
                 "Icosahedron"},
                "off",
                "isohedra-icosahedron",
                12, 30, 20,
                true, true, true,
                true,
                true));            
        i++;
                   
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Tetraedro Issceles",
                 "Isosceles Tetrahedron"},
                "off",
                "isohedra-isosceles-tetrahedron",
                4, 6, 4,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Dodecaedro Pentagonal Octaedral",        		
                 "Octahedral Pentagonal Dodecahedron"},
                "off",
                "isohedra-octahedral-pentagonal-dodecahedron",
                20, 30, 12,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Octaedro",        		
                 "Octahedron"},
                "off",
                "isohedra-octahedron",
                6, 12, 8,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Hexecontaedro Pentagonal",        		
                 "Pentagonal Hexecontahedron"},
                "off",
                "isohedra-pentagonal-hexecontahedron",
                92, 150, 60,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Icositetraedro Pentagonal",        		
                 "Pentagonal Icositetrahedron"},
                "off",
                "isohedra-pentagonal-icositetrahedron",
                38, 60, 24,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Dodecaedro Pentakis",        		
                 "Pentakis Dodecahedron"},
                "off",
                "isohedra-pentakis-dodecahedron",
                32, 90, 60,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Dodecaedro Rmbico",        		
                 "Rhombic Dodecahedron"},
                "off",
                "isohedra-rhombic-dodecahedron",
                14, 24, 12,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Triacontaedro Rmbico",        		
                 "Rhombic Triacontahedron"},
                "off",
                "isohedra-rhombic-triacontahedron",
                32, 60, 30,
                true, true, true,
                true,
                true));            
        i++;     
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Tetraedro Escaleno",        		
                 "Scalene Tetrahedron"},
                "off",
                "isohedra-scalene-tetrahedron",
                4, 6, 4,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Dodecaedro Pentagonal Tetragonal",        		
                 "Tetragonal Pentagonal Dodecahedron"},
                "off",
                "isohedra-tetragonal-pentagonal-dodecahedron",
                20, 30, 12,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Tetraedro",        		
                 "Tetrahedron"},
                "off",
                "isohedra-tetrahedron",
                4, 6, 4,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Hexaedro Tetrakis",        		
                 "Tetrakis Hexahedron"},
                "off",
                "isohedra-tetrakis-hexahedron",
                14, 36, 24,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Diedro Trapezoidal Bsico",        		
                 "Trapezoidal Dihedron (Basic)"},
                "off",
                "isohedra-trapezoidal-dihedron",
                8, 12, 6,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Diedro Trapezoidal Assimtrico",        		
                 "Trapezoidal Dihedron (Skewed)"},
                "off",
                "isohedra-trapezoidal-dihedron-skewed",
                8, 12, 6,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Dodecaedro Trapezoidal",        		
                 "Trapezoidal Dodecahedron"},
                "off",
                "isohedra-trapezoidal-dodecahedron",
                14, 24, 12,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Icosaedro Triakis",        		
                 "Triakis Icosahedron"},
                "off",
                "isohedra-triakis-icosahedron",
                32, 90, 60,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Octaedro Triakis",        		
                 "Triakis Octahedron"},
                "off",
                "isohedra-triakis-octahedron",
                14, 36, 24,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Tetraedro Triakis",        		
                 "Triakis Tetrahedron"},
                "off",
                "isohedra-triakis-tetrahedron",
                8, 18, 12,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Diedro Triangular",        		
                 "Triangular Dihedron"},
                "off",
                "isohedra-triangular-dihedron",
                10, 24, 16,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Diedro Triangular Assimtrico Dentro-Fora",        		
                 "Triangular Dihedron Skewed In-Out"},
                "off",
                "isohedra-triangular-dihedron-skewed-in-out",
                10, 24, 16,
                true, true, true,
                true,
                true));            
        i++;
        
        isohedra.addModel(i, new Model(isohedra_trans,
                new String[]
                {"Diedro Triangular Assimtrico Para Cima-Para Baixo",        		
                 "Triangular Dihedron Skewed Up-Down"},
                "off",
                "isohedra-triangular-dihedron-skewed-up-down",
                6, 12, 8,
                true, true, true,
                true,
                true));            
        i++;
}
 
 // PLATONIC
 i = 0;
 platonic = new Category(platonic_trans, 5);

 platonic.addModel(i, new Model(platonic_trans,
         new String[]
         {"Tetraedro",
          "Tetrahedron",
			 "Tetraeder"},
         "off",
         "platonic-tetrahedron",
       4, 6, 4,
         true, true, true,
         true,
         true));
 i++;

 platonic.addModel(i, new Model(platonic_trans,
         new String[]
         {"Cubo",
          "Cube",
			 "Kocka"},
         "off",
         "platonic-cube",
       8, 12, 6,
         true, true, true,
         true,
         true));
 i++;

 platonic.addModel(i, new Model(platonic_trans,
         new String[]
         {"Octaedro",
          "Octahedron",
			 "Oktaeder"},
         "off",
         "platonic-octahedron",
       6, 12, 8,
         true, true, true,
         true,
         true));
 i++;

 platonic.addModel(i, new Model(platonic_trans,
         new String[]
         {"Dodecaedro",
          "Dodecahedron",
			 "Dodekaeder"},
         "off",
         "platonic-dodecahedron",
       20, 30, 12,
         true, true, true,
         true,
         true));
 i++;

 platonic.addModel(i, new Model(platonic_trans,
         new String[]
         {"Icosaedro",
          "Icosahedron",
			 "Ikozaeder"},
         "off",
         "platonic-icosahedron",
       12, 30, 20,
         true, true, true,
         true,
         true));
 i++;

 // ARCHIMEDEAN
 i = 0;
 archimedean = new Category(archimedean_trans, 13);

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Tetraedro Truncado",
          "Truncated Tetrahedron", 
			 "Prisekani etverec"},
         "off",
         "archimedean-truncated-tetrahedron",
       12, 18, 8,
         true, true, true,
         true,
         true));
 i++;

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Cuboctaedro",
          "Cuboctahedron",
			 "Kockin osmerec"},
         "off",
         "archimedean-cuboctahedron",
       12, 24, 14,
         true, true, true,
         true,
         true));
 i++;

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Octaedro Truncado",
          "Truncated Octahedron",
			 "Prisekani osmerec"},
         "off",
         "archimedean-truncated-octahedron",
       24, 36, 14,
         true, true, true,
         true,
         true));
 i++;

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Cubo Truncado",
          "Truncated Cube",
			 "Prisekana kocka"},
         "off",
         "archimedean-truncated-cube",
       24, 36, 14,
         true, true, true,
         true,
         true));
 i++;

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Pequeno Rombicuboctaedro",
          "Small Rhombicuboctahedron",
			 "Okrnjeni kockin osmerec"},
         "off",
         "archimedean-rhombicuboctahedron",
       24, 48, 26,
         true, true, true,
         true,
         true));
 i++;

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Grande Rombicuboctaedro",
          "Great Rhombicuboctahedron",
			 "Prisekani kockin osmerec"},
         "off",
         "archimedean-truncated-cuboctahedron",
       48, 72, 26,
         true, true, true,
         true,
         true));
 i++;

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Cubo Achatado",
          "Snub Cube",
			 "Prerezana kocka"},
         "off",
         "archimedean-snub-cube",
       24, 60, 38,
         true, true, true,
         true,
         true));
 i++;

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Icosidodecaedro",
          "Icosidodecahedron",
			 "Dvajseterev dvanajsterec"},
         "off",
         "archimedean-icosidodecahedron",
       30, 60, 32,
         true, true, true,
         true,
         true));
 i++;

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Icosaedro Truncado",
          "Truncated Icosahedron",
			 "Prisekani dvajseterec"},
         "off",
         "archimedean-truncated-icosahedron",
       60, 90, 32,
         true, true, true,
         true,
         true));
 i++;

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Dodecaedro Truncado",
          "Truncated Dodecahedron",
			 "Prisekani dvanajsterec"},
         "off",
         "archimedean-truncated-dodecahedron",
       60, 90, 32,
         true, true, true,
         true,
         true));
 i++;

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Pequeno Rombicosidodecaedro",
          "Small Rhombicosidodecahedron",
			 "Okrnjeni dvajseterev dvanajsterec"},
         "off",
         "archimedean-rhombicosidodecahedron",
       60, 120, 62,
         true, true, true,
         true,
         true));
 i++;

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Grande Rombicosidodecaedro",
          "Great Rhombicosidodecahedron",
			 "Prisekani dvajseterev dvanajsterec"},
         "off",
         "archimedean-truncated-icosidodecahedron",
       120, 180, 62,
         true, true, true,
         true,
         true));
 i++;

 archimedean.addModel(i, new Model(archimedean_trans,
         new String[]
         {"Dodecaedro Achatado",
          "Snub Dodecahedron",
			 "Prirezani dvanajsterec"},
         "off",
         "archimedean-snub-dodecahedron",
       60, 150, 92,
         true, true, true,
         true,
         true));
 i++;

 // JOHNSON
 i = 0;
 johnson = new Category(johnson_trans, 92);

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Pirmide Quadrada (J1)",
          "Square Pyramid (J1)",
			 "Kvadratna piramida (J1)"},
         "off",
         "johnson-j01-square-pyramid",
       5, 8, 5,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Pirmide Pentagonal (J2)",
          "Pentagonal Pyramid (J2)",
			 "Petkotna piramida"},
         "off",
         "johnson-j02-pentagonal-pyramid",
       6, 10, 6,
         true, true, true,
         true,
         true));
 i++;

johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Cpula Triangular (J3)",
          "Triangular Cupola (J3)",
			 "Trikotna kupola (J3)"},
         "off",
         "johnson-j03-triangular-cupola",
       9, 15, 8,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Cpula Quadrada (J4)",
          "Square Cupola (J4)",
			 "Kvadratna kupola (J4)"},
         "off",
         "johnson-j04-square-cupola",
       12, 20, 10,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Cpula Pentagonal (J5)",
          "Pentagonal Cupola (J5)",
			 "Petkotna kupola (J5)"},
         "off",
         "johnson-j05-pentagonal-cupola",
       15, 25, 12,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Rotunda Pentagonal (J6)",
          "Pentagonal Rotunda (J6)",
			 "Petkotna rotunda (J6)"},
         "off",
         "johnson-j06-pentagonal-rotunda",
       20, 35, 17,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Pirmide Triangular Alongada (J7)",
          "Elongated Triangular Pyramid (J7)",
			 "Podaljana trikotna piramida (J7)"},
         "off",
         "johnson-j07-elongated-triangular-pyramid",
       7, 12, 7,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Pirmide Quadrada Alongada (J8)",
          "Elongated Square Pyramid (J8)",
			 "Podaljana kvadratna piramida (J8)"},
         "off",
         "johnson-j08-elongated-square-pyramid",
       9, 16, 9,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Pirmide Pentagonal Alongada (J9)",
          "Elongated Pentagonal Pyramid (J9)",
			 "Podaljana petkotna piramida (J9)"},
         "off",
         "johnson-j09-elongated-pentagonal-pyramid",
       11, 20, 11,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Pirmide Quadrada Giroalongada (J10)",
          "Gyroelongated Square Pyramid (J10)", 
			 "Poevno podaljana kvadratna piramida (J10)"},
         "off",
         "johnson-j10-gyroelongated-square-pyramid",
       9, 20, 13,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Pirmide Pentagonal Giroalongada (J11)",
          "Gyroelongated Pentagonal Pyramid (J11)",
			 "Poevno podaljana petkotna piramida (J11)"},
         "off",
         "johnson-j11-gyroelongated-pentagonal-pyramid",
       11, 25, 16,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dipirmide Triangular (J12)",
          "Triangular Dipyramid (J12)",
			 "Trikotna bipiramida (J12)"},
         "off",
         "johnson-j12-triangular-dipyramid",
       5, 9, 6,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dipirmide Pentagonal (J13)",
          "Pentagonal Dipyramid (J13)",
			 "Petkotna bipiramida (J13)"},
         "off",
         "johnson-j13-pentagonal-dipyramid",
       7, 15, 10,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dipirmide Triangular Alongada (J14)",
          "Elongated Triangular Dipyramid (J14)",
			 "Podaljana trikotna bipiramida (J14)"},
         "off",
         "johnson-j14-elongated-triangular-dipyramid",
       8, 15, 9,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dipirmide Quadrada Alongada (J15)",
          "Elongated Square Dipyramid (J15)",
			 "Podaljana kvadratna bipiramida (J15)"},
         "off",
         "johnson-j15-elongated-square-dipyramid",
       10, 20, 12,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dipirmide Pentagonal Alongada (J16)",
          "Elongated Pentagonal Dipyramid (J16)",
			 "Podaljana petkotna dipiramida (J16)"},
         "off",
         "johnson-j16-elongated-pentagonal-dipyramid",
       12, 25, 15,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dipirmide Quadrada Giroalongada (J17)",
          "Gyroelongated Square Dipyramid (J17)",
			 "Poevno podaljana kvadratna bipiramida (J17)"},
         "off",
         "johnson-j17-gyroelongated-square-dipyramid",
       10, 24, 16,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Cpula Triangular Alongada (J18)",
          "Elongated Triangular Cupola (J18)",
			 "Podaljana trikotna kupola (J18)"},
         "off",
         "johnson-j18-elongated-triangular-cupola",
       15, 27, 14,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Cpula Quadrada Alongada (J19)",
          "Elongated Square Cupola (J19)",
			 "Podaljana kvadratna kupola (J19)"},
         "off",
         "johnson-j19-elongated-square-cupola",
       20, 36, 18,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Cpula Pentagonal Alongada (J20)",
          "Elongated Pentagonal Cupola (J20)",
			 "Podaljana petkotna kupola (J20)"},
         "off",
         "johnson-j20-elongated-pentagonal-cupola",
       25, 45, 22,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Rotunda Pentagonal Alongada (J21)",
          "Elongated Pentagonal Rotunda (J21)",
			 "Podaljana petkotna rotunda (J21)"},
         "off",
         "johnson-j21-elongated-pentagonal-rotunda",
       30, 55, 27,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Cpula Triangular Giroalongada (J22)",
          "Gyroelongated Triangular Cupola (J22)",
			 "Poevno podaljana trikotna kupola (J22)"},
         "off",
         "johnson-j22-gyroelongated-triangular-cupola",
       15, 33, 20,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Cpula Quadrada Giroalongada (J23)",
          "Gyroelongated Square Cupola (J23)",
			 "Poevno podaljana kvadratna kupola (J23)"},
         "off",
         "johnson-j23-gyroelongated-square-cupola",
       20, 44, 26,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Cpula Pentagonal Giroalongada (J24)",
          "Gyroelongated Pentagonal Cupola (J24)",
			 "Poevno podaljana petkotna kupola (J24)"},
         "off",
         "johnson-j24-gyroelongated-pentagonal-cupola",
       25, 55, 32,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Rotunda Pentagonal Giroalongada (J25)",
          "Gyroelongated Pentagonal Rotunda (J25)",
			 "Poevno podaljana petkotna rotunda (J25)"},
         "off",
         "johnson-j25-gyroelongated-pentagonal-rotunda",
       30, 65, 37,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Gyrobifastigium (J26)",
          "Gyrobifastigium (J26)",
			 "Gyrobifastigium (J26)"},
         "off",
         "johnson-j26-gyrobifastigium",
       8, 14, 8,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Ortobicpula Triangular (J27)",
          "Triangular Orthobicupola (J27)", 
			 "Trikotna pravokotna bikupola"},
         "off",
         "johnson-j27-triangular-orthobicupola",
       12, 24, 14,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Ortobicpula Quadrada (J28)",
          "Square Orthobicupola (J28)",
			 "Kvadratna pravokotna bikupola (J28)"},
         "off",
         "johnson-j28-square-orthobicupola",
       16, 32, 18,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Girobicpula Quadrada (J29)",
          "Square Gyrobicupola (J29)",
			 "Kvadratna zasukana bikupola (J29)"},
         "off",
         "johnson-j29-square-gyrobicupola",
       16, 32, 18,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Ortobicpula Pentagonal (J30)",
          "Pentagonal Orthobicupola (J30)",
			 "Petkotna pravokotna bikupola (J30)"},
         "off",
         "johnson-j30-pentagonal-orthobicupola",
       20, 40, 22,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Girobicpula Pentagonal (J31)",
          "Pentagonal Gyrobicupola (J31)",
			 "Petkotna zasukana bikupola (J31)"},
         "off",
         "johnson-j31-pentagonal-gyrobicupola",
       20, 40, 22,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Ortocupularrotunda Pentagonal (J32)",
          "Pentagonal Orthocupolarotunda (J32)",
			 "Petkotna pravokotna kupola rotunda (J32)"},
         "off",
         "johnson-j32-pentagonal-orthocupolarotunda",
       25, 50, 27,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Girocupularrotunda Pentagonal (J33)",
          "Pentagonal Gyrocupolarotunda (J33)",
			 "Petkotna zasukana kupola rotunda (J33)"},
         "off",
         "johnson-j33-pentagonal-gyrocupolarotunda",
       25, 50, 27,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Ortobirrotunda Pentagonal (J34)",
          "Pentagonal Orthobirotunda (J34)",
			 "Petkotna pravokotna birotunda (J34)"},
         "off",
         "johnson-j34-pentagonal-orthobirotunda",
       30, 60, 32,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Ortobicpula Triangular Alongada (J35)",
          "Elongated Triangular Orthobicupola (J35)",
			 "Podaljana trikotna pravokotna bikupola (J35)"},
         "off",
         "johnson-j35-elongated-triangular-orthobicupola",
       18, 36, 20,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Girobicpula Triangular Alongada (J36)",
          "Elongated Triangular Gyrobicupola (J36)",
			 "Podaljana trikotna zasukana bikupola (J36)"},
         "off",
         "johnson-j36-elongated-triangular-gyrobicupola",
       18, 36, 20,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Girobicpula Quadrada Alongada (J37)",
          "Elongated Square Gyrobicupola (J37)",
			 "Podaljana kvadratna zasukana bikupola (J37)"},
         "off",
         "johnson-j37-elongated-square-gyrobicupola",
       24, 48, 26,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Ortobicpula Pentagonal Alongada (J38)",
          "Elongated Pentagonal Orthobicupola (J38)",
			 "Podaljana petkotna pravokotna bikupola (J38) "},
         "off",
         "johnson-j38-elongated-pentagonal-orthobicupola",
       30, 60, 32,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Girobicpula Pentagonal Alongada (J39)",
          "Elongated Pentagonal Gyrobicupola (J39)",
			 "Podaljana petkotna zasukana bikupola (J39)"},
         "off",
         "johnson-j39-elongated-pentagonal-gyrobicupola",
       30, 60, 32,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Ortocupularrotunda Pentagonal Alongada (J40)",
          "Elongated Pentagonal Orthocupolarotunda (J40)",
			 "Podaljana petkotna pravokotna kupola rotunda (J40)"},
         "off",
         "johnson-j40-elongated-pentagonal-orthocupolarotunda",
       35, 70, 37,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Girocupularrotunda Pentagonal Alongada (J41)",
          "Elongated Pentagonal Gyrocupolarotunda (J41)",
			 "Podaljana petkotna zasukana kupola rotunda (J41)"},
         "off",
         "johnson-j41-elongated-pentagonal-gyrocupolarotunda",
       35, 70, 37,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Ortobirrotunda Pentagonal Alongada (J42)",
          "Elongated Pentagonal Orthobirotunda (J42)",
			 "Podaljana petkotna pravokotna birotunda (J42)"},
         "off",
         "johnson-j42-elongated-pentagonal-orthobirotunda",
       40, 80, 42,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Girobirrotunda Pentagonal Alongada (J43)",
          "Elongated Pentagonal Gyrobirotunda (J43)",
			 "Podaljana petkotna zasukana birotunda (J43)"},
         "off",
         "johnson-j43-elongated-pentagonal-gyrobirotunda",
       40, 80, 42,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Bicpula Triangular Giroalongada (J44)",
          "Gyroelongated Triangular Bicupola (J44)",
			 "Poevno podaljana trikotna bikupola (J44)"},
         "off",
         "johnson-j44-gyroelongated-triangular-bicupola",
       18, 42, 26,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Bicpula Quadrada Giroalongada (J45)",
          "Gyroelongated Square Bicupola (J45)",
			 "Poevno podaljana kvadratna bikupola (J45)"},
         "off",
         "johnson-j45-gyroelongated-square-bicupola",
       24, 56, 34,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Bicpula Pentagonal Giroalongada (J46)",
          "Gyroelongated Pentagonal Bicupola (J46)",
			 "Poevno podaljana petkotna bikupola (J46)"},
         "off",
         "johnson-j46-gyroelongated-pentagonal-bicupola",
       30, 70, 42,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Cupularrotunda Pentagonal Giroalongada (J47)",
          "Gyroelongated Pentagonal Cupolarotunda (J47)",
			 "Poevno podaljana petkotna kupola rotunda"},
         "off",
         "johnson-j47-gyroelongated-pentagonal-cupolarotunda",
       35, 80, 47,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Birrotunda Pentagonal Giroalongada (J48)",
          "Gyroelongated Pentagonal Birotunda (J48)",
			 "Poevno podaljana petkotna birotunda (J48"},
         "off",
         "johnson-j48-gyroelongated-pentagonal-birotunda",
       40, 90, 52,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Prisma Triangular Aumentado (J49)",
          "Augmented Triangular Prism (J49)",
			 "Poveana trikotna prizma (J49)"},
         "off",
         "johnson-j49-augmented-triangular-prism",
       7, 13, 8,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Prisma Triangular Biaumentado (J50)",
          "Biaugmented Triangular Prism (J50)",
			 "Dvakrat poveana trikotna prizma (J50)"},
         "off",
         "johnson-j50-biaugmented-triangular-prism",
       8, 17, 11,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Prisma Triangular Triaumentado (J51)",
          "Triaugmented Triangular Prism (J51)",
			 "Trikrat poveana trikotna prizma (J51)"},
         "off",
         "johnson-j51-triaugmented-triangular-prism",
       9, 21, 14,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Prisma Pentagonal Aumentado (J52)",
          "Augmented Pentagonal Prism (J52)",
			 "Poveana petkotna prizma"},
         "off",
         "johnson-j52-augmented-pentagonal-prism",
       11, 19, 10,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Prisma Pentagonal Biaumentado (J53)",
          "Biaugmented Pentagonal Prism (J53)",
			 "Dvakrat poveana petkotna prizma (J53)"},
         "off",
         "johnson-j53-biaugmented-pentagonal-prism",
       12, 23, 13,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Prisma Hexagonal Aumentado (J54)",
          "Augmented Hexagonal Prism (J54)",
			 "Poveana estkotna prizma (J54)"},
         "off",
         "johnson-j54-augmented-hexagonal-prism",
       13, 22, 11,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Prisma Hexagonal Parabiaumentado (J55)",
          "Parabiaugmented Hexagonal Prism (J55)",
			 "Vzporedno dvakrat poveana estkotna prizma (J55)"},
         "off",
         "johnson-j55-parabiaugmented-hexagonal-prism",
       14, 26, 14,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Prisma Hexagonal Metabiaumentado (J56)",
          "Metabiaugmented Hexagonal Prism (J56)",
			 "Nevzporedno dvakrat poveana estkotna prizma (J56)"},
         "off",
         "johnson-j56-metabiaugmented-hexagonal-prism",
       14, 26, 14,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Prisma Hexagonal Triaumentado (J57)",
          "Triaugmented Hexagonal Prism (J57)",
			 "Trikrat poveana estkotna prizma (J57)"},
         "off",
         "johnson-j57-triaugmented-hexagonal-prism",
       15, 30, 17,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dodecaedro Aumentado (J58)",
          "Augmented Dodecahedron (J58)",
			 "Poveani dvanajsterec"},
         "off",
         "johnson-j58-augmented-dodecahedron",
       21, 35, 16,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dodecaedro Parabiaumentado (J59)",
          "Parabiaugmented Dodecahedron (J59)",
			 "Vzporedno dvakrat poveani dvanajsterec (J59)"},
         "off",
         "johnson-j59-parabiaugmented-dodecahedron",
       22, 40, 20,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dodecaedro Metabiaumentado (J60)",
          "Metabiaugmented Dodecahedron (J60)",
			 "Nevzporedno dvakrat poveani dvanajsterec (J60)"},
         "off",
         "johnson-j60-metabiaugmented-dodecahedron",
       22, 40, 20,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dodecaedro Triaumentado (J61)",
          "Triaugmented Dodecahedron (J61)",
			 "Trojno poveani dvanajsterec (J61)"},
         "off",
         "johnson-j61-triaugmented-dodecahedron",
       23, 45, 24,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Icosaedro Metabidiminudo (J62)",
          "Metabidiminished Icosahedron (J62)",
			 "Nevzporedno dvakrat zmanjani dvajseterec (J62)"},
         "off",
         "johnson-j62-metabidiminished-icosahedron",
       10, 20, 12,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Icosaedro Tridiminudo (J63)",
          "Tridiminished Icosahedron (J63)",
			"Trikrat zmanjani dvajseterec (J63)"},
         "off",
         "johnson-j63-tridiminished-icosahedron",
       9, 15, 8,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Icosaedro Tridiminudo Aumentado (J64)",
          "Augmented Tridiminished Icosahedron (J64)",
			 "Poveani trikrat zmanjani dvajseterec (J64)"},
         "off",
         "johnson-j64-augmented-tridiminished-icosahedron",
       10, 18, 10,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Tetraedro Truncado Aumentado (J65)",
          "Augmented Truncated Tetrahedron (J65)",
			 "Razirjeni prisekani etverec (J65)"},
         "off",
         "johnson-j65-augmented-truncated-tetrahedron",
       15, 27, 14,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Cubo Truncado Aumentado (J66)",
          "Augmented Truncated Cube (J66)",
			 "Razijena prisekana kocka (J66)"},
         "off",
         "johnson-j66-augmented-truncated-cube",
       28, 48, 22,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Cubo Truncado Biaumentado (J67)",
          "Biaugmented Truncated Cube (J67)",
			 "Dvojno razijena prisekana kocka (J67)"},
         "off",
         "johnson-j67-biaugmented-truncated-cube",
       32, 60, 30,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dodecaedro Truncado Aumentado (J68)",
          "Augmented Truncated Dodecahedron (J68)",
			 "Razirjeni prisekani dvanajsterec (J68)"},
         "off",
         "johnson-j68-augmented-truncated-dodecahedron",
       65, 105, 42,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dodecaedro Truncado Parabiaumentado (J69)",
          "Parabiaugmented Truncated Dodecahedron (J69)",
			 "Vzporedno dvakrat poveani prisekani dvanajsterec"},
         "off",
         "johnson-j69-parabiaugmented-truncated-dodecahedron",
       70, 120, 52,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dodecaedro Truncado Metabiaumentado (J70)",
          "Metabiaugmented Truncated Dodecahedron (J70)",
			 "Nevzporedno dvakrat poveani prisekani dvanajsterec"},
         "off",
         "johnson-j70-metabiaugmented-truncated-dodecahedron",
       70, 120, 52,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Dodecaedro Truncado Triaumentado (J71)",
          "Triaugmented Truncated Dodecahedron (J71)",
			 "Trikrat poveani prisekani dvanajsterec"},
         "off",
         "johnson-j71-triaugmented-truncated-dodecahedron",
       75, 135, 62,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Giro-Rombicosidodecaedro (J72)",
          "Gyrate-Rhombicosidodecahedron (J72)",
			 "Zasukani okrnjeni dvajseterev dvanajsterec (J72)"},
         "off",
         "johnson-j72-gyrate-rhombicosidodecahedron",
       60, 120, 62,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Parabigiro-Rombicosidodecaedro (J73)",
          "Parabigyrate-Rhombicosidodecahedron (J73)",
			 "Vzporedno dvakrat zasukani okrnjeni dvajseterev dvanajsterec (J73)"},
         "off",
         "johnson-j73-parabigyrate-rhombicosidodecahedron",
       60, 120, 62,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Metabigiro-Rombicosidodecaedro (J74)",
          "Metabigyrate-Rhombicosedodecahedron (J74)",
			 "Nevzporedno dvakrat zasukani okrnjeni dvajseterev dvanajsterec (J74)"},
         "off",
         "johnson-j74-metabigyrate-rhombicosidodecahedron",
       60, 120, 62,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Trigiro-Rombicosidodecaedro (J75)",
          "Trigyrate-Rhombicosidodecahedron (J75)",
			 "Trikrat zasukani okrnjeni dvajseterev dvanajsterec (J75)"},
         "off",
         "johnson-j75-trigyrate-rhombicosidodecahedron",
       60, 120, 62,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Rombicosidodecaedro Diminudo (J76)",
          "Diminished Rhombicosidodecahedron (J76)",
			 "Zmanjani okrnjeni dvajseterev dvanajsterec (J76)"},
         "off",
         "johnson-j76-diminished-rhombicosidodecahedron",
       55, 105, 52,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Rombicosidodecaedro Paragirodiminudo (J77)",
          "Paragyrate Diminished Rhombicosidodecahedron (J77)",
			 "Vzporedno zmanjani okrnjeni dvajseterev dvanajsterec (J77)"},
         "off",
         "johnson-j77-paragyrate-diminished-rhombicosidodecahedron",
       55, 105, 52,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Rombicosidodecaedro Metagirodiminudo (J78)",
          "Metagyrate Diminished Rhombicosidodecahedron (J78)",
			 "Nevzporedno zmanjani okrnjeni dvajseterev dvanajsterec (J78)"},
         "off",
         "johnson-j78-metagyrate-diminished-rhombicosidodecahedron",
       55, 105, 52,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Rombicosidodecaedro Bigirodiminudo (J79)",
          "Bigyrate Diminished Rhombicosidodecahedron (J79)",
			 "Dvakrat zasukani zmanjani okrnjeni dvajseterev dvanajsterec (J79)"},
         "off",
         "johnson-j79-bigyrate-diminished-rhombicosidodecahedron",
       55, 105, 52,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Rombicosidodecaedro Parabidiminudo (J80)",
          "Parabidiminished Rhombicosidodecahedron (J80)",
			 "Vzporedno dvakrat zmanjani okrnjeni dvajseterev dvanajsterec (J80)"},
         "off",
         "johnson-j80-parabidiminished-rhombicosidodecahedron",
       50, 90, 42,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Rombicosidodecaedro Metabidiminudo (J81)",
          "Metabidiminished Rhombicosidodecahedron (J81)",
			 "Nevzporedno dvakrat zmanjani okrnjeni dvajseterev dvanajsterec (J81)"},
         "off",
         "johnson-j81-metabidiminished-rhombicosidodecahedron",
       50, 90, 42,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Rombicosidodecaedro Girobidiminudo (J82)",
          "Gyrate Bidiminished Rhombicosidodecahedron (J82)",
			 "Zasukani dvakrat zmanjani okrnjeni dvajseterev dvanajsterec (J82)"},
         "off",
         "johnson-j82-gyrate-bidiminished-rhombicosidodecahedron",
       50, 90, 42,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Rombicosidodecaedro Tridiminudo (J83)",
          "Tridiminished Rhombicosidodecahedron (J83)",
			 "Trikrat zmanjani okrnjeni dvajseterev dvanajsterec (J83)"},
         "off",
         "johnson-j83-tridiminished-rhombicosidodecahedron",
       45, 75, 32,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Disfenide Achatado (J84)",
          "Snub-Disphenoid (J84)",
			 "Snub-Disphenoid (J84)"},
         "off",
         "johnson-j84-snub-disphenoid",
       8, 18, 12,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Antiprisma Quadrado Achatado (J85)",
          "Snub Square Antiprism (J85)",
			 "Prirezana kvadratna antiprizma"},
         "off",
         "johnson-j85-snub-square-antiprism",
       16, 40, 26,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Esfenocorona (J86)",
          "Sphenocorona (J86)",
			 "Klinasta krona (J86)"},
         "off",
         "johnson-j86-sphenocorona",
       10, 22, 14,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Esfenocorona Aumentada (J87)",
          "Augmented Sphenocorona (J87)",
			 "Poveana klinasta krona (J87)"},
         "off",
         "johnson-j87-augmented-sphenocorona",
       11, 26, 17,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Esfenomegacorona (J88)",
          "Sphenomegacorona (J88)",
			 "Velika klinasta krona (J88)"},
         "off",
         "johnson-j88-sphenomegacorona",
       12, 28, 18,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Hebesfenomegacorona (J89)",
          "Hebesphenomegacorona (J89)",
			 "Trilunska velika krona (J89)"},
         "off",
         "johnson-j89-hebesphenomegacorona",
       14, 33, 21,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Disfenocingulum (J90)",
          "Disphenocingulum (J90)",
			 "Dvoklinski pas (J90)"},
         "off",
         "johnson-j90-disphenocingulum",
       16, 38, 24,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Bilunabirrotunda (J91)",
          "Bilunabirotunda (J91)",
			 "Bilunabirotunda (J91)"},
         "off",
         "johnson-j91-bilunabirotunda",
       14, 26, 14,
         true, true, true,
         true,
         true));
 i++;

 johnson.addModel(i, new Model(johnson_trans,
         new String[]
         {"Hebesfenorrotunda Triangular (J92)",
          "Triangular Hebesphenorotunda (J92)",
			 "Trikotna trilunska rotunda (J92)"},
         "off",
         "johnson-j92-triangular-hebesphenorotunda",
       18, 36, 20,
         true, true, true,
         true,
         true));
 i++;

 // CATALAN
 i = 0;
 catalan = new Category(catalan_trans, 13);

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Tetraedro Triakis",
          "Triakistetrahedron",
			 "Triakistetrahedron"},
         "off",
         "catalan-triakistetrahedron",
       8, 18, 12,
         true, true, true,
         true,
         true));
 i++;

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Dodecaedro Rmbico",
          "Rhombic Dodecahedron",
			 "Rombski dodekaeder"},
         "off",
         "catalan-rhombic-dodecahedron",
       14, 24, 12,
         true, true, true,
         true,
         true));
 i++;

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Hexaedro Tetrakis",
          "Tetrakishexahedron",
			 "Tetrakishexahedron"},
         "off",
         "catalan-tetrakishexahedron",
       14, 36, 24,
         true, true, true,
         true,
         true));
 i++;

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Octaedro Triakis",
          "Triakisoctahedron",
			 "Triakisoctahedron"},
         "off",
         "catalan-triakisoctahedron",
       14, 36, 24,
         true, true, true,
         true,
         true));
 i++;

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Icositetraedro Deltoidal",
          "Strombic Icositetrahedron",
			 "Strombic Icositetrahedron"},
         "off",
         "catalan-strombic-icositetrahedron",
       26, 48, 24,
         true, true, true,
         true,
         true));
 i++;

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Dodecaedro Disdiakis",
          "Disdyakis Dodecahedron",
			 "Disdyakis Dodecahedron"},
         "off",
         "catalan-disdyakis-dodecahedron",
       26, 72, 48,
         true, true, true,
         true,
         true));
 i++;

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Icositetraedro Pentagonal",
          "Pentagonal Icositetrahedron",
			 "Pentagonal Icositetrahedron"},
         "off",
         "catalan-pentagonal-icositetrahedron",
       38, 60, 24,
         true, true, true,
         true,
         true));
 i++;

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Triacontaedro Rmbico",
          "Rhombic Triacontahedron",
			 "Rhombic Triacontahedron"},
         "off",
         "catalan-rhombic-triacontahedron",
       32, 60, 30,
         true, true, true,
         true,
         true));
 i++;

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Dodecaedro Pentakis",
          "Pentakis Dodecahedron",
			 "Pentakis Dodecahedron"},
         "off",
         "catalan-pentakis-dodecahedron",
       32, 90, 60,
         true, true, true,
         true,
         true));
 i++;

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Icosaedro Triakis",
          "Triakis Icosahedron",
			 "Triakis Icosahedron"},
         "off",
         "catalan-triakis-icosahedron",
       32, 90, 60,
         true, true, true,
         true,
         true));
 i++;

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Hexecontaedro Deltoidal",
          "Strombic Hexecontahedron",
			 "Strombic Hexecontahedron"},
         "off",
         "catalan-strombic-hexecontahedron",
       62, 120, 60,
         true, true, true,
         true,
         true));
 i++;

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Triacontaedro Disdiakis",
          "Disdyakis Triacontahedron",
			 "Disdyakis Triacontahedron"},
         "off",
         "catalan-disdyakis-triacontahedron",
       62, 180, 120,
         true, true, true,
         true,
         true));
 i++;

 catalan.addModel(i, new Model(catalan_trans,
         new String[]
         {"Hexecontaedro Pentagonal",
          "Pentagonal Hexecontahedron",
			 "Pentagonal Hexecontahedron"},
         "off",
         "catalan-pentagonal-hexecontahedron",
       92, 150, 60,
         true, true, true,
         true,
         true));
 i++;

 // PRISMS
 i = 0;
 prisms = new Category(prisms_trans, 30);        
 
// Regular 
prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Regular de Base Triangular",
         "Regular with Triangular Base",
			"Pravilna, ki ima za osnovno ploskev trikotnik"},
        "off",
        "prisms-regular-triangular",
       6, 9, 5,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Reto de Base Triangular",
         "Right with Triangular Base",
			"Pokonna, ki ima za osnovno ploskev trikotnik"},
        "off",
        "prisms-right-triangular",
       6, 9, 5,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Oblquo de Base Triangular",
         "Oblique with Triangular Base",
			"Poevna, ki ima za osnovno ploskev trikotnik"},
        "off",
        "prisms-oblique-triangular",
       6, 9, 5,
        true, true, true,
        true,
        true));
i++;
       
prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Regular de Base Quadrangular",
         "Regular with Quadrangular Base",
			"Pravilna, ki ima za osnovno ploskev tirikotnik"},
        "off",
        "prisms-regular-quadrangular",
       8, 12, 6,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Reto de Base Quadrangular",
         "Right with Quadrangular Base",
			"Pokonna, ki ima za osnovno ploskev tirikotnik"},
        "off",
        "prisms-right-quadrangular",
       8, 12, 6,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Oblquo de Base Quadrangular",
         "Oblique with Quadrangular Base",
			"Poevna, ki ima za osnovno ploskev tirikotnik"},
        "off",
        "prisms-oblique-quadrangular",
       8, 12, 6,
        true, true, true,
        true,
        true));
i++;       
      
prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Regular de Base Pentagonal",
         "Regular with Pentagonal Base",
			"Pravilna, ki ima za osnovno ploskev petkotnik"},
        "off",
        "prisms-regular-pentagonal",
       10, 15, 7,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Reto de Base Pentagonal",
         "Right with Pentagonal Base",
			"Pokonna, ki ima za osnovno ploskev petkotnik"},
        "off",
        "prisms-right-pentagonal",
       10, 15, 7,
        true, true, true,
        true,
        true));
i++;       

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Oblquo de Base Pentagonal",
         "Oblique with Pentagonal Base",
			"Poevna, ki ima za osnovno ploskev petkotnik"},
        "off",
        "prisms-oblique-pentagonal",
       10, 15, 7,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Regular de Base Hexagonal",
         "Regular with Hexagonal Base",
			"Pravilna, ki ima za osnovno ploskev estkotnik"},
        "off",
        "prisms-regular-hexagonal",
       12, 18, 8,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Reto de Base Hexagonal",
         "Right with Hexagonal Base",
			"Pokonna, ki ima za osnovno ploskev estkotnik"},
        "off",
        "prisms-right-hexagonal",
       12, 18, 8,
        true, true, true,
        true,
        true));
i++;       

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Oblquo de Base Hexagonal",
         "Oblique with Hexagonal Base",
			"Poevna, ki ima za osnovno ploskev estkotnik"},
        "off",
        "prisms-oblique-hexagonal",
       12, 18, 8,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Regular de Base Heptagonal",
         "Regular with Heptagonal Base",
			"Pravilna, ki ima za osnovno ploskev sedemkotnik"},
        "off",
        "prisms-regular-heptagonal",
       14, 21, 9,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Reto de Base Heptagonal",
         "Right with Heptagonal Base",
			"Pokonna, ki ima za osnovno ploskev sedemkotnik"},
        "off",
        "prisms-right-heptagonal",
       14, 21, 9,
        true, true, true,
        true,
        true));
i++;       

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Oblquo de Base Heptagonal",
         "Oblique with Heptagonal Base", 
			"Poevna, ki ima za osnovno ploskev sedemkotnik"},
        "off",
        "prisms-oblique-heptagonal",
       14, 21, 9,
        true, true, true,
        true,
        true));
i++;       

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Regular de Base Octagonal",
         "Regular with Octagonal Base",
			"Pravilna, ki ima za osnovno ploskev osemkotnik"},
        "off",
        "prisms-regular-octagonal",
       16, 24, 10,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Reto de Base Octagonal",
         "Right with Octagonal Base",
			"Pokonna, ki ima za osnovno ploskev osemkotnik"},
        "off",
        "prisms-right-octagonal",
       16, 24, 10,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Oblquo de Base Octagonal",
         "Oblique with Octagonal Base",
			"Poevna, ki ima za osnovno ploskev osemkotnik"},
        "off",
        "prisms-oblique-octagonal",
       16, 24, 10,
        true, true, true,
        true,
        true));
i++;       

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Regular de Base Eneagonal",
         "Regular with Enneagonal Base",
			"Pravilna, ki ima za osnovno ploskev devetkotnik"},
        "off",
        "prisms-regular-enneagonal",
       18, 27, 11,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Reto de Base Eneagonal",
         "Right with Enneagonal Base",
			"Pokonna, ki ima za osnovno ploskev devetkotnik"},
        "off",
        "prisms-right-enneagonal",
       18, 27, 11,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Oblquo de Base Eneagonal",
         "Oblique with Enneagonal Base",
			"Poevna, ki ima za osnovno ploskev devetkotnik"},
        "off",
        "prisms-oblique-enneagonal",
       18, 27, 11,
        true, true, true,
        true,
        true));
i++;       

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Regular de Base Decagonal",
         "Regular with Decagonal Base",
			"Pravilna, ki ima za osnovno ploskev desetkotnik"},
        "off",
        "prisms-regular-decagonal",
       20, 30, 12,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Reto de Base Decagonal",
         "Right with Decagonal Base",
			"Pokonna, ki ima za osnovno ploskev desetkotnik"},
        "off",
        "prisms-right-decagonal",
       20, 30, 12,
        true, true, true,
        true,
        true));
i++;       

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Oblquo de Base Decagonal",
         "Oblique with Decagonal Base",
			"Poevna, ki ima za osnovno ploskev desetkotnik"},
        "off",
        "prisms-oblique-decagonal",
       20, 30, 12,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Regular de Base Hendecagonal",
         "Regular with Hendecagonal Base",
			"Pravilna, ki ima za osnovno ploskev enajstkotnik"},
        "off",
        "prisms-regular-hendecagonal",
       22, 33, 13,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Reto de Base Hendecagonal",
         "Right with Hendecagonal Base",
			"Pokonna, ki ima za osnovno ploskev enajstkotnik"},
        "off",
        "prisms-right-hendecagonal",
       22, 33, 13,
        true, true, true,
        true,
        true));
i++;       

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Oblquo de Base Hendecagonal",
         "Oblique with Hendecagonal Base",
			"Poevna, ki ima za osnovno ploskev enajstkotnik"},
        "off",
        "prisms-oblique-hendecagonal",
       22, 33, 13,
        true, true, true,
        true,
        true));
i++;       

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Regular de Base Dodecagonal",
         "Regular with Dodecagonal Base",
			"Pravilna, ki ima za osnovno ploskev dvanajstkotnik"},
        "off",
        "prisms-regular-dodecagonal",
       24, 36, 14,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Reto de Base Dodecagonal",
         "Right with Dodecagonal Base",
			"Pokonna, ki ima za osnovno ploskev dvanajstkotnik"},
        "off",
        "prisms-right-dodecagonal",
       24, 36, 14,
        true, true, true,
        true,
        true));
i++;

prisms.addModel(i, new Model(prisms_trans,
        new String[]
        {"Oblquo de Base Dodecagonal",
         "Oblique with Dodecagonal Base",
			"Poevna, ki ima za osnovno ploskev dvanajstkotnik"},
        "off",
        "prisms-oblique-dodecagonal",
       24, 36, 14,
        true, true, true,
        true,
        true));
i++;       
       

// ANTIPRISMS
i = 0;
antiprisms = new Category(antiprisms_trans, 10);

antiprisms.addModel(i, new Model(antiprisms_trans,
       new String[]
       {"Regular de Base Triangular",
        "Regular with Triangular Base", 
		   "Pravilna, ki ima za osnovno ploskev trikotnik"},
       "off",
       "antiprisms-regular-octahedron",
       6, 12, 8,
       true, true, true,
       true,
       true));
i++;      

antiprisms.addModel(i, new Model(antiprisms_trans,
       new String[]
       {"Regular de Base Quadrangular",
        "Regular with Quadrangular Base",
		   "Pravilna, ki ima za osnovno ploskev tirikotnik"},
       "off",
       "antiprisms-regular-quadrangular",
       8, 16, 10,
       true, true, true,
       true,
       true));
i++;

antiprisms.addModel(i, new Model(antiprisms_trans,
       new String[]
       {"Regular de Base Pentagonal",
        "Regular with Pentagonal Base",
		   "Pravilna, ki ima za osnovno ploskev petkotnik"},
       "off",
       "antiprisms-regular-pentagonal",
       10, 20, 12,
       true, true, true,
       true,
       true));
i++;

antiprisms.addModel(i, new Model(antiprisms_trans,
       new String[]
       {"Regular de Base Hexagonal",
        "Regular with Hexagonal Base",
		   "Pravilna, ki ima za osnovno ploskev estkotnik"},
       "off",
       "antiprisms-regular-hexagonal",
       12, 24, 14,
       true, true, true,
       true,
       true));
i++;

antiprisms.addModel(i, new Model(antiprisms_trans,
       new String[]
       {"Regular de Base Heptagonal",
        "Regular with Heptagonal Base",
		   "Pravilna, ki ima za osnovno ploskev sedemkotnik"},
       "off",
       "antiprisms-regular-heptagonal",
       14, 28, 16,
       true, true, true,
       true,
       true));
i++;

antiprisms.addModel(i, new Model(antiprisms_trans,
       new String[]
       {"Regular de Base Octagonal",
        "Regular with Octagonal Base",
		   "Pravilna, ki ima za osnovno ploskev osemkotnik"},
       "off",
       "antiprisms-regular-octagonal",
       16, 32, 18,
       true, true, true,
       true,
       true));
i++;

antiprisms.addModel(i, new Model(antiprisms_trans,
       new String[]
       {"Regular de Base Eneagonal",
        "Regular with Enneagonal Base",
		   "Pravilna, ki ima za osnovno ploskev devetkotnik"},
       "off",
       "antiprisms-regular-enneagonal",
       18, 36, 20,
       true, true, true,
       true,
       true));
i++;      

antiprisms.addModel(i, new Model(antiprisms_trans,
       new String[]
       {"Regular de Base Decagonal",
        "Regular with Decagonal Base", 
		   "Pravilna, ki ima za osnovno ploskev desetkotnik"},
       "off",
       "antiprisms-regular-decagonal",
       20, 40, 22,
       true, true, true,
       true,
       true));
i++;

antiprisms.addModel(i, new Model(antiprisms_trans,
       new String[]
       {"Regular de Base Hendecagonal",
        "Regular with Hendecagonal Base", 
		   "Pravilna, ki ima za osnovno ploskev enajstkotnik"},
       "off",
       "antiprisms-regular-hendecagonal",
       22, 44, 24,
       true, true, true,
       true,
       true));
i++;

antiprisms.addModel(i, new Model(antiprisms_trans,
       new String[]
       {"Regular de Base Dodecagonal",
        "Regular with Dodecagonal Base", 
		   "Pravilna, ki ima za osnovno ploskev dvanajstkotnik"},
       "off",
       "antiprisms-regular-dodecagonal",
       24, 48, 26,
       true, true, true,
       true,
       true));
i++;      

// PYRAMIDS
i = 0;
pyramids = new Category(pyramids_trans, 30);

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Regular de Base Triangular",
        "Regular with Triangular Base", 
		   "Pravilna, ki ima za osnovno ploskev trikotnik"},
       "off",
       "pyramids-regular-triangular",
       4, 6, 4,
       true, true, true,
       true,
       true));
i++;

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Reta de Base Triangular",
        "Right with Triangular Base",
		   "Pokonna, ki ima za osnovno ploskev trikotnik"},
       "off",
       "pyramids-right-triangular",
       4, 6, 4,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Oblqua de Base Triangular",
        "Oblique with Triangular Base",
		   "Poevna, ki ima za osnovno ploskev trikotnik"},
       "off",
       "pyramids-oblique-triangular",
       4, 6, 4,
       true, true, true,
       true,
       true));
i++;
     
pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Regular de Base Quadrangular",
        "Regular with Quadrangular Base",
		   "Pravilna, ki ima za osnovno ploskev tirikotnik"},
       "off",
       "pyramids-regular-quadrangular",
       5, 8, 5,
       true, true, true,
       true,
       true));
i++;

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Reta de Base Quadrangular",
        "Right with Quadrangular Base",
		   "Pokonna, ki ima za osnovno ploskev tirikotnik"},
       "off",
       "pyramids-right-quadrangular",
       5, 8, 5,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Oblqua de Base Quadrangular",
        "Oblique with Quadrangular Base",
		   "Poevna, ki ima za osnovno ploskev tirikotnik"},
       "off",
       "pyramids-oblique-quadrangular",
       5, 8, 5,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Regular de Base Pentagonal",
        "Regular with Pentagonal Base",
		   "Pravilna, ki ima za osnovno ploskev petkotnik"},
       "off",
       "pyramids-regular-pentagonal",
       6, 10, 6,
       true, true, true,
       true,
       true));
i++;

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Reta de Base Pentagonal",
        "Right with Pentagonal Base",
		   "Pokonna, ki ima za osnovno ploskev petkotnik"},
       "off",
       "pyramids-right-pentagonal",
       6, 10, 6,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Oblqua de Base Pentagonal",
        "Oblique with Pentagonal Base",
		   "Poevna, ki ima za osnovno ploskev petkotnik"},
       "off",
       "pyramids-oblique-pentagonal",
       6, 10, 6,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Regular de Base Hexagonal",
        "Regular with Hexagonal Base",
		   "Pravilna, ki ima za osnovno ploskev estkotnik"},
       "off",
       "pyramids-regular-hexagonal",
       7, 12, 7,
       true, true, true,
       true,
       true));
i++;

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Reta de Base Hexagonal",
        "Right with Hexagonal Base",
		   "Pokonna, ki ima za osnovno ploskev estkotnik"},
       "off",
       "pyramids-right-hexagonal",
       7, 12, 7,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Oblqua de Base Hexagonal",
        "Oblique with Hexagonal Base",
		   "Poevna, ki ima za osnovno ploskev estkotnik"},
       "off",
       "pyramids-oblique-hexagonal",
       7, 12, 7,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Regular de Base Heptagonal",
        "Regular with Heptagonal Base",
		   "Pravilna, ki ima za osnovno ploskev sedemkotnik"},
       "off",
       "pyramids-regular-heptagonal",
       8, 14, 8,
       true, true, true,
       true,
       true));
i++;

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Reta de Base Heptagonal",
        "Right with Heptagonal Base",
		   "Pokonna, ki ima za osnovno ploskev sedemkotnik"},
       "off",
       "pyramids-right-heptagonal",
       8, 14, 8,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Oblqua de Base Heptagonal",
        "Oblique with Heptagonal Base",
		   "Poevna, ki ima za osnovno ploskev sedemkotnik"},
       "off",
       "pyramids-oblique-heptagonal",
       8, 14, 8,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Regular de Base Octagonal",
        "Regular with Octagonal Base",
		   "Pravilna, ki ima za osnovno ploskev osemkotnik"},
       "off",
       "pyramids-regular-octagonal",
       9, 16, 9,
       true, true, true,
       true,
       true));
i++;

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Reta de Base Octagonal",
        "Right with Octagonal Base",
		   "Pokonna, ki ima za osnovno ploskev osemkotnik"},
       "off",
       "pyramids-right-octagonal",
       9, 16, 9,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Oblqua de Base Octagonal",
        "Oblique with Octagonal Base",
		   "Poevna, ki ima za osnovno ploskev osemkotnik"},
       "off",
       "pyramids-oblique-octagonal",
       9, 16, 9,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Regular de Base Eneagonal",
        "Regular with Enneagonal Base",
		   "Pravilna, ki ima za osnovno ploskev devetkotnik"},
       "off",
       "pyramids-regular-enneagonal",
       10, 18, 10,
       true, true, true,
       true,
       true));
i++;

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Reta de Base Eneagonal",
        "Right with Enneagonal Base",
		   "Pokonna, ki ima za osnovno ploskev devetkotnik"},
       "off",
       "pyramids-regular-enneagonal",
       10, 18, 10,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Oblqua de Base Eneagonal",
        "Oblique with Enneagonal Base",
		   "Poevna, ki ima za osnovno ploskev devetkotnik"},
       "off",
       "pyramids-oblique-enneagonal",
       10, 18, 10,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Regular de Base Decagonal",
        "Regular with Decagonal Base",
		   "Pravilna, ki ima za osnovno ploskev desetkotnik"},
       "off",
       "pyramids-regular-decagonal",
       11, 20, 11,
       true, true, true,
       true,
       true));
i++;

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Reta de Base Decagonal",
        "Right with Decagonal Base",
		   "Pokonna, ki ima za osnovno ploskev desetkotnik"},
       "off",
       "pyramids-right-decagonal",
       11, 20, 11,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Oblqua de Base Decagonal",
        "Oblique with Decagonal Base",
		   "Poevna, ki ima za osnovno ploskev desetkotnik"},
       "off",
       "pyramids-oblique-decagonal",
       11, 20, 11,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Regular de Base Hendecagonal",
        "Regular with Hendecagonal Base",
		   "Pravilna, ki ima za osnovno ploskev enajstkotnik"},
       "off",
       "pyramids-regular-hendecagonal",
       12, 22, 12,
       true, true, true,
       true,
       true));
i++;

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Reta de Base Hendecagonal",
        "Right with Hendecagonal Base",
		   "Pokonna, ki ima za osnovno ploskev enajstkotnik"},
       "off",
       "pyramids-right-hendecagonal",
       12, 22, 12,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Oblqua de Base Hendecagonal",
        "Oblique with Hendecagonal Base",
		   "Poevna, ki ima za osnovno ploskev enajstkotnik"},
       "off",
       "pyramids-oblique-hendecagonal",
       12, 22, 12,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Regular de Base Dodecagonal",
        "Regular with Dodecagonal Base",
		   "Pravilna, ki ima za osnovno ploskev dvanajstkotnik"},
       "off",
       "pyramids-regular-dodecagonal",
       13, 24, 13,
       true, true, true,
       true,
       true));
i++;

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Reta de Base Dodecagonal",
        "Right with Dodecagonal Base",
		   "Pokonna, ki ima za osnovno ploskev dvanajstkotnik"},
       "off",
       "pyramids-right-dodecagonal",
       13, 24, 13,
       true, true, true,
       true,
       true));
i++;      

pyramids.addModel(i, new Model(pyramids_trans,
       new String[]
       {"Oblqua de Base Dodecagonal",
        "Oblique with Dodecagonal Base",
		   "Poevna, ki ima za osnovno ploskev dvanajstkotnik"},
       "off",
       "pyramids-oblique-dodecagonal",
       13, 24, 13,
       true, true, true,
       true,
       true));
i++;      
          
/*
// NONREGULAR
i = 0;
nonregular = new Category(nonregular_trans, 10);

nonregular.addModel(i, new Model(nonregular_trans,
       new String[]
       {"Prisma Reto de Base Triangular",
        "NonRegular Triangular Right Prism",
		   "Nepravilna tristrana pokonna prizma"},
       "off",
       "non-regular-triangular-right-prism",
       6, 9, 5,
       true, true, true,
       true,
       true));
i++;      

nonregular.addModel(i, new Model(nonregular_trans,
       new String[]
       {"Prisma Oblquo de Base Triangular",
        "NonRegular Triangular Oblique Prism",
		   "Nepravilna trikotna poevna prizma"},
       "off",
       "non-regular-triangular-oblique-prism",
       6, 9, 5,
       true, true, true,
       true,
       true));
i++;

nonregular.addModel(i, new Model(nonregular_trans,
       new String[]
       {"Prisma Reto de Base Quadrada",
        "NonRegular Right Square Prism",
		   "Nepravilna tirikotna pokonna prizma"},
       "off",
       "non-regular-right-square-prism",
       8, 12, 6,
       true, true, true,
       true,
       true));
i++;

nonregular.addModel(i, new Model(nonregular_trans,
       new String[]
       {"Prisma Oblquo de Base Quadrada",
        "NonRegular Oblique Square Prism",
		   "Nepravilna tirikotna poevna prizma"},
       "off",
       "non-regular-oblique-square-prism",
       8, 12, 6,
       true, true, true,
       true,
       true));
i++;

nonregular.addModel(i, new Model(nonregular_trans,
       new String[]
       {"Pirmide Oblqua de Base Quadrada",
        "NonRegular Oblique Square Pyramid",
		   "Nepravilni tirikotna pokonna piramida"},
       "off",
       "non-regular-oblique-square-pyramid",
       5, 8, 5,
       true, true, true,
       true,
       true));
i++;

nonregular.addModel(i, new Model(nonregular_trans,
       new String[]
       {"Romboedro Oblquo",
        "NonRegular Oblique Rhombohedron",
		   "Nepravilni poevni romboeder"},
       "off",
       "non-regular-oblique-rhombohedron",
       8, 12, 6,
       true, true, true,
       true,
       true));
i++;

nonregular.addModel(i, new Model(nonregular_trans,
       new String[]
       {"Paraleleppedo Reto Retngulo",
        "NonRegular Right Rectangle Parallelepiped",
		   "Nepravilni pokonni kvader",
		   },
       "off",
       "non-regular-right-rectangle-parallelepiped",
       8, 12, 6,
       true, true, true,
       true,
       true));
i++;

nonregular.addModel(i, new Model(nonregular_trans,
       new String[]
       {"Paraleleppedo Oblquo",
        "NonRegular Oblique Parallelepiped", 
		   "Nepravilni poevni paralelepiped" },
       "off",
       "non-regular-oblique-parallelepiped",
       8, 12, 6,
       true, true, true,
       true,
       true));
i++;

nonregular.addModel(i, new Model(nonregular_trans,
       new String[]
       {"Paraleleppedo Reto",
        "NonRegular Right Parallelepiped",
		   "Nepravilen pokonni paralelepiped"},
       "off",
       "non-regular-right-parallelepiped",
       8, 12, 6,
       true, true, true,
       true,
       true));
i++;

nonregular.addModel(i, new Model(nonregular_trans,
       new String[]
       {"Pirmide No-Regular",
        "NonRegular Pyramid",
		   "Nepravilna piramida"},
       "off",
       "non-regular-pyramid",
       5, 8, 5,
       true, true, true,
       true,
       true));
i++;
*/
 
// TOROIDS
i = 0;
toroids = new Category(toroids_trans, 44);

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Toride com 1 Buraco Triangular",
        "Toroid with 1 Triangular Hole",
		   "Torus z eno trikotno luknjo"},
       "off",
       "toroid-triangular-genus-01",
       9, 18, 9,
       true, true, true,
       false,
       true));
i++;

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Toride com 1 Buraco Quadrado",
        "Toroid with 1 Square Hole",
		   "Torus z eno tirikotno luknjo"},
       "off",
       "toroid-quadrangular-genus-01",
       12, 24, 12,
       true, true, true,
       false,
       true));
i++;

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Toride com 1 Buraco Pentagonal",
        "Toroid with 1 Pentagonal Hole",
		   "Torus z eno petkotno luknjo"},
       "off",
       "toroid-pentagonal-genus-01",
       15, 30, 15,
       true, true, true,
       false,
       true));
i++;

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Toride com 1 Buraco Hexagonal",
        "Toroid with 1 Hexagonal Hole",
		   "Torus z eno estkotno luknjo"},
       "off",
       "toroid-hexagonal-genus-01",
       18, 36, 18,
       true, true, true,
       false,
       true));
i++;

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Toride com 1 Buraco Heptagonal",
        "Toroid with 1 Heptagonal Hole",
		   "Torus z eno sedemkotno luknjo"},
       "off",
       "toroid-heptagonal-genus-01",
       21, 42, 21,
       true, true, true,
       false,
       true));
i++;      
     
toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Toride com 2 Buraco Triangulares",
        "Toroid with 2 Triangular Holes",
		   "Torus z dvema trikotnima luknjama"},
       "off",
       "toroid-triangular-genus-02",
       14, 32, 16,
       true, true, true,
       false,
       true));
i++;            

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Toride com 2 Buracos Quadrados",
        "Toroid with 2 Square Holes",
		   "Torus z dvema tirikotnima luknjama"},
       "off",
       "toroid-quadrangular-genus-02",
       20, 44, 22,
       true, true, true,
       false,
       true));
i++;      

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Toride com 3 Buracos Quadrados",
        "Toroid with 3 Square Holes",
		   "Torus z tremi tirikotnimi luknjami"},
       "off",
       "toroid-quadrangular-genus-03",
       28, 64, 32,
       true, true, true,
       false,
       true));
i++;            

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Toride com 4 Buracos Quadrados",
        "Toroid with 4 Square Holes",
		   "Torus z tirimi tirikotnimi luknjami"},
       "off",
       "toroid-quadrangular-genus-04",
       36, 84, 42,
       true, true, true,
       false,
       true));
i++;      

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Toride com 5 Buracos Quadrados",
        "Toroid with 5 Square Holes",
		   "Torus z petimi tirikotnimi luknjami"},
       "off",
       "toroid-quadrangular-genus-05",
       44, 104, 52,
       true, true, true,
       false,
       true));
i++;      

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Toride com 6 Buracos Quadrados",
        "Toroid with 6 Square Holes",
		   "Torus z estimi tirikotnimi luknjami"},
       "off",
       "toroid-quadrangular-genus-06",
       52, 124, 62,
       true, true, true,
       false,
       true));
i++;

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Toride com 7 Buracos Quadrados",
        "Toroid with 7 Square Holes",
		   "Torus z sedmimi tirikotnimi luknjami"},
       "off",
       "toroid-quadrangular-genus-07",
       60, 144, 72,
       true, true, true,
       false,
       true));
i++;

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Poliedro com 1 Ala",
        "Polyhedron with 1 Handle",
		   "Polieder z 1 roko"},
       "off",
       "toroid-handle-genus-01",
       48, 78, 30,
       true, true, true,
       false,
       true));
i++;                  

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Poliedro com 2 Alas",
        "Polyhedron with 2 Handles",
		   "Polieder z 2 rokama"},
       "off",
       "toroid-handle-genus-02",
       54, 93, 37,
       true, true, true,
       false,
       true));
i++;      

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Poliedro com 3 Alas",
        "Polyhedron with 3 Handles",
		   "Polieder s 3 rokami"},
       "off",
       "toroid-handle-genus-03",
       60, 108, 44,
       true, true, true,
       false,
       true));
i++;

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Poliedro com 4 Alas",
        "Polyhedron with 4 Handles",
		   "Polieder s 4 rokami"},
       "off",
       "toroid-handle-genus-04",
       66, 123, 51,
       true, true, true,
       false,
       true));
i++;

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Poliedro com 5 Alas",
        "Polyhedron with 5 Handles",
		   "Polieder s 5 rokami"},
       "off",
       "toroid-handle-genus-05",
       72, 138, 58,
       true, true, true,
       false,
       true));
i++;      

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Poliedro com 6 Alas",
        "Polyhedron with 6 Handles",
		   "Polieder s 6 rokami"},
       "off",
       "toroid-handle-genus-06",
       78, 153, 65,
       true, true, true,
       false,
       true));
i++;      

toroids.addModel(i, new Model(toroids_trans,
       new String[]
       {"Poliedro com 7 Alas",
        "Polyhedron with 7 Handles",
		   "Polieder s 7 rokami"},
       "off",
       "toroid-handle-genus-07",
       84, 168, 72,
       true, true, true,
       false,
       true));
i++;      

// STEWART
//  i = 0;
//  stewart = new Category(stewart_trans, 25);
 
toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Cpula Triangular Perfurada Alongada",
          "Drilled Elongated Triangular Cupola",
			 "Drilled Elongated Triangular Cupola"},
         "off",
         "stewart-drilled-elongated-triangular-cupola",
       18, 39, 21,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Bicpula Triangular Perfurada",
          "Drilled Triangular Bicupola",
			 "Drilled Triangular Bicupola"},
         "off",
         "stewart-drilled-triangular-bicupola",
       15, 39, 24,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Cubo Truncado Perfurado",
          "Drilled Truncated Cube",
			 "Drilled Truncated Cube"},
         "off",
         "stewart-drilled-truncated-cube",
       32, 64, 32,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Bicpula Quadrada Perfurada",
          "Drilled Square Bicupola",
			 "Drilled Square Bicupola"},
         "off",
         "stewart-drilled-square-bicupola",
       20, 48, 28,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Octaedro Truncado Perfurado",
          "Single-drilled Truncated Octahedron",
			 "Single-drilled Truncated Octahedron"},
         "off",
         "stewart-single-drilled-truncated-octahedron",
       30, 54, 24,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Rotunda Pentagonal Perfurada",
          "Drilled Pentagonal Rotunda",
			 "Drilled Pentagonal Rotunda"},
         "off",
         "stewart-drilled-pentagonal-rotunda",
       25, 60, 35,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Cubo Truncado Biaumentado Perfurado",
          "Drilled Biaugmented Truncated Cube",
			 "Drilled Biaugmented Truncated Cube"},
         "off",
         "stewart-drilled-biaugmented-truncated-cube",
       48, 104, 56,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Octaedro Truncado Tetra Perfurado",
          "Four-Drilled Truncated Octahedron",
			 "Four-Drilled Truncated Octahedron"},
         "off",
         "stewart-four-drilled-truncated-octahedron",
         30, 72, 38,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Anel Octadrico com 8 Elos",
          "Eight-Octahedron Ring",
			 "Eight-Octahedron Ring"},
         "off",
         "stewart-eight-octahedron-ring",
       24, 72, 48,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Cuboctaedro Truncado Quadrado-Perfurado",
          "Square-Drilled Truncated Cuboctahedron",
			 "Square-Drilled Truncated Cuboctahedron"},
         "off",
         "stewart-square-drilled-truncated-cuboctahedron",
       72, 168, 76,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Cuboctaedro Truncado Hexgono-Perfurado",
          "Hexagon-Drilled Truncated Cuboctahedron",
			 "Hexagon-Drilled Truncated Cuboctahedron"},
         "off",
         "stewart-hexagon-drilled-truncated-cuboctahedron",
       72, 168, 84,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Cuboctaedro Truncado Octgono-Perfurado",
          "Octagon-Drilled Truncated Cuboctahedron",
			 "Octagon-Drilled Truncated Cuboctahedron"},
         "off",
         "stewart-octagon-drilled-truncated-cuboctahedron",
       72, 168, 88,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Cuboctaedro Truncado Tetra-Quadrado-Perfurado",
          "Four-Square-Drilled Truncated Cuboctahedron",
			 "Four-Square-Drilled Truncated Cuboctahedron"},
         "off",
         "stewart-four-square-drilled-truncated-cuboctahedron",
       72, 136, 60,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Cuboctaedro Truncado Biquadrado-Perfurado",
          "Two-Square-Double-Drilled Truncated Cuboctahedron",
			 "Two-Square-Double-Drilled Truncated Cuboctahedron"},
         "off",
         "stewart-two-square-double-drilled-truncated-cuboctahedron",
       72, 132, 58,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Cuboctaedro Truncado com Dois Buracos Perfurados",
          "Two-Hole Drilled Truncated Cuboctahedron",
			 "Two-Hole Drilled Truncated Cuboctahedron"},
         "off",
         "stewart-two-hole-drilled-truncated-cuboctahedron",
       72, 144, 62,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Cuboctaedro Truncado Duplamente Perfurado",
          "Double Drilled Truncated Cuboctahedron",
			 "Double Drilled Truncated Cuboctahedron"},
         "off",
         "stewart-double-drilled-truncated-cuboctahedron",
       80, 192, 90,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Variao do Cuboctaedro Truncado Perfurado",
          "Drilled Truncated Cuboctahedron Variation",
			 "Drilled Truncated Cuboctahedron Variation"},
         "off",
         "stewart-drilled-truncated-cuboctahedron-variation",
       60, 128, 68,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Cuboctaedro Dissecado por Expanso em Prisma",
          "Prism-Expanded Dissected Cuboctahedron",
			 "Prism-Expanded Dissected Cuboctahedron"},
         "off",
         "stewart-prism-expanded-dissected-cuboctahedron",
       62, 168, 86,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Rombicosidodecaedro Perfurado",
          "Drilled Rhombicosidodecaedro",
			 "Drilled Rhombicosidodecaedro"},
         "off",
         "stewart-drilled-rhombicosidodecahedron",
       80, 168, 80,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Dodecaedro Truncado Perfurado",
          "Drilled Truncated Dodecahedron",
			 "Drilled Truncated Dodecahedron"},
         "off",
         "stewart-drilled-truncated-dodecahedron",
       140, 420, 260,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Dodecaedro Truncado Parcialmente Perfurado",
          "Partially Drilled Truncated Dodecahedron",
			 "Partially Drilled Truncated Dodecahedron"},
         "off",
         "stewart-partially-drilled-truncated-dodecahedron",
       115, 290, 165,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Toro Cortado",
          "Torus Slice",
			 "Torus Slice"},
         "off",
         "stewart-torus-slice",
         50, 120, 70,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Icosidodecaedro Truncado Rotunda-Perfurado",
          "Rotunda-Drilled Truncated Icosidodecahedron",
			 "Rotunda-Drilled Truncated Icosidodecahedron"},
         "off",
         "stewart-rotunda-drilled-truncated-icosidodecahedron",
       240, 540, 280,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Icosidodecaedro Truncado Cpula-Perfurado",
          "Cupola-Drilled Truncated Icosidodecahedron",
			 "Cupola-Drilled Truncated Icosidodecahedron"},
         "off",
         "stewart-cupola-drilled-truncated-icosidodecahedron",
       240, 600, 340,
         true, true, true,
         false,
         true));
 i++;

 toroids.addModel(i, new Model(toroids_trans,
         new String[]
         {"Gnero 87",
          "Genus 87",
			 "Genus 87"},
         "off",
         "stewart-genus-87-new-record",
       1238, 3708, 2298,
         true, true, true,
         false,
         true));
 i++;

 // LEONARDO
 i = 0;
 leonardo = new Category(leonardo_trans, 5);

 leonardo.addModel(i, new Model(leonardo_trans,
         new String[]
         {"Cosmograma 1",
          "Cosmogram 1",
			 "Kozmogram 1"},
         "off",
         "leonardo-cosmogram-1",
         280, 720, 360,
         false, true, true,
         false,
         true));
 leonardo.getModel(i).setImproveUnfolding(true, 6);
 i++;

 leonardo.addModel(i, new Model(leonardo_trans,
         new String[]
         {"Cosmograma 2",
          "Cosmogram 2",
			 "Kozmogram 2"},
         "off",
         "leonardo-cosmogram-2",
         280, 720, 360,
         false, true, true,
         false,
         true));
 leonardo.getModel(i).setImproveUnfolding(true, 6);
 i++;

 leonardo.addModel(i, new Model(leonardo_trans,
         new String[]
         {"Cosmograma 3",
          "Cosmogram 3",
			 "Kozmogram 3"},
         "off",
         "leonardo-cosmogram-3",
         280, 720, 360,
         false, true, true,
         false,
         true));
 leonardo.getModel(i).setImproveUnfolding(true, 6);
 i++;

 leonardo.addModel(i, new Model(leonardo_trans,
         new String[]
         {"Cosmograma 4",
          "Cosmogram 4",
			 "Kozmogram 4"},
         "off",
         "leonardo-cosmogram-4",
         280, 720, 360,
         false, true, true,
         false,
         true));
 leonardo.getModel(i).setImproveUnfolding(true, 6);
 i++;
 
 leonardo.addModel(i, new Model(leonardo_trans,
         new String[]
         {"Cosmograma 5",
          "Cosmogram 5",
			 "Kozmogram 5"},
         "off",
         "leonardo-cosmogram-5",
         280, 720, 360,
         false, true, true,
         false,
         true));
 leonardo.getModel(i).setImproveUnfolding(true, 6);
 i++;        

 // ANIMAL
 i = 0;
 animal = new Category(animal_trans, 4);

 animal.addModel(i, new Model(animal_trans,
        new String[]
        {"Cavalo",
         "Horse",
			"Konj"},
        "off",
        "animal-horse",
        173, 513, 342,
        true, true, true,
        false,
        true));
 animal.getModel(i).setImproveUnfolding(true, 6);
 i++;

 animal.addModel(i, new Model(animal_trans,
          new String[]
          {"Coelho",
           "Bunny",
			  "Zajec"},
          "off",
          "animal-bunny",
          157, 465, 310,
          true, true, true,
          false,
          true));
 animal.getModel(i).setImproveUnfolding(true, 6);
 i++;

 animal.addModel(i, new Model(animal_trans,
        new String[]
        {"Gatinho",
         "Kitten",
			"Maek"},
        "off",
        "animal-kitten",
        175, 525, 350,
        true, true, true,
        false,
        true));
 animal.getModel(i).setImproveUnfolding(true, 6);
 i++;
   
 animal.addModel(i, new Model(animal_trans,
        new String[]
        {"Dromedrio",
         "Dromedary",
			"Kamela"},
        "off",
         "animal-dromedary",
         443, 1329, 886,
         true, true, true,
         false,
         true));
 animal.getModel(i).setImproveUnfolding(true, 5);
 i++;
 
 
 // HEXAHEDRA
 i = 0;
 hexahedra = new Category(hexahedra_trans, 13);
 
 hexahedra.addModel(i, new Model(hexahedra_trans,
	          new String[]
	          {"Hexaedro 3, 3, 3, 3, 3, 3",
	           "Hexahedron 3, 3, 3, 3, 3, 3",
			   "Heksaeder 3, 3, 3, 3, 3, 3"},
	          "off",
	          "hexahedra-333333",
	          5, 9, 6,
	          true, true, true,
	          true,
	          true));
 i++;
   
 hexahedra.addModel(i, new Model(hexahedra_trans,
             new String[]
             {"Hexaedro 5, 3, 3, 3, 3, 3",
              "Hexahedron 5, 3, 3, 3, 3, 3",
			   "Heksaeder 5, 3, 3, 3, 3, 3"},
              "off",
             "hexahedra-533333",
             6, 10, 6,
             true, true, true,
             true,
             true));
 i++;
 
 hexahedra.addModel(i, new Model(hexahedra_trans,
             new String[]
             {"Hexaedro 4, 4, 3, 3, 3, 3",
              "Hexahedron 4, 4, 3, 3, 3, 3",
			   "Heksaeder 4, 4, 3, 3, 3, 3"},
             "off",
             "hexahedra-443333",
             6, 10, 6,
             true, true, true,
             true,
             true));
 i++;
 
 hexahedra.addModel(i, new Model(hexahedra_trans,
	          new String[]
	          {"Hexaedro 5, 4, 4, 3, 3, 3",
	           "Hexahedron 5, 4, 4, 3, 3, 3",
			   "Heksaeder 5, 4, 4, 3, 3, 3"},
	          "off",
	          "hexahedra-544333",
	          7, 11, 6,
	          true, true, true,
	          true,
	          true));
 i++;        
   
 hexahedra.addModel(i, new Model(hexahedra_trans,
             new String[]
	         {"Hexaedro 4, 4, 4, 4, 3, 3",
	          "Hexahedron 4, 4, 4, 4, 3, 3",
			  "Heksaeder 4, 4, 4, 4, 3, 3"},
	         "off",
	         "hexahedra-444433",
	         7, 11, 6,
	         true, true, true,
	         true,
	         true));
 i++;
 
 hexahedra.addModel(i, new Model(hexahedra_trans,
            new String[]
             {"Hexaedro 5, 5, 4, 4, 3, 3",
              "Hexahedron 5, 5, 4, 4, 3, 3",
			  "Heksaeder 5, 5, 4, 4, 3, 3"},
              "off",
             "hexahedra-554433",
             8, 12, 6,
             true, true, true,
             true,
             true));
 i++;        
 
 hexahedra.addModel(i, new Model(hexahedra_trans,
           new String[]
            {"Hexaedro 4, 4, 4, 4, 4, 4 (Cubo)",
             "Hexahedron 4, 4, 4, 4, 4, 4 (Cube)",
			  "Heksaeder 4, 4, 4, 4, 4, 4 (Kocka)"},
             "off",
            "hexahedra-444444",
            8, 12, 6,
            true, true, true,
            true,
            true));
 i++;        
  
 hexahedra.addModel(i, new Model(hexahedra_trans,
         new String[]
         {"Hexaedro 4, 4, 4, 4, 4, 4 (Prisma Reto de Base Quadrada)",
          "Hexahedron 4, 4, 4, 4, 4, 4 (NonRegular Right Square Prism)",
		   "Heksaeder 4, 4, 4, 4, 4, 4 (Nepravilna pokonna tirikotna prizma)"},
         "off",
         "hexahedra-right-square-prism",
         8, 12, 6,
         true, true, true,
         true,
         true));
 i++;
 
 hexahedra.addModel(i, new Model(hexahedra_trans,
         new String[]
         {"Hexaedro 4, 4, 4, 4, 4, 4 (Prisma Oblquo de Base Quadrada)",
          "Hexahedron 4, 4, 4, 4, 4, 4 (NonRegular Oblique Square Prism)",
		   "Heksaeder 4, 4, 4, 4, 4, 4 (Nepravilna poevna tirikotna prizma)"},
         "off",
         "hexahedra-oblique-square-prism",
         8, 12, 6,
         true, true, true,
         true,
         true));
 i++;        
 
 hexahedra.addModel(i, new Model(hexahedra_trans,
         new String[]
         {"Hexaedro 4, 4, 4, 4, 4, 4 (Romboedro Oblquo)",
          "Hexahedron 4, 4, 4, 4, 4, 4 (NonRegular Oblique Rhombohedron)",
		   "Heksaeder 4, 4, 4, 4, 4, 4 (Nepravilni poevni roboid)"},
         "off",
         "hexahedra-oblique-rhombohedron",
         8, 12, 6,
         true, true, true,
         true,
         true));
 i++;
 
 hexahedra.addModel(i, new Model(hexahedra_trans,
         new String[]
         {"Hexaedro 4, 4, 4, 4, 4, 4 (Paraleleppedo Reto Retngulo)",
          "Hexahedron 4, 4, 4, 4, 4, 4 (NonRegular Right Rectangle Parallelepiped)",
		   "Heksaeder 4, 4, 4, 4, 4, 4 (Nepravilni pokonni kvader)"},
         "off",
         "hexahedra-right-rectangle-parallelepiped",
         8, 12, 6,
         true, true, true,
         true,
         true));
 i++;

 hexahedra.addModel(i, new Model(hexahedra_trans,
         new String[]
         {"Hexaedro 4, 4, 4, 4, 4, 4 (Paraleleppedo Oblquo)",
          "Hexahedron 4, 4, 4, 4, 4, 4 (NonRegular Oblique Parallelepiped)",
		   "Heksaeder 4, 4, 4, 4, 4, 4 (Nepravilna poevni paralelepiped)"},
         "off",
         "hexahedra-oblique-parallelepiped",
         8, 12, 6,
         true, true, true,
         true,
         true));
 i++;
 
 hexahedra.addModel(i, new Model(hexahedra_trans,
         new String[]
         {"Hexaedro 4, 4, 4, 4, 4, 4 (Paraleleppedo Reto)",
          "Hexahedron 4, 4, 4, 4, 4, 4 (NonRegular Right Parallelepiped)",
		   "Heksaeder 4, 4, 4, 4, 4, 4 (Nepravilni pokonni paralelepiped)"},
         "off",
         "hexahedra-right-parallelepiped",
         8, 12, 6,
         true, true, true,
         true,
         true));
 i++;        
 
 
 // ISOHEDRA
 i = 0;
 isohedra = new Category(isohedra_trans, 30);
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
        {"Cubo",
          "Cube",
			 "Kocka"},
         "off",
         "isohedra-cube",
            8, 12, 6,
         true, true, true,
         true,
         true));            
 i++;
  
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Dodecaedro Disdiakis",
          "Disdyakis Dodecahedron",
			 "Disdyakis Dodecahedron"},
         "off",
         "isohedra-disdyakis-dodecahedron",
	        26, 72, 48,
         true, true, true,
         true,
         true));            
 i++;
     
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Hexecontaedro Deltoidal",
          "Deltoidal Hexecontahedron",
			 "Deltoidal Hexecontahedron"},
         "off",
         "isohedra-deltoidal-hexecontahedron",
	        62, 120, 60,
         true, true, true,
         true,
         true));            
 i++;
      
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
        {"Icositetraedro Deltoidal",
         "Deltoidal Icositetrahedron",
			"Deltoidal Icositetrahedron"},
        "off",
        "isohedra-deltoidal-icositetrahedron",
	       26, 48, 24,
        true, true, true,
        true,
        true));            
 i++;
       
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Triacontaedro Disdiakis",
          "Disdyakis Triacontahedron",
			 "Disdyakis Triacontahedron"},
         "off",
         "isohedra-disdyakis-triacontahedron",
	        62, 180, 120,
         true, true, true,
         true,
         true));            
  i++;
        
  isohedra.addModel(i, new Model(isohedra_trans,
          new String[]
          {"Dodecaedro",
           "Dodecahedron",
			  "Dvanajsterec"},
          "off",
          "isohedra-dodecahedron",
          20, 30, 12,
          true, true, true,
          true,
          true));            
 i++;                
    
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Dodecaedro Dyakis",
          "Dyakis Dodecahedron",
			 "Dyakis Dodecahedron"},
         "off",
         "isohedra-dyakis-dodecahedron",
         26, 48, 24,
         true, true, true,
         true,
         true));            
 i++;
          
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Tetraedro Hexakis",
          "Hexakis Tetrahedron",
			 "Hexakis Tetrahedron"},
         "off",
         "isohedra-hexakis-tetrahedron",
         14, 36, 24,
         true, true, true,
         true,
         true));            
 i++;
           
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Icosaedro",
          "Icosahedron",
			 "Dvajseterec"},
         "off",
         "isohedra-icosahedron",
         12, 30, 20,
         true, true, true,
         true,
         true));            
 i++;
            
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Tetraedro Issceles",
          "Isosceles Tetrahedron",
			 "Isosceles Tetrahedron"},
         "off",
         "isohedra-isosceles-tetrahedron",
         4, 6, 4,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Dodecaedro Pentagonal Octaedral",        		
          "Octahedral Pentagonal Dodecahedron",
			 "Octahedral Pentagonal Dodecahedron"},
         "off",
         "isohedra-octahedral-pentagonal-dodecahedron",
         20, 30, 12,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Octaedro",        		
          "Octahedron",
			 "Osmerec"},
         "off",
         "isohedra-octahedron",
         6, 12, 8,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Hexecontaedro Pentagonal",        		
          "Pentagonal Hexecontahedron",
			 "Pentagonal Hexecontahedron"},
         "off",
         "isohedra-pentagonal-hexecontahedron",
         92, 150, 60,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Icositetraedro Pentagonal",        		
          "Pentagonal Icositetrahedron",
			 "Pentagonal Icositetrahedron"},
         "off",
         "isohedra-pentagonal-icositetrahedron",
         38, 60, 24,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Dodecaedro Pentakis",        		
          "Pentakis Dodecahedron",
			 "Pentakis Dodecahedron"},
         "off",
         "isohedra-pentakis-dodecahedron",
         32, 90, 60,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Dodecaedro Rmbico",        		
          "Rhombic Dodecahedron",
			 "Rhombic Dodecahedron"},
         "off",
         "isohedra-rhombic-dodecahedron",
         14, 24, 12,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Triacontaedro Rmbico",        		
          "Rhombic Triacontahedron",
			 "Rhombic Triacontahedron"},
         "off",
         "isohedra-rhombic-triacontahedron",
         32, 60, 30,
         true, true, true,
         true,
         true));            
 i++;     
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Tetraedro Escaleno",        		
          "Scalene Tetrahedron",
			 "Scalene Tetrahedron"},
         "off",
         "isohedra-scalene-tetrahedron",
         4, 6, 4,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Dodecaedro Pentagonal Tetragonal",        		
          "Tetragonal Pentagonal Dodecahedron",
			 "Tetragonal Pentagonal Dodecahedron"},
         "off",
         "isohedra-tetragonal-pentagonal-dodecahedron",
         20, 30, 12,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Tetraedro",        		
          "Tetrahedron",
			 "etverec"},
         "off",
         "isohedra-tetrahedron",
         4, 6, 4,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Hexaedro Tetrakis",        		
          "Tetrakis Hexahedron",
			 "Tetrakis Hexahedron"},
         "off",
         "isohedra-tetrakis-hexahedron",
         14, 36, 24,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Diedro Trapezoidal Bsico",        		
          "Trapezoidal Dihedron (Basic)",
			 "Trapezoidal Dihedron (Basic)"},
         "off",
         "isohedra-trapezoidal-dihedron",
         8, 12, 6,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Diedro Trapezoidal Assimtrico",        		
          "Trapezoidal Dihedron (Skewed)",
			 "Trapezoidal Dihedron (Skewed)"},
         "off",
         "isohedra-trapezoidal-dihedron-skewed",
         8, 12, 6,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Dodecaedro Trapezoidal",        		
          "Trapezoidal Dodecahedron",
			 "Trapezoidal Dodecahedron"},
         "off",
         "isohedra-trapezoidal-dodecahedron",
         14, 24, 12,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Icosaedro Triakis",        		
          "Triakis Icosahedron",
			 "Triakis Icosahedron"},
         "off",
         "isohedra-triakis-icosahedron",
         32, 90, 60,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Octaedro Triakis",        		
          "Triakis Octahedron",
			 "Triakis Octahedron"},
         "off",
         "isohedra-triakis-octahedron",
         14, 36, 24,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Tetraedro Triakis",        		
          "Triakis Tetrahedron",
			 "Triakis Tetrahedron"},
         "off",
         "isohedra-triakis-tetrahedron",
         8, 18, 12,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Diedro Triangular",        		
          "Triangular Dihedron",
			 "Triangular Dihedron"},
         "off",
         "isohedra-triangular-dihedron",
         10, 24, 16,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Diedro Triangular Assimtrico Dentro-Fora",        		
          "Triangular Dihedron Skewed In-Out",
			 "Triangular Dihedron Skewed In-Out"},
         "off",
         "isohedra-triangular-dihedron-skewed-in-out",
         10, 24, 16,
         true, true, true,
         true,
         true));            
 i++;
 
 isohedra.addModel(i, new Model(isohedra_trans,
         new String[]
         {"Diedro Triangular Assimtrico Para Cima-Para Baixo",        		
          "Triangular Dihedron Skewed Up-Down",
			 "Triangular Dihedron Skewed Up-Down"},
         "off",
         "isohedra-triangular-dihedron-skewed-up-down",
         6, 12, 8,
         true, true, true,
         true,
         true));            
 i++;        

    }
}; // End of PjPoly_IP class
